#ifndef GEOMBOX2_H
#define GEOMBOX2_H

#include "GeomPrimitivForm.h"
#include "MagicFMLibType.h"
#include "GeomVector2.h"
#include "GeomRTLib.h"
#include <string>
 using namespace std;

namespace Geom {


  class MAGICFM Box2 :  public PrimitivForm
{
public:
    Box2 ();
	
	string type() {return "Box";}
	
    Vector2& Center ();
    const Vector2& Center () const;

    Vector2& Axis (int i);
    const Vector2& Axis (int i) const;
    Vector2* Axes ();
    const Vector2* Axes () const;

    Real& Extent (int i);
    const Real& Extent (int i) const;
    Real* Extents ();
    const Real* Extents () const;

    void ComputeVertices (Vector2 akVertex[4]) const;

	virtual void Translate(Real _tx, Real _ty)
	  {
		Center().Translate(_tx,_ty);
	  }
	
	virtual void Rotate(Real _cost, Real _sint, Real _centerx, Real _centery)
	  {
		Center().Rotate(_cost,_sint,_centerx,_centery);
		(Axes()[0]).Rotate(_cost,_sint,_centerx,_centery);
		(Axes()[1]).Rotate(_cost,_sint,_centerx,_centery);
	  }
	
	virtual void Rotate(Real _theta, Real _centerx, Real _centery)
	  {
		this->Rotate(cos(_theta),sin(_theta),_centerx,_centery);
	  }
	
	
protected:
    Vector2 m_kCenter;
    Vector2 m_akAxis[2];
    Real m_afExtent[2];
	
};

#include "GeomBox2.inl"

} // namespace Geom

#endif


