
#include "GeomIntervalIntersection.h"
#include "GeomRTLib.h"
using namespace Geom;

//----------------------------------------------------------------------------
void Geom::FindIntersection (Real fU0, Real fU1, Real fV0, Real fV1,
    int& riQuantity, Real& rfW0, Real& rfW1)
{
    assert( fU0 < fU1 && fV0 < fV1 );

    if ( fU1 < fV0 || fU0 > fV1 )
    {
        riQuantity = 0;
    }
    else if ( fU1 > fV0 )
    {
        if ( fU0 < fV1 )
        {
            riQuantity = 2;
            rfW0 = ( fU0 < fV0 ? fV0 : fU0 );
            rfW1 = ( fU1 > fV1 ? fV1 : fU1 );
        }
        else  // fU0 == fV1
        {
            riQuantity = 1;
            rfW0 = fU0;
        }
    }
    else  // fU1 == fV0
    {
        riQuantity = 1;
        rfW0 = fU1;
    }
}
//----------------------------------------------------------------------------
int Geom::FindIntersection (Real fU0, Real fU1, Real& rfV0, Real& rfV1)
{
    assert( fU0 < fU1 && rfV0 < rfV1 );

    if ( fU1 < rfV0 || fU0 > rfV1 )
    {
        return 0;
    }
    else if ( fU1 > rfV0 )
    {
        if ( fU0 < rfV1 )
        {
            if ( fU0 > rfV0 )
                rfV0 = fU0;
            if ( fU1 < rfV1 )
                rfV1 = fU1;
            return 2;
        }
        else  // fU0 == fV1
        {
            rfV0 = fU0;
            return 1;
        }
    }
    else  // fU1 == fV0
    {
        rfV0 = fU1;
        return 1;
    }
}
//----------------------------------------------------------------------------


