
#ifndef GEOMINTERVALINTERSECTION_H
#define GEOMINTERVALINTERSECTION_H

#include "GeomMath.h"

namespace Geom {

// Compute the intersection of [u0,u1] and [v0,v1] where u0 < u1 and
// v0 < v1.  Values of +MAX_REAL or -MAX_REAL are allowed.  The returned
// quantity is
//   0:  no intersection (w[0] and w[1] are invalid)
//   1:  intersection contains one point (w[0] is either u0 or u1)
//   2:  intersection is an interval, [w[0],w[1]]
MAGICFM void FindIntersection (Real fU0, Real fU1, Real fV0, Real fV1,
    int& riQuantity, Real& rfW0, Real& rfW1);

// The intersection is stored in-place (for convenience in calling).
MAGICFM int FindIntersection (Real fU0, Real fU1, Real& rfV0, Real& rfV1);

} // namespace Geom

#endif


