
#ifndef GEOMINTR2DCIRCIR_H
#define GEOMINTR2DCIRCIR_H

#include "GeomArc2.h"
#include "GeomCircle2.h"

// The return value is 'true' if and only if the objects intersect.  The
// returned quantity is usually 0, 1, or 2 and is the number of valid points
// in akPoint[2] (the intersection points).  It is also possible that the
// two objects overlap in infinitely many points.  For the circle-circle case,
// the returned quantity is -1 and the first circle can be used as the
// intersection set.  The akPoint[] values are invalid.  For the circle-arc
// case, the returned quantity is -1 and the arc can be used as the
// intersection set.  The akPoint[] values are invalid.  For the arc-arc case,
// the returned quantity is
//    0: arcs do not overlap
//   -1: arcs just touch at a single point, akPoint[0]
//   -2: arcs overlap on an arc, <akPoint[0],akPoint[1]>
// The application must look at the sign of riQuantity when the function
// returns 'true' to trap these cases.

namespace Geom {

MAGICFM bool FindIntersection (const Circle2& _Circle0,
    const Circle2& _Circle1, int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Circle2& _Circle, const Arc2& _Arc,
    int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Arc2& _Arc0, const Arc2& _Arc1,
    int& riQuantity, Vector2 akPoint[2]);

} // namespace Geom

#endif


