#include "GeomIntr2DLinBox.h"
//#include <iostream>
using namespace Geom;


bool Geom::TestIntersection(const Box2& _Box, const Line2& _Line)
{
  Vector2 Vertex[4];
  _Box.ComputeVertices(Vertex);

  Segment2* Seg[4];
  int control,i;
  Real w[2];
  
  for(i=0;i<4;i++)
	{
	  Seg[i]=new Segment2;
	}
  
  for (i=0;i<4;i++)
	{
	  Seg[i]->Origin()=Vertex[i];
	  Seg[i]->Direction()=Vertex[(i+1)%4]-Vertex[i];

	  if (FindIntersection(_Line,*Seg[i],control,w))
		{
		  return true;
		}
	}
  
  for(i=0;i<4;i++)
	{
	  delete(Seg[i]);
	}
return false;  
}

//---------------------------------------------------------------------

bool Geom::TestIntersection(const Box2& _Box, const Ray2& _Ray)
{
  Vector2 Vertex[4];
  _Box.ComputeVertices(Vertex);

  Segment2* Seg[4];
  
  int control,i;
  Real w[2];

  for(i=0;i<4;i++)
	{
	  Seg[i]=new Segment2;
	}
  
  for (i=0;i<4;i++)
	{
	  Seg[i]->Origin()=Vertex[i];
	  Seg[i]->Direction()=Vertex[(i+1)%4]-Vertex[i];

	  if (FindIntersection(_Ray,*Seg[i],control,w))
		{
		  return true;
		}
	}
  
  for(i=0;i<4;i++)
	{
	  delete(Seg[i]);
	}
  
return false;  
}

//---------------------------------------------------------------------

bool Geom::TestIntersection(const Box2& _Box, const Segment2& _Segment)
{
  Vector2 Vertex[4];
  _Box.ComputeVertices(Vertex);

  Segment2* Seg[4];
  int control,i;
  Real w[2];

  
  for(i=0;i<4;i++)
	{
	  Seg[i]=new Segment2;
	}
  
  
  for (i=0;i<4;i++)
	{
	  Seg[i]->Origin()=Vertex[i];
	  
	  Seg[i]->Direction()=Vertex[(i+1)%4]-Vertex[i];
	  
	  if (FindIntersection(_Segment,*Seg[i],control,w))
		{
		  return true;
		}
	  
	}
  
  for(i=0;i<4;i++)
	{
	  delete(Seg[i]);
	}
  
return false;  
}
//----------------------------------------------------------------------

bool Geom::FindIntersection(const Box2& _Box, const Segment2& _Segment,int& nb_intersec,Vector2 intersec[4])
{
  nb_intersec=0;
  
  Vector2 Vertex[4];
  _Box.ComputeVertices(Vertex);

  
  Segment2 Seg[4];
  int control,i;
  Real w[2];
  
  //for(i=0;i<4;i++)
  //	{
  //	  Seg[i]=new Segment2;
  //	}
  
  for (i=0;i<4;i++)
	{
	  Seg[i].Origin()=Vertex[i];
	  Seg[i].Direction()=Vertex[(i+1)%4]-Vertex[i];
	  
	  if (FindIntersection(_Segment,Seg[i],control,w))
		{
		  
		  if (control==1) {

			(intersec[nb_intersec])=_Segment.Origin()+w[0]*_Segment.Direction();
			nb_intersec++;
		  }
		  
		  if (control==2) {

			(intersec[nb_intersec])=(_Segment.Origin()+w[0]*_Segment.Direction());
			nb_intersec++;

			(intersec[nb_intersec])=(_Segment.Origin()+w[1]*_Segment.Direction());
			nb_intersec++;
		  }
		  
		}
	}
  
  //for(i=0;i<4;i++)
  //	{
  //  delete(Seg[i]);
  //	}

return (nb_intersec>0); 
}

