
#ifndef GEOMINTR2DLINLIN_H
#define GEOMINTR2DLINLIN_H

#include "GeomLine2.h"
#include "GeomRay2.h"
#include "GeomSegment2.h"

namespace Geom {

// The return value is 'true' if and only if the objects intersect.  If an
// intersection occurs, the returned values are the parameter values for the
// point(s) of intersection with respect to the first object parameterized
// by P+t*D (t in [-inf,+inf] for line, t in [0,+inf] for ray, t in [0,1]
// for segment).  The returned quantity is 1 or 2.  If 2, then the returned
// values are the end points of an interval of intersection.

MAGICFM bool FindIntersection (const Line2& _Line0, const Line2& _Line1,
    int& riQuantity, Real afT[2]);

MAGICFM bool FindIntersection (const Line2& _Line, const Ray2& _Ray,
    int& riQuantity, Real afT[2]);

MAGICFM bool FindIntersection (const Line2& _Line, const Segment2& _Segment,
    int& riQuantity, Real afT[2]);

MAGICFM bool FindIntersection (const Ray2& _Ray0, const Ray2& _Ray1,
    int& riQuantity, Real afT[2]);

MAGICFM bool FindIntersection (const Ray2& _Ray, const Segment2& _Segment,
    int& riQuantity, Real afT[2]);

MAGICFM bool FindIntersection (const Segment2& _Segment0,
    const Segment2& _Segment1, int& riQuantity, Real afT[2]);

} // namespace Geom

#endif


