
//----------------------------------------------------------------------------
inline Line2::Line2 ()
{
    // no initialization for efficiency
}
//----------------------------------------------------------------------------
inline Line2::Line2 (const Vector2& _V0, const Vector2& _V1,
    bool bParametricForm)
{
    Vector2 kDiff = _V1 - _V0;

    if ( bParametricForm )
    {
        m_kOrigin = _V0;
        m_kDirection = kDiff;
    }
    else
    {
        m_kNormal = (_V1-_V0).Cross();
        m_fConstant = m_kNormal.Dot(_V0);
    }
}
//----------------------------------------------------------------------------
inline Vector2& Line2::Origin ()
{
    return m_kOrigin;
}
//----------------------------------------------------------------------------
inline const Vector2& Line2::Origin () const
{
    return m_kOrigin;
}
//----------------------------------------------------------------------------
inline Vector2& Line2::Direction ()
{
    return m_kDirection;
}
//----------------------------------------------------------------------------
inline const Vector2& Line2::Direction () const
{
    return m_kDirection;
}
//----------------------------------------------------------------------------
inline Vector2& Line2::Normal ()
{
    return m_kNormal;
}
//----------------------------------------------------------------------------
inline const Vector2& Line2::Normal () const
{
    return m_kNormal;
}
//----------------------------------------------------------------------------
inline Real& Line2::Constant ()
{
    return m_fConstant;
}
//----------------------------------------------------------------------------
inline const Real& Line2::Constant () const
{
    return m_fConstant;
}
//----------------------------------------------------------------------------
inline Real Line2::GetPseudodistance (const Vector2& _V) const
{
    return m_kNormal.Dot(_V) - m_fConstant;
}
//----------------------------------------------------------------------------


