#include "GL_3D.h"
#include "world.h"
#include "robot.h"


world world_GL;
GLfloat src_pos[]= { 0.0,10.0,0.0,1.0};
GLint startx,starty,moving,instantInitial,last_display;
//GLdouble thetaOeil=0.0, phiOeil=M_PI/4.0, distOeil=10.0, thetaOeilInit, phiOeilInit, distOeilInit;
//GLdouble oeilx=distOeil*cos(thetaOeil)*cos(phiOeil),oeily=distOeil*sin(thetaOeil)*cos(phiOeil),oeilz=distOeil*sin(phiOeil),visex=0.0,visey=0.0,visez=0.5*0;

GLdouble oeilx=9.0,oeily=0.0,oeilz=5.0,visex=0.0,visey=0.0,visez=0.0;
//extern bool arret_demande; //eoCtrlCContinue.cpp
extern void signal_handler( int sig );

int winIdMain,winIdSensors;

vector<int> win_asked_by_robots;
vector<robot*> owners_of_windows;
//vector<string> name_of_windows;
int current_displaying;

void (* user_key_management) (unsigned char c, int x, int y)=NULL;
void (* user_pre_idle) (void)=NULL;
void (* user_post_idle) (void)=NULL;


void Register_my_keyfunc(void (* func) (unsigned char c, int x, int y) )
{
  user_key_management=func;
}

void Register_my_pre_idle_func(void (* func) (void) )
{
  user_pre_idle=func;
}

void Register_my_post_idle_func(void (* func) (void) )
{
  user_post_idle=func;
}




void Redisplay_all_graphics_windows()
{//Display cams
  for (unsigned i=0;i<(win_asked_by_robots.size());i++)
	{
	  current_displaying=i;
	  glutPostWindowRedisplay(win_asked_by_robots[i]);
	  
	}
  
  //Display sensors value window
  glutPostWindowRedisplay(winIdSensors);
  
  //Display Main graphic window
  glutPostWindowRedisplay(winIdMain);
  
  
}



/*********************************************************/
/* fonction de dessin de la scne  l'cran           */
 void drawFunc(void)
{ /* initialisation des buffers : couleur et ZBuffer */
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  /* modification de la matrice de la scne */
  glMatrixMode(GL_MODELVIEW);

  glPushMatrix();

  //glLightfv(GL_LIGHT0,GL_POSITION,src_pos);

  /* placement de la scne en fonction de la camra */
  
  if (mode_follow<0)
	{
	  gluLookAt(oeilx,oeily,oeilz,visex,visey,visez,0.0,0.0,1.0);
	  glTranslatef(world_GL.gl_shift_cam_x(),world_GL.gl_shift_cam_y(),0);
	}
  else
	{
	  gluLookAt((world_GL.vector_robot[mode_follow])->centerx/SCALE_GL,
				(world_GL.vector_robot[mode_follow])->centery/SCALE_GL,
				KHEPERA_GL_HEIGHT*2,
				(world_GL.vector_robot[mode_follow])->centerx/SCALE_GL+cos((world_GL.vector_robot[mode_follow])->direction),
				(world_GL.vector_robot[mode_follow])->centery/SCALE_GL+sin((world_GL.vector_robot[mode_follow])->direction),
				0.0,
				0.0,0.0,1.0);
	}

  world_GL.display_3D();
 


  glPopMatrix();
  /* changement de buffer d'affichage */
   
  glutSwapBuffers();
}



/*********************************************************/
/* fonction de changement de dimension de la fenetre     */
/* paramtres :                                          */
/* - width : largeur (x) de la zone de visualisation     */
/* - height : hauteur (y) de la zone de visualisation    */
  void reshapeFunc(int w,int h)
{ GLfloat r=(float)w/(float)h;
 /* dimension de l'cran GL */
 glViewport(0, 0, (GLint)w, (GLint)h);
 /* construction de la matrice de projection */
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 /* dfinition de la camera */
 if (mode_follow<0)
   {
	 gluPerspective(20.0,r,0.1,1000.0 );
   }
 else
   {
	 //gluPerspective(100.0,r,0.1,1000.0 );
	 gluPerspective(20.0,r,0.1,1000.0 );
   }
 
 
 /* initialisation de la matrice de la scne */
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
}


/*********************************************************/
/* fonction associe aux interruptions clavier           */
/* paramtres :                                          */
/* - c : caractre saisi                                 */
/* - x,y : coordonne du curseur dans la fentre         */
 void kbdFunc(unsigned char c, int x, int y)
{ /* sortie du programme si utilisation des touches ESC, */
  /* 'q' ou 'Q'*/
  
  switch(c)
  {
  case 27 : case 'q' : case 'Q' : exit(0); break;
  case 'p' : case 'P' : glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);break;
  case 'f' : case 'F' : glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); break;
  case 's': case 'S' : display_sensor_around=!display_sensor_around; break;
  case 'k': save_display=!save_display; break;
  case 'n' : case 'N' : show_name_robots=!show_name_robots; break;
  case 'v' : case 'V' : display_sensor_value=!display_sensor_value; break;
  case 'a' : case 'A' : display_sensor_window=!display_sensor_window; break;
  case 'z' : case 'Z' : display_graphic_window=!display_graphic_window; break;
  case 32 : freeze=!freeze; break;
  case '+' : cycle_simulation+=0.02; break;
  case '-' : if (cycle_simulation>=0.005) {cycle_simulation-=0.004;} break;
  case 'm' :case 'M' : mode_follow++;
	if (mode_follow>=((int)world_GL.vector_robot.size())) {mode_follow=-1;} break;
  case 't' :case 'T' : take_over++;
	if (take_over>=((int)world_GL.vector_robot.size())) {take_over=-1;} break;	

	// Test theses keys only if user asked the control of a robot
  case '4' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_turn_left();
  } else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '6' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_turn_right();
  } else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '8' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_go_forward();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '2' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_go_back();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '5' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_stop();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '9' :if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_gripper_up();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '7' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_gripper_down();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '0' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_grip();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;
  case '.' : if (take_over>=0) {
	(world_GL.vector_robot[take_over])->decide_to_release();
  }else {if (user_key_management!=NULL) user_key_management(c,x, y);
  }
	break;

  case 'r' :
	if (world_GL.vector_robot.size()>2)
	  {
		printf("More robots than serial ports. Real mode impossible (T'as essay de jouer au plus malin l...).\n");
	  }
	else {
		
	use_real_khepera=!use_real_khepera;
	if (use_real_khepera) {
	  const unsigned buf_size=64;
	  char result[buf_size];
	  int count = 0;
	  vector<robot*>::iterator it1;
	  
	  for (it1=world_GL.vector_robot.begin();it1!=world_GL.vector_robot.end();it1++) 
		{
		  count++;
		  
		  if (count==1) {
			// open the serial communication 
			(*it1)->robot_serial = serial_open(SERIAL_PORT1); 
		  }

		  if (count==2) {
			// open the serial communication 
			(*it1)->robot_serial = serial_open(SERIAL_PORT0); 
		  }

		  if ((*it1)->robot_serial > 0)
			printf("Khepera robot ready to run\n");
		  else
			{
			  if (count==1) 
				printf("unable to open serial port: %s\n",SERIAL_PORT1);
			  else
				printf("unable to open serial port: %s\n",SERIAL_PORT0);
			}
		  
		  
		  // config the serial line Baudrate to 38400 
		  serial_configure((*it1)->robot_serial,38400);

		  // set the PID parameters of the speed controller 
		  khep_talk((*it1)->robot_serial,"A,3800,800,100\n",result,buf_size-1);
		}
	  
	  
	}
	  }
	
	break;
  default:
	if (user_key_management!=NULL) user_key_management(c,x, y);
	
	break;
  }

  makeui_display_according_to_curent_values();

  Redisplay_all_graphics_windows();
  
  glutSetWindow(winIdControl);
  glutPostRedisplay();

  
}

/*********************************************************/
/* fonction associe aux interruptions clavier           */
/* paramtres :                                          */
/* - c : caractre saisi                                 */
/* - x,y : coordonne du curseur dans la fentre         */
  void kbdSpecialFunc(int c, int x, int y)
{
  Real X,Y,Z,L;
  X=oeilx-visex; Y=oeily-visey;  Z=oeilz-visez;
  L=sqrt(X*X+Y*Y+Z*Z);
  X=X/(L*8);
  Y=Y/(L*8);
  Z=Z/(L*8);
  switch (c)
	{
	  /*case GLUT_KEY_UP : phiOeil += 0.1; break;
	  case GLUT_KEY_DOWN : phiOeil -= 0.1; break;
	  case GLUT_KEY_RIGHT : thetaOeil += 0.1; break;
	  case GLUT_KEY_LEFT : thetaOeil -= 0.1; break;
	  */
	case GLUT_KEY_UP :
	  oeilx-=X;
	  oeily-=Y;
	  oeilz-=Z;
	  break;
	case GLUT_KEY_DOWN :
	  oeilx+=X;
	  oeily+=Y;
	  oeilz+=Z;
	  break;
	case GLUT_KEY_RIGHT :
	  oeilx+=-Y;
	  oeily+=X;
	  visex+=-Y;
	  visey+=X;
	  break;
	case GLUT_KEY_LEFT :
	  oeilx-=-Y;
	  oeily-=X;
	  visex-=-Y;
	  visey-=X;
	  break;
	case  GLUT_KEY_PAGE_UP :
	  oeilz+=0.04;
	  visez+=0.04;
	  break;
	case GLUT_KEY_PAGE_DOWN :
	  oeilz-=0.04;
	  visez-=0.04;
	  break;
	}
/*
  polar coords to cartesian
 oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
 oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
 oeilz=distOeil*sin(phiOeil);
*/

  Redisplay_all_graphics_windows();
  
}

/*********************************************************/
/* fonction associe au clique de la souris              */
/* paramtres :                                          */
/* - button : nom du bouton press GLUT_LEFT_BUTTON,     */
/*   GLUT_MIDDLE_BUTTON ou GLUT_RIGHT_BUTTON             */
/* - state : tat du bouton button GLUT_DOWN ou GLUT_UP  */
/* - x,y : coordonne du curseur dans la fentre         */
 void mouseFunc(int button, int state, int x, int y)
{ if (state == GLUT_DOWN)
    { startx = x;
      starty = y;
      moving =1+button;
	  //thetaOeilInit = thetaOeil;
	  //phiOeilInit = phiOeil;
	  //distOeilInit = distOeil;
    }
    if (state == GLUT_UP)
    { moving = 0;
    }
  
}

/*********************************************************/
/* fonction associe au dplacement de la souris bouton  */
/* enfonc.                                              */
/* paramtres :                                          */
/* - x,y : coordonne du curseur dans la fentre         */
 void motionFunc(int x, int y)
{ if (moving==1+GLUT_LEFT_BUTTON)
  { /*thetaOeil = thetaOeilInit - 0.01*(x-startx);
    phiOeil = phiOeilInit + 0.01*(y-starty);
	oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
    oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
    oeilz=distOeil*sin(phiOeil);*/
	Real X,Y,Z,Ax,Ay,D,Zd,P,T;
	X=oeilx-visex; Y=oeily-visey;  Z=oeilz-visez;
	Ax=(x-startx)*0.01;
	Ay=(y-starty)*0.01;
	D=sqrt(X*X+Y*Y+Z*Z);

	//Xd=X/D; Yd=Y/D;
	Zd=Z/D;
	
	P=Math::ASin(Zd);
	T=Math::ATan(Y/X);
	
	if (X<0) {T+=M_PI;}

	T-=Ax;
	P+=Ay;
	//if (P>M_PI/2) {P-=M_PI;}
	
	
	oeilx=D*cos(T)*cos(P)+visex;
    oeily=D*sin(T)*cos(P)+visey;
    oeilz=D*sin(P)+visez;
	
	startx=x;
	starty=y;
	
	
	
    /* demande de redessin de la fentre */
    glutPostRedisplay();
} 
  else if (moving==1+GLUT_RIGHT_BUTTON)
  {/*
	distOeil = distOeilInit+0.01*(y-starty);
    oeilx=distOeil*cos(thetaOeil)*cos(phiOeil);
    oeily=distOeil*sin(thetaOeil)*cos(phiOeil);
    oeilz=distOeil*sin(phiOeil);*/
    /* demande de redessin de la fentre */
    glutPostRedisplay();
  }
} 

/*********************************************************/
/* fonction excute par OpenGL lorsqu'il n'y a pas de   */
/* traitement d'affichage  raliser.                    */
//This fucntion is also used to decide is eo or graphics have to be used
void idleFunc(void)
{
  /*  
  glTranslatef(0,0,0);
  glRotatef(1.0,0.0,1.0,0.0);   
  glutPostRedisplay();
  */
  /*
  bool allow_redisplay;
  allow_redisplay = true;
  
#ifndef DONT_USE_GL

  allow_redisplay=((glutGet(GLUT_ELAPSED_TIME)-last_display)>(1000/FPS));

#endif
  */

  for (int sim=0;sim<SIMULATION_STEPS_BY_PICTURE;sim++) // execute several times theses steps before to ask for redraw
 {
   
  if (!freeze) {

	// Look at the user pre idle func
	if ( user_pre_idle!=NULL)  user_pre_idle();
 
   
	world_GL.evolue();
  
  
	//if (allow_redisplay)
	//  {

	Redisplay_all_graphics_windows(); // Now redisplay
	if (save_display) {save_display_to_disk();} //And save it if needed
		
		//#ifndef DONT_USE_GL
		//last_display=glutGet(GLUT_ELAPSED_TIME);
			  
		//#endif
		
		//  }
	
	// Look at the user post idle func
	if ( user_post_idle!=NULL)  user_post_idle();
 
	
  }
 }
  
}
  

#ifdef ACTIVATE_TEXTURES
//Load a texture
bool LoadTexTiff(char *fichier,int numtex)
{
  unsigned char image[256][256][3];
  uint32 l, h;
  int i,j;
  size_t npixels;
  uint32* raster;
  
  // chargement de l'image TIF 
  TIFF* tif = TIFFOpen(fichier, "r");
  if (tif) {
    TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &l);
    TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &h); 
    npixels = l * h;
    raster = (uint32*) _TIFFmalloc(npixels * sizeof (uint32)); 
    if (raster != NULL) {
      // lecture de l'image 
      if (TIFFReadRGBAImage(tif, l, h, raster, 1)) {
        // transfert de l'image vers le tableau 'image' 
        for (i=0;i<256;i++)
          for (j=0;j<256;j++) {
            image[i][j][0]=((unsigned char *)raster)[i*256*4+j*4+0];
            image[i][j][1]=((unsigned char *)raster)[i*256*4+j*4+1];
            image[i][j][2]=((unsigned char *)raster)[i*256*4+j*4+2];
          }
      }
      else {
        printf("erreur de chargement du fichier %s\n",fichier);
        return 0;
      }
      _TIFFfree(raster); 
    }
    TIFFClose(tif);
    
    //      paramtrage de la texture 
    glBindTexture(GL_TEXTURE_2D,numtex);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
    glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,256,0,
                 GL_RGB,GL_UNSIGNED_BYTE,image);
  }

  return 1;
}
#endif

/*********************************************************/
/* fonction d'initialisation des paramtres de rendu et  */
/* des objets de la scnes.                              */
  void init()
{ 
  // couleur du fond (noir) 
  glClearColor(0.2,0.2,0.2,0.0);

  GLfloat light_ambient[] = { 0.1, 0.1, 0.1, 1.0 };
  GLfloat light_diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
  GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };
  //	light_position is NOT default value	
  GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };
  
  glLightfv (GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv (GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv (GL_LIGHT0, GL_SPECULAR, light_specular);
  glLightfv (GL_LIGHT0, GL_POSITION, light_position);

  
//  GLfloat light_position1[] = { 100/SCALE_GL, 100.0/SCALE_GL, 0.0, 0.0 };
//  GLfloat light_ambient1[] = { 0.1, 0.0, 0.0, 1.0 };
//  GLfloat light_diffuse1[] = { 0.0, 1.0, 0.0, 1.0 };
//  GLfloat light_specular1[] = { 0.0, 1.0, 0.0, 1.0 };
//  glLightfv (GL_LIGHT1, GL_AMBIENT, light_ambient1);
//  glLightfv (GL_LIGHT1, GL_DIFFUSE, light_diffuse1);
//  glLightfv (GL_LIGHT1, GL_SPECULAR, light_specular1);
//  glLightfv (GL_LIGHT1, GL_POSITION, light_position1);
//
  
  
  // activation du ZBuffer 
  glEnable(GL_DEPTH_TEST);

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  //  glEnable(GL_LIGHT1);
  
  glEnable(GL_AUTO_NORMAL);
  glEnable(GL_NORMALIZE);

  // activation des textures 2D
  //  glEnable(GL_TEXTURE_2D);
  //glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
  
  
  //transparence
  //glEnable(GL_BLEND);
  //glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  
  /* non lissage des couleurs sur les facettes */
  // glShadeModel(GL_SMOOTH);
  
  // Keep initial time
  instantInitial = glutGet(GLUT_ELAPSED_TIME);
  last_display=glutGet(GLUT_ELAPSED_TIME);
}


/*********************************************************/
/* fonction d'initialisation de la fenetre des  senseurs*/
  void init_sensors()
{ 
  // couleur du fond (noir) 
  glClearColor(0.2,0.2,0.2,0.0);

  // activation du ZBuffer (mask part of sensors)
  //glEnable(GL_DEPTH_TEST);

  //glEnable(GL_LIGHTING);
  //glEnable(GL_LIGHT0);
  //glEnable(GL_NORMALIZE);
  glEnable(GL_COLOR_MATERIAL);
  
}


 void drawFunc_sensors(void)
{ /* initialisation des buffers : couleur et ZBuffer */

   glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

   if (display_sensor_window){
	 
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
  
   gluOrtho2D (0.0F, ((min<float>(world_GL.vector_robot.size(),MAX_ROBOTS_BY_LINE)))*1.1, 0.0F,Math::Ceil((float) world_GL.vector_robot.size()/MAX_ROBOTS_BY_LINE) );
  

   world_GL.display_winSensors();
  
  

   /* changement de buffer d'affichage */
   
   }
   
   glutSwapBuffers();  
  
}



// All Cams of robots have the same display function... Strange isn't it ?
// It is due to glut and his fuc**ing willing to receive a
// function(void->void) as display function To have different display
// according to the robot the cam looks to "current_displaying" variable.

 void drawCam(void)
{ // initialisation des buffers : couleur et ZBuffer 
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);

  glPushMatrix();

  
  gluLookAt((owners_of_windows[current_displaying])->centerx/SCALE_GL,
			(owners_of_windows[current_displaying])->centery/SCALE_GL,
			KHEPERA_GL_HEIGHT*2,
			(owners_of_windows[current_displaying])->centerx/SCALE_GL+cos((owners_of_windows[current_displaying])->direction),
			(owners_of_windows[current_displaying])->centery/SCALE_GL+sin((owners_of_windows[current_displaying])->direction),
			0.0,
			0.0,0.0,1.0);


  
  bool s_display_sensor_around=display_sensor_around;
  bool s_display_sensor_value=display_sensor_value;
  bool s_display_sensor_window=display_sensor_window;
  bool s_show_name_robots=show_name_robots;
  

  display_sensor_around=false;
  display_sensor_value=false;
  display_sensor_window=false;
  show_name_robots=false;
    
  world_GL.display_3D();

  display_sensor_around=s_display_sensor_around;
  display_sensor_value=s_display_sensor_value;
  display_sensor_window=s_display_sensor_window;
  show_name_robots=s_show_name_robots;
  
  glPopMatrix();
  glutSwapBuffers();

  
  //Now the scene is drawn we put it in the right robot;
  int i=0,win=glutGetWindow();
  vector<int>::iterator it1;
  for (it1=win_asked_by_robots.begin();it1!=win_asked_by_robots.end();it1++) 
	{
	  if ((*it1)==win)
		{
		  glReadPixels(0,0,KHEPERA_CAM_2D_X,KHEPERA_CAM_2D_Y,
					   GL_RGB,GL_UNSIGNED_BYTE,
					   owners_of_windows[i]->camera2D());
		 		  
		}
	  i++;
	}
  
}


int ask_a_cam(robot * _rob,string  _name,int _sx,int _sy)
{
  owners_of_windows.push_back(_rob);
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(_sx,_sy);
  int w=glutCreateWindow(_name.c_str());
  if (w==GL_FALSE) return 1;

  win_asked_by_robots.push_back(w);
  init();
  glutDisplayFunc(drawCam);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(KHEPERA_CAM_ANGLE_X,KHEPERA_CAM_ANGLE_X/KHEPERA_CAM_ANGLE_Y,0.1,100.0 );
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  return 0;
  
}




int GL_world_initialisation(int argc, char *argv[],unsigned sx,unsigned sy,unsigned ss)
{
  size_of_win_sensors=ss;
  
  win_asked_by_robots.clear();
  owners_of_windows.clear();
  
  
  // traitement des paramtres du programme propres  GL 
	  glutInit(&argc, argv);
	  // initialisation du mode d'affichage :                
	  // RVB + Double buffer.                      
	  glutInitDisplayMode(GLUT_RGB|GLUT_DEPTH|GLUT_DOUBLE);
	  

	  // placement et dimentions initiales de la fentre 
	  glutInitWindowPosition(0, 0);
	  glutInitWindowSize(sx,sy);
	  // ouverture de la fentre de visualisation 3D
	  winIdMain=glutCreateWindow("Robot Simulator");
#ifndef DONT_USE_GL
	  if (winIdMain == GL_FALSE)
		{ return 1;
		}

	  init();
	 //load texture
	 // if (LoadTexTiff("heart/marble.tif",1)==0) {return 1;}
	  
#endif
	  
	  // association de la fonction de dimensionnement 
	  glutReshapeFunc(reshapeFunc);
	  // association de la fonction d'affichage 
	  glutDisplayFunc(drawFunc);
	  /// association des fonctions d'vnement du clavier 
	  glutKeyboardFunc(kbdFunc);
	  glutSpecialFunc(kbdSpecialFunc);
	  // association de la fonction d'vnement souris 
	  glutMouseFunc(mouseFunc);
	  // association de la fonction de DRAG 
	  glutMotionFunc(motionFunc);
	  glutIdleFunc(idleFunc);

	  //initialisation of Sensors Window
	  //-----------------
	  glutInitWindowPosition(sx+2, 0);
	  //glutInitWindowSize(110*world_GL.vector_robot.size(),100);

	  glutInitWindowSize((int)Math::Floor(size_of_win_sensors*1.1),size_of_win_sensors);
	  
	  winIdSensors=glutCreateWindow("Robot Sensors");
	  // ouverture de la fentre de visualisation 3D
#ifndef DONT_USE_GL
	  if (winIdSensors == GL_FALSE)
		{ return 1;
		}
#endif

	  init_sensors();
	  // association de la fonction de dimensionnement 
	  //glutReshapeFunc(reshapeFunc);
	  // association de la fonction d'affichage 
	  glutDisplayFunc(drawFunc_sensors);
	  // association des fonctions d'vnement du clavier 
	  glutKeyboardFunc(kbdFunc);
	  glutSpecialFunc(kbdSpecialFunc);
	  // association de la fonction d'vnement souris 
	  //glutMouseFunc(mouseFunc);
	  // association de la fonction de DRAG 
	  //glutMotionFunc(motionFunc);
	  glutIdleFunc(idleFunc);
	  //------------------------


	  //initialisation of Control Window
	  //-----------------
	  glutInitWindowPosition(sx+2, 130);
	  glutInitWindowSize(300, 500);
	  //glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE );
	  winIdControl=glutCreateWindow("Simulator Control");
	  makeui();
	  muiInit();
	  // Show/Mask Windows according to initialisation value (in global.h)
	  makeui_display_according_to_curent_values();

	  //glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);

	  glutSetWindow(winIdMain);
	  
	  
	  return 0;
	  
}

#define DIMENSIONS_CANNOT_BE_DIVIDED_BY_2 -1
#define WRITE_PROBLEM -2

int save_current_window(char * name)
{
  FILE *fptr;
  int x,y,i,j,return_value=0;
  x=glutGet(GLUT_WINDOW_WIDTH);
  y=glutGet(GLUT_WINDOW_HEIGHT);

  if ((x%2==1)||(y%2==1))
	{
	  return_value=DIMENSIONS_CANNOT_BE_DIVIDED_BY_2; // Dimension problem
	}
  
  GLubyte* dump_buffer;
  dump_buffer = new (GLubyte[x*y*3]);
  
  //read buffer 
  glPixelStorei(GL_PACK_ALIGNMENT,1);
  glReadBuffer(GL_BACK);
  glReadPixels(0, 0, x, y, GL_RGB, GL_UNSIGNED_BYTE, dump_buffer);
	  
  /* save image */
  if ((fptr = fopen(name,"w")) == NULL) {
	cout<<"couldnt save gl imgages (write problem)"<<endl;
	return WRITE_PROBLEM;
  }
  else{
	fprintf(fptr,"P6\n%d %d\n255\n",x,y);
		
	for (j=y-1;j>=0;j--){
	  for (i=0;i<x;i++){
		fputc(dump_buffer[3*j*x+3*i+0],fptr);
		fputc(dump_buffer[3*j*x+3*i+1],fptr);
		fputc(dump_buffer[3*j*x+3*i+2],fptr);
	  }
	}
	fclose(fptr);
  }
	
  return return_value;
}


void save_display_to_disk()
{
  char name[255];
  bool wait=false; // Used for waiting redimensionnement of windows to a multiple of 2
  
  
  int win = glutGetWindow();
  
  glutSetWindow(winIdSensors);
  sprintf(name,"Sensors-pict-%09d.ppm", nb_frame_saved);
  if (save_current_window(name)<0) { // Dimension problem
	glutReshapeWindow(glutGet(GLUT_WINDOW_WIDTH)+glutGet(GLUT_WINDOW_WIDTH)%2,glutGet(GLUT_WINDOW_HEIGHT)+glutGet(GLUT_WINDOW_HEIGHT)%2);  // ask for redim
	wait=true; // and wait it (to have all pictures the same size) 
  }

  glutSetWindow(winIdMain);
  sprintf(name,"Main-pict-%09d.ppm", nb_frame_saved);
  if (save_current_window(name)<0) {
	glutReshapeWindow(glutGet(GLUT_WINDOW_WIDTH)+glutGet(GLUT_WINDOW_WIDTH)%2,glutGet(GLUT_WINDOW_HEIGHT)+glutGet(GLUT_WINDOW_HEIGHT)%2); //ask for redim (to have all pictures the same size)
	wait=true;}

  for (unsigned i=0;i<(win_asked_by_robots.size());i++)
	{
	  glutSetWindow(win_asked_by_robots[i]);
	  sprintf(name,"Camera-%s-pict-%09d.ppm",(owners_of_windows[i]->namerobot).c_str(), nb_frame_saved);
	  save_current_window(name); // We don't wait for the redim of the camera since she cannot be redimensionned... 
	}

  if (!wait)  nb_frame_saved++;
  
  
  glutSetWindow(win);
}






