#include "GLheader.h"
#include "global.h"

void drawCylinder(float r, float h,int dx, int dy,bool plein,double amax)
{ int ix,iy;
  double a,pasa =amax/(double)dx,pash=h/(double)dy,x,y;

  for (iy=0; iy<dy; iy++)
  { glBegin(GL_QUAD_STRIP);
	for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa)
	{ x = r*cos(a);
	  y = r*sin(a);
	  glNormal3f(x,y,0.0f);
	  glVertex3d(x,y,(double)(iy+1)*pash);
	  glVertex3d(x,y,(double)iy*pash);
	} 
	glEnd();   
  }
  if (plein)
  { glNormal3f(0.0f,0.0f,-1.0f);
	glBegin(GL_TRIANGLE_FAN);
	glVertex3f(0.0,0.0,0.0);	  
    for (ix=0,a=amax; ix<=dx; ix++,a-=pasa)
	{ x = r*cos(a);
	  y = r*sin(a);
	  glVertex3d(x,y,0.0);
	} 
	glEnd();   
	glNormal3f(0.0f,0.0f,1.0f);
	glBegin(GL_TRIANGLE_FAN);
	glVertex3f(0.0,0.0,h);	  
    for (ix=0,a=0.0; ix<=dx; ix++,a+=pasa)
	{ x = r*cos(a);
	  y = r*sin(a);
	  glVertex3d(x,y,h);
	} 
	glEnd();   
  }
}
void drawConea(float r1,float r2, float h,int dx)
{
  int ix;
  double a,pasa =2*M_PI/(double)dx,x1,y1,x2,y2;
  Real l1,coef1,z1,l2,coef2,z2;
  
  glBegin(GL_TRIANGLE_FAN);
  for (ix=0,a=0;ix<=dx; ix++, a+=pasa)
	{
	  x1=r2*cos(a);
	  y1=r1*sin(a);
	  x2=r2*cos(a+pasa);
	  y2=r1*sin(a+pasa);

	  l1=sqrt((x1*x1+y1*y1)+h*h);
	  coef1=h/l1;
	  z1=h-h*h/l1;

	  l2=sqrt((x2*x2+y2*y2)+h*h);
	  coef2=h/l2;
	  z2=h-h*h/l2;
	  
	  glNormal3f(h*(y2-y1),h*(x2-x1),x1*y2-y1*x2);
	  
	  glVertex3d(0.0,0.0,h);
	  glVertex3d(coef1*x1,coef1*y1,z1);
	  glVertex3d(coef2*x2,coef2*y2,z2);
		
	}
  glEnd();
}

void DrawCircle2D(float xcenter,float ycenter,float radius,float c1,float c2,float c3)
{
  glColor3f(c1, c2, c3);
  //glColor3i(255, 0  , 0  );
  double  vectorX1, vectorX;
  double  vectorY1, vectorY;
  double angle;
  double originX,originY;
  originX = xcenter;
  originY = ycenter;
  vectorX1=originX;
  vectorY1=originY;
  glBegin(GL_POLYGON);  
  for(int i=0;i<=360;i=i+5)  //360
	{
	  angle=(double)(((double)i)/57.29577957795135);   
	  vectorX=originX+(radius*(double)sin((double)angle));
	  vectorY=originY+(radius*(double)cos((double)angle));             
	  glVertex2d(originX,originY);  //2d
	  glVertex2d(vectorX1,vectorY1);  //2d
	  glVertex2f(vectorX,vectorY);  //2d
	  vectorY1=vectorY;
	  vectorX1=vectorX;       
	}
  glEnd();
}

void DrawRectangle2D(float _x, float _y, float _length, float _width, float _r, float _v, float _b)
{

  glColor3f(_r,_v,_b);
  glBegin(GL_QUADS);
  glVertex3f(_x,_y,0.0);
  glVertex3f(_x+_length,_y,0.0);
  glVertex3f(_x+_length,_y+_width,0.0);
  glVertex3f(_x,_y+_width,0.0);
  glEnd();

}


void DrawRectangle3D(float _x, float _y, float _height, float _length, float _width, float _r, float _v, float _b, float _a)
{

  float mat_ambi_ag[]= {_r,_v,_b,_a};
  //float low_shininess[]= {5.0};
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
  // glMaterialfv(GL_FRONT,GL_SHININESS,low_shininess);
  
  // glDisable(GL_LIGHTING);
  // glColor4f(_r,_v,_b,_a);
  // glBegin(GL_QUADS);
  //glVertex3f(_x,_y,0.0);
  //glVertex3f(_x+_length,_y,0.0);
  //glVertex3f(_x+_length,_y+_width,0.0);
  //glVertex3f(_x,_y+_width,0.0);
  //glEnd();
  //  glBegin(GL_QUADS);
  //glVertex3f(_x,_y,_height);
  //glVertex3f(_x+_length,_y,_height);
  //glVertex3f(_x+_length,_y+_width,_height);
  //glVertex3f(_x,_y+_width,_height);
  //glEnd();
  glBegin(GL_QUADS);
  glVertex3f(_x,_y,0.0);
  glVertex3f(_x,_y,_height);
  glVertex3f(_x,_y+_width,_height);
  glVertex3f(_x,_y+_width,0.0);
  glEnd();
   glBegin(GL_QUADS);
  glVertex3f(_x+_length,_y,0.0);
  glVertex3f(_x+_length,_y,_height);
  glVertex3f(_x+_length,_y+_width,_height);
  glVertex3f(_x+_length,_y+_width,0.0);
  glEnd();
   glBegin(GL_QUADS);
  glVertex3f(_x,_y,0.0);
  glVertex3f(_x,_y,_height);
  glVertex3f(_x+_length,_y,_height);
  glVertex3f(_x+_length,_y,0.0);
  glEnd();
   glBegin(GL_QUADS);
  glVertex3f(_x,_y+_width,0.0);
  glVertex3f(_x,_y+_width,_height);
  glVertex3f(_x+_length,_y+_width,_height);
  glVertex3f(_x+_length,_y+_width,0.0);
  glEnd();
  // glEnable(GL_LIGHTING);

}

void DrawString (float _x, float _y,const char *s,float _z)
{
  glPushAttrib(GL_LIGHTING);
  glPushAttrib(GL_LIGHT0);
    
  glDisable(GL_LIGHTING);
  glDisable(GL_LIGHT0);
  
  glRasterPos3f(_x,_y,_z);
  unsigned int i;
  for (i = 0; i < strlen (s); i++)
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_10, s[i]);

  glPopAttrib();
  glPopAttrib();
  
}
void DrawBigString (float _x, float _y,const char *s)
{
  glPushAttrib(GL_LIGHTING);
  glPushAttrib(GL_LIGHT0);
  
  glDisable(GL_LIGHTING);
  glDisable(GL_LIGHT0);
  
  glRasterPos2f(_x,_y);
  unsigned int i;
  for (i = 0; i < strlen (s); i++)
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_18, s[i]);

  glPopAttrib();
  glPopAttrib();
 
}
