#include "IRsensor.h"
//#include <iostream>
using namespace Geom;
using namespace std;


void IRsensor::IRcompute_Value(vector<Form *> _vf)
{
  //             /|
  //         S1 / |
  //           /  |
  //    Center< Angle_perception  ----> direction
  //           \  |
  //         S2 \ |S3
  //             \|
  //  

  
  /*
  S1.Origin()=Center;
  S1.Direction()=(Vector2(cos(direction+Angle_perception/2),sin(direction+Angle_perception/2)))*range;
  
  S2.Origin()=Center;
  S2.Direction()=(Vector2(cos(direction-Angle_perception/2),sin(direction-Angle_perception/2)))*range;

  S3.Origin()=Center+S1.Direction();
  S3.Direction()=S2.Direction()-S1.Direction();
  */
  
  
    
  vector<PrimitivForm *> Preselected_Primitiv_Forms;
  vector<unsigned> colors;
	
    for (vector<Form *>::iterator it1=_vf.begin();it1 != _vf.end();it1++) 
	  
		{
	  if ((*it1)->x_max > Center.x-Range) {       // Tests with bounding box
		if ((*it1)->y_max > Center.y-Range) {     // to avoid inutils calcs 
		  if (Center.x+Range > (*it1)->x_min) {
			if (Center.y+Range > (*it1)->y_min) {  
		  
			  for (vector<PrimitivForm *>::iterator it2=((*it1)->forms).begin();it2 != ((*it1)->forms).end();it2++)
				{		  
				  Preselected_Primitiv_Forms.push_back(*it2);
				  colors.push_back((*it1)->color);
				}
			  
			  
			}
		  }
		}
	   
		}
			  
	}

	//	cout<<Preselected_Primitiv_Forms.size()<<"*";
  

  // The cone of detection is divided in nb_ray parts.
  // We use ray tracing to have the distance to the detectded objects
  // and calc the contribution of this ray by the formula :
  //
  //              Intensity*Range 
  //  Iray=  -----------------------------
  //        (distance_of_object^2)*(nb_ray)
  //
  

  const int nb_ray=20;
  
  Real cos_angle_step = cos(Perception_Angle/(Real (nb_ray-1)));
  Real sin_angle_step = sin(Perception_Angle/(Real (nb_ray-1)));
  
  Segment2 S;
  S.Origin()=Center;
  S.Direction()=(Vector2(cos(direction-Perception_Angle/2),sin(direction-Perception_Angle/2)))*Range;

  Real d2;
  Real d2tmp;
  Real w[2];
  Vector2 wcir[2];
  Vector2 wbox[4];
  int control;
  string typ;
  vector<unsigned>::iterator color_iterator;
  unsigned color=255;
   
  Value=0;
  for (int i=0;i<nb_ray;i++)
	{
	  d2=Range*Range;
	  color_iterator=colors.begin();
	  for (vector<PrimitivForm *>::iterator it1=Preselected_Primitiv_Forms.begin();it1 != Preselected_Primitiv_Forms.end();it1++)
		{
		  //find intersection (if exists)
		   typ=(*it1)->type();   
		   if (typ=="Segment"){
#ifdef _WIN32
			 if (FindIntersection(S,*(static_cast<Segment2 *>(*it1)),control,w))			 
#else
			 if (FindIntersection(S,*(dynamic_cast<Segment2 *>(*it1)),control,w))
#endif
			   {
				 d2tmp=(S.Direction()*w[0]).SquaredLength();
				 if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(S.Direction()*w[1]).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
			   }
		   }
		   if (typ=="Ray") {
#ifdef _WIN32
			   if (FindIntersection(*(static_cast<Ray2 *>(*it1)),S,control,w))
#else
				 if (FindIntersection(*(dynamic_cast<Ray2 *>(*it1)),S,control,w))
#endif
				 {
				   d2tmp=(S.Direction()*w[0]).SquaredLength();
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(S.Direction()*w[1]).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   if (typ=="Line") {
#ifdef _WIN32
			   if (FindIntersection(*(static_cast<Line2 *>(*it1)),S,control,w))
#else
				 if (FindIntersection(*(dynamic_cast<Line2 *>(*it1)),S,control,w))
#endif
				 {
				   d2tmp=(S.Direction()*w[0]).SquaredLength();
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(S.Direction()*w[1]).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   if (typ=="Circle") {
#ifdef _WIN32
			   if (FindIntersection(S,*(static_cast<Circle2 *>(*it1)),control,wcir))
#else
				 if (FindIntersection(S,*(dynamic_cast<Circle2 *>(*it1)),control,wcir))
#endif
				 {
				   d2tmp=(wcir[0]-S.Origin()).SquaredLength();
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(wcir[1]-S.Origin()).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   if (typ=="Arc") {
#ifdef _WIN32
			   if (FindIntersection(S,*(static_cast<Arc2 *>(*it1)),control,wcir))
#else
				 if (FindIntersection(S,*(dynamic_cast<Arc2 *>(*it1)),control,wcir))
#endif
				 {
				   d2tmp=(wcir[0]-S.Origin()).SquaredLength();
				   
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(wcir[1]-S.Origin()).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   
		   if (typ=="Box") {

#ifdef WIN32
			 if (FindIntersection(*(static_cast<Box2 *>(*it1)),S,control,wbox))
#else
			   if (FindIntersection(*(dynamic_cast<Box2 *>(*it1)),S,control,wbox))
#endif
				 {
				   for (int ii=0;ii<control;ii++)
					 {
					   d2tmp=((wbox[ii])-S.Origin()).SquaredLength();
					   //cout<<wbox[ii].x<<" "<<wbox[ii].y<<endl;
					   
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 }
				   				   
				   				   
				 }
			 
				 }
		   color_iterator++;
		}
	  //calc contribution

	  // cout<<d2<<" ";

	  // if (color!=255) {cout<<"warning color:"<<color<<endl;}

#ifdef _WIN32
	  if (d2<Range*Range) Value+=(1/d2)*(color)/255;
#else
	  if (d2<Range*Range) Value+=(1/d2)*((Real (color))/255);
#endif
	  
	  //Change Ray
	  (S.Direction()).Rotate(cos_angle_step,sin_angle_step,0,0);
	}
  // cout<<"///"<<endl;
  
  Value_already_computed=true;
  Value=Value*(Intensity)*Range/(nb_ray);
  
  Value+=Math::NormalRandom(biais,ecart_type);
  if (Value>Intensity) {Value=Intensity;}
  if (Value<0) {Value=0;}
  
  
}

void IRsensor::IRcompute_Passive_Value(vector<Form *> _vf,vector<light *> _vl)
{
  vector<light*>::iterator it1;
  Passive_Value=passive_Intensity;
  
  vector<PrimitivForm *>* vpf= new vector<PrimitivForm *>;
  Segment2* seg=new Segment2();
  Form* seg_IR_light;
  Real angle;
  
  
  seg->Origin()=Center;
  
  for (it1=_vl.begin();it1!=_vl.end();it1++) 
	{
	  //Calc the segment IRcenter-Light


	  seg->Direction()=Vector2((*it1)->x,(*it1)->y)-Center;
	  vpf->clear();
	  vpf->push_back(seg);
	  
	  seg_IR_light = new Form(*vpf);
		
	  	  
	  
	  // if no obstacle to see the light
	  if (!(GeomFormCollisionDetection((*seg_IR_light),_vf)))
		{
		  //Calc contribution of the light

		  // Find the angle between the sensor direction and
		  // the direction of the light angle is in [-PI;PI]
		  // for convenience
		  angle=Math::ATan(seg->Direction().y/seg->Direction().x);
		  if (seg->Direction().x<0) {angle+=M_PI;}
		  angle-=direction;
		  if (angle<=-M_PI) {angle+=2*M_PI;}
		  if (angle>M_PI) {angle-=2*M_PI;}

		  // if the sensor look in the correct direction add contribution
		  if ((angle<(M_PI/2))&&(angle>(-M_PI/2)))
			{
			  Passive_Value-=((*it1)->power*Math::ATan(SIZE_OF_LIGHTS/(seg->Direction()).Length()))*(Math::Cos(angle));
			}
		  
		}
	  delete(seg_IR_light);
	}
  delete(seg);
  delete(vpf);
  
  
  
  Passive_Value+=Math::NormalRandom(passive_biais,passive_ecart_type);
  if (Passive_Value>passive_Intensity) {Passive_Value=passive_Intensity;}
  if (Passive_Value<0) {Passive_Value=0;}
  Passive_Value_already_computed=true;
  
  
}

void IRsensor::Reset()
{
Value_already_computed=false;
Passive_Value_already_computed=false;
}

Real IRsensor::Get_Value()
{
if (Value_already_computed) return (Value);
 return -1;
}

Real IRsensor::Get_Passive_Value()
{
if (Passive_Value_already_computed) return (Passive_Value);
 return -1;
}

void IRsensor::Translate(Real _tx, Real _ty)
{
  Center.Translate(_tx,_ty);
}

void IRsensor::Rotate(Real _theta, Real _centerx, Real _centery)
{
  Center.Rotate(_theta,_centerx,_centery);
  direction+=_theta;
  if (direction > 2*Math::PI) {direction-=2*Math::PI;}
  if (direction < 0) {direction+=2*Math::PI;}
}



