#ifndef IRsensor_H
#define IRsensor_H


#include "global.h"
//#include "../GEOMsources/GeomForm.h"
//#include "../GEOMsources/GeomMath.h"
#include "../GEOMsources/GeomFormCollisionDetection.h"

#include "light.h"

#include <math.h>
#include <vector>

using namespace std;
using namespace Geom;


class IRsensor
{
  friend class robot;
  friend class khepera;
 
  
 private:
  Real Passive_Value;
  Real Value;
  bool Value_already_computed;
  bool Passive_Value_already_computed;
  Real biais;
  Real ecart_type;
  Real passive_biais;
  Real passive_ecart_type;
  Real passive_Intensity;
  
	
 public:
  
  Vector2 Center;
  Real direction;
  
  Real Range;
  Real Perception_Angle;
  Real Intensity;
  

  IRsensor(Real _position_x0,Real _position_y0,Real _direction,
				  Real _Range,Real _Perception_Angle,Real _Intensity,
		   Real _biais =KHEPERA_IR_BIAS , Real _ecart_type=KHEPERA_IR_NOISE,
		   Real _passive_biais =KHEPERA_IR_PASSIVE_BIAS,
		   Real _passive_ecart_type=KHEPERA_IR_PASSIVE_NOISE,
		   Real _passive_Intensity=KHEPERA_passive_IR_Intensity)
  {
	Center.x=_position_x0;
	Center.y=_position_y0;
	
	direction=_direction;
	Range=_Range;
	Perception_Angle=_Perception_Angle;
	Intensity=_Intensity;
	biais = _biais;
	ecart_type= _ecart_type;
	passive_biais = _passive_biais;
	passive_ecart_type= _passive_ecart_type;
	passive_Intensity=_passive_Intensity;
	
	
	Value_already_computed=false;
	Passive_Value_already_computed=false;
  }

  
  void IRcompute_Value(vector<Form *> _vf);
  void IRcompute_Passive_Value(vector<Form *> _vf,vector<light *> _vl);
  
  void Reset();
  Real Get_Value();
  Real Get_Passive_Value(); 
  void Translate(Real _tx, Real _ty);
  void Rotate(Real _theta, Real _centerx, Real _centery);
	
};




#endif
