#include "camera1D.h"


unsigned*  Camera_1D::camera1D()
{

  if (calc_done)
	{
	  return picture;
	}
  else
	{
	  int a=0;
	  throw (a);
	  
	}
}


void Camera_1D::calcule_picture(vector<Form *> _vf)
{
  
  vector<PrimitivForm *> Preselected_Primitiv_Forms;
  vector<unsigned> colors;
 
  for (vector<Form *>::iterator it1=_vf.begin();it1 != _vf.end();it1++) 
	  
	{
	  if ((*it1)->x_max > Center.x-Range) {       // Tests with bounding box
		if ((*it1)->y_max > Center.y-Range) {     // to avoid inutils calcs 
		  if (Center.x+Range > (*it1)->x_min) {
			if (Center.y+Range > (*it1)->y_min) {  
			  
			  for (vector<PrimitivForm *>::iterator it2=((*it1)->forms).begin();it2 != ((*it1)->forms).end();it2++)
				{		  
				  Preselected_Primitiv_Forms.push_back(*it2);
				  colors.push_back((*it1)->color);
				}
			}
		  }
		}
	  }
	}

  
  int nb_ray=number_of_pixels;
  
  Real cos_angle_step = cos(Perception_Angle/(Real (nb_ray-1)));
  Real sin_angle_step = sin(Perception_Angle/(Real (nb_ray-1)));
  
  Segment2 S;
  S.Origin()=Center;
  S.Direction()=(Vector2(cos(direction-Perception_Angle/2),sin(direction-Perception_Angle/2)))*Range;

  Real d2;
  Real d2tmp;
  Real w[2];
  Vector2 wcir[2];
  Vector2 wbox[4];
  int control;
  string typ;
  vector<unsigned>::iterator color_iterator;
  unsigned color=255;
   

  for (int i=0;i<nb_ray;i++)
	{
	  d2=Range*Range;
	  color_iterator=colors.begin();
	  for (vector<PrimitivForm *>::iterator it1=Preselected_Primitiv_Forms.begin();it1 != Preselected_Primitiv_Forms.end();it1++)
		{
		  //find intersection (if exists)
		   typ=(*it1)->type();   
		   if (typ=="Segment"){
#ifdef _WIN32
			 if (FindIntersection(S,*(static_cast<Segment2 *>(*it1)),control,w))			 
#else
			 if (FindIntersection(S,*(dynamic_cast<Segment2 *>(*it1)),control,w))
#endif
			   {
				 d2tmp=(S.Direction()*w[0]).SquaredLength();
				 if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(S.Direction()*w[1]).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
			   }
		   }
		   if (typ=="Ray") {
#ifdef _WIN32
			   if (FindIntersection(*(static_cast<Ray2 *>(*it1)),S,control,w))
#else
				 if (FindIntersection(*(dynamic_cast<Ray2 *>(*it1)),S,control,w))
#endif
				 {
				   d2tmp=(S.Direction()*w[0]).SquaredLength();
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(S.Direction()*w[1]).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   if (typ=="Line") {
#ifdef _WIN32
			   if (FindIntersection(*(static_cast<Line2 *>(*it1)),S,control,w))
#else
				 if (FindIntersection(*(dynamic_cast<Line2 *>(*it1)),S,control,w))
#endif
				 {
				   d2tmp=(S.Direction()*w[0]).SquaredLength();
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(S.Direction()*w[1]).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   if (typ=="Circle") {
#ifdef _WIN32
			   if (FindIntersection(S,*(static_cast<Circle2 *>(*it1)),control,wcir))
#else
				 if (FindIntersection(S,*(dynamic_cast<Circle2 *>(*it1)),control,wcir))
#endif
				 {
				   d2tmp=(wcir[0]-S.Origin()).SquaredLength();
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(wcir[1]-S.Origin()).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   if (typ=="Arc") {
#ifdef _WIN32
			   if (FindIntersection(S,*(static_cast<Arc2 *>(*it1)),control,wcir))
#else
				 if (FindIntersection(S,*(dynamic_cast<Arc2 *>(*it1)),control,wcir))
#endif
				 {
				   d2tmp=(wcir[0]-S.Origin()).SquaredLength();
				   
				   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
				   if (control==2)
					 {
					   d2tmp=(wcir[1]-S.Origin()).SquaredLength();
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 } 
				 }
		   }
		   
		   if (typ=="Box") {

#ifdef WIN32
			 if (FindIntersection(*(static_cast<Box2 *>(*it1)),S,control,wbox))
#else
			   if (FindIntersection(*(dynamic_cast<Box2 *>(*it1)),S,control,wbox))
#endif
				 {
				   for (int ii=0;ii<control;ii++)
					 {
					   d2tmp=((wbox[ii])-S.Origin()).SquaredLength();
					   //cout<<wbox[ii].x<<" "<<wbox[ii].y<<endl;
					   
					   if (d2tmp<d2) {d2=d2tmp; color=*color_iterator;}
					 }
				   				   
				   				   
				 }
			 
				 }
		   color_iterator++;
		}
	  //calc contribution

	  // cout<<d2<<" ";

	  // if (color!=255) {cout<<"warning color:"<<color<<endl;}


	  picture[i*3]=color;
	  picture[i*3+1]=color;
	  picture[i*3+2]=color;

	  
	  //Change Ray
	  (S.Direction()).Rotate(cos_angle_step,sin_angle_step,0,0);
	}

	
  calc_done=true;
  
}




void Camera_1D::Translate(Real _tx, Real _ty)
{
  Center.Translate(_tx,_ty);
}

void Camera_1D::Rotate(Real _theta, Real _centerx, Real _centery)
{
  Center.Rotate(_theta,_centerx,_centery);
  direction+=_theta;
  if (direction > 2*Math::PI) {direction-=2*Math::PI;}
  if (direction < 0) {direction+=2*Math::PI;}
}

void Camera_1D::Reset()
{
  calc_done=false;
}









