#include "environment.h"


using namespace std; // for string and gcc3.2
using namespace Geom;





void wall::initGL3D()
{
  	
  id_obstacle=glGenLists(1);
  glNewList(id_obstacle,GL_COMPILE);
  
  GL3D_without_Lists();
  
  glEndList();
		  
}

void wall::GL3D_without_Lists()
{
  vector<PrimitivForm *> fo =(pforme->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Segment2 * seg=(static_cast<Segment2 *>(*it1));
#else
  Segment2 * seg=(dynamic_cast<Segment2 *>(*it1));
#endif
  
  Real x1,y1,x2,y2;
  x1=(seg->Origin()).x/SCALE_GL;
  y1=(seg->Origin()).y/SCALE_GL;
  x2=((seg->Origin()).x+(seg->Direction()).x)/SCALE_GL;
  y2=((seg->Origin()).y+(seg->Direction()).y)/SCALE_GL;

	
  float mat_ambi_pl[]= {0.9,0.5,0.9},mat_diff_pl[]= {0.2,0.2,0.2},mat_spec_pl[]= {0.2,0.2,0.2},mat_nphong_pl=40.0;
  
  //glColor3fv(0.1,0.5,0.9);
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
  

  glNormal3f(x2-x1,y2-y1,0.0);
  glBegin(GL_QUADS);
		
  glVertex3d(x1,y1,-0.01);
  glVertex3d(x2,y2,-0.01);
  glVertex3d(x2,y2,0.3);
  glVertex3d(x1,y1,0.3);
		 
  glEnd();
		
  glNormal3f(x2-x1,-(y2-y1),0.0);
  glBegin(GL_QUADS);
  
  glVertex3d(x1,y1,-0.01);
  glVertex3d(x2,y2,-0.01);
  glVertex3d(x2,y2,0.3);
  glVertex3d(x1,y1,0.3);
		 
  glEnd();

}

	
void wall::display_2D()
{
	  
}
  
void wall::display_3D()
{
  if (!gripped)
	{
	  
	  glPushMatrix();
	  if (glutGetWindow()==winIdMain)
		{ GL3D_without_Lists();
		// glCallList(id_obstacle); 
		} else {
		  GL3D_without_Lists();
		}
	  glPopMatrix();
  
	}

  
}

void wall::save(FILE *Fichier)
{
  vector<PrimitivForm *> fo =(pforme->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Segment2 * seg=(static_cast<Segment2 *>(*it1));
#else
  Segment2 * seg=(dynamic_cast<Segment2 *>(*it1));
#endif
  
  Real x1,y1,x2,y2;
  x1=(seg->Origin()).x;
  y1=(seg->Origin()).y;
  x2=((seg->Origin()).x+(seg->Direction()).x);
  y2=((seg->Origin()).y+(seg->Direction()).y);

  fprintf(Fichier,"wall %s %lg %lg %lg %lg %i %d\n",name.c_str(),x1,y1,x2,y2,pforme->color,can_be_gripped_);
}

void wall::can_be_gripped()
{can_be_gripped_=true;}

void wall::grip()
{if (can_be_gripped_) {gripped=true;}}

void wall::release()
{
  if (gripped){
	
	gripped=false;
	
	//make a new GL struture to allow display
	glDeleteLists(id_obstacle,1);
	
	int win = glutGetWindow();
  
	glutSetWindow(winIdMain);
	initGL3D();
	
	glutSetWindow(win);
	
	  
  }
}




void cylinder::initGL3D()
{
  
		
  id_obstacle=glGenLists(1);
  glNewList(id_obstacle,GL_COMPILE);
  
  GL3D_without_Lists();
  
  glEndList();
  
}

void cylinder::GL3D_without_Lists()
{
  vector<PrimitivForm *> fo =(pforme->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
  
  Real x,y,r;
  x=(cir->Center()).x/SCALE_GL;
  y=(cir->Center()).y/SCALE_GL;
  r=((cir->Radius()))/SCALE_GL;
	
  float mat_ambi_pl[]= {0.1,0.5,0.4},mat_diff_pl[]= {0.8,0.2,0.2},mat_spec_pl[]= {0.1,0.1,0.1},mat_nphong_pl=40.0;
		
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		

  glPushMatrix();
  glTranslatef(x,y,0.0);	
  drawCylinder(r,0.25,20,1,true);
  glPopMatrix();
		

}

	
void cylinder::display_2D()
{
	  
}
  
void cylinder::display_3D()
{

  if (!gripped)
	{
	  glPushMatrix();
	  if (glutGetWindow()==winIdMain)
		{ GL3D_without_Lists();
		// glCallList(id_obstacle); 
		} else {
		  GL3D_without_Lists();
		}
	  glPopMatrix();
	  
	}

	  
}


void cylinder::save(FILE *Fichier)
{
  vector<PrimitivForm *> fo =(pforme->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
		
  Real x,y,r;
  x=(cir->Center()).x;
  y=(cir->Center()).y;
  r=((cir->Radius()));
		
  fprintf(Fichier,"cylinder %s %lg %lg %lg %i %d\n",name.c_str(),x,y,r,pforme->color,can_be_gripped_);
}
	
void cylinder::can_be_gripped()
{can_be_gripped_=true;}

void cylinder::grip()
{if (can_be_gripped_) {gripped=true;}}

void cylinder::release()
{
  if (gripped) {
	
	gripped=false;

	//make a new GL struture to allow display
	glDeleteLists(id_obstacle,1);
	
	int win = glutGetWindow();
  
	glutSetWindow(winIdMain);
	initGL3D();
	
	glutSetWindow(win);
	
  }
  
}



void  cylinder_unfixed::initGL3D()
{
  id_obstacle=glGenLists(1);
  glNewList(id_obstacle,GL_COMPILE);
		
  GL3D_without_Lists();
		
  glEndList();
		  
}

void  cylinder_unfixed::GL3D_without_Lists()
	  {
		vector<PrimitivForm *> fo =(pforme->forms);
		vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
		Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
		Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
		
		Real r;//,x,y;
		//x=(cir->Center()).x/SCALE_GL;
		//y=(cir->Center()).y/SCALE_GL;
		r=((cir->Radius()))/SCALE_GL;
	
		float mat_ambi_pl[]= {0.1,0.5,0.4},mat_diff_pl[]= {0.8,0.2,0.2},mat_spec_pl[]= {0.1,0.1,0.1},mat_nphong_pl=40.0;
		
		
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
		glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		

		glPushMatrix();
		//glTranslatef(x,y,0.0);	
		drawCylinder(r,0.25,20,1,true);
		glPopMatrix();
		
	  }

void  cylinder_unfixed::display_2D()
	  {
	  
	  }
  
void  cylinder_unfixed::display_3D()
	  {
		if (!gripped)
		  {
			vector<PrimitivForm *> fo =(pforme->forms);
			vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
			Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
			Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
		
			Real x,y;
			x=(cir->Center()).x/SCALE_GL;
			y=(cir->Center()).y/SCALE_GL;
	  	  
			glPushMatrix();
		
			glTranslatef(x,y,0.0);	
			
			if (glutGetWindow()==winIdMain)
			  {
				glCallList(id_obstacle); 
			  } else {
				GL3D_without_Lists();
			  }
		
			glPopMatrix();
	  
			}
	  }


void  cylinder_unfixed::save(FILE *Fichier)
	  {
		vector<PrimitivForm *> fo =(pforme->forms);
		vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
		Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
		Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
		
		Real x,y,r;
		x=(cir->Center()).x;
		y=(cir->Center()).y;
		r=((cir->Radius()));
		
		fprintf(Fichier,"cylinder_unfixed %s %lg %lg %lg %i %d\n",name.c_str(),x,y,r,pforme->color,can_be_gripped_);
	  }

void cylinder_unfixed::can_be_gripped()
{can_be_gripped_=true;}

void cylinder_unfixed::grip()
{}

void cylinder_unfixed::release()
{
  if (gripped) {
	
	gripped=false;
	
	//no need to remake a glList for this type of obstacle
  }
}





void bloc::initGL3D()
	  {
		
		
		id_obstacle=glGenLists(1);
		glNewList(id_obstacle,GL_COMPILE);
		
		GL3D_without_Lists();
		
		glEndList();
		
		
	  }


void bloc::GL3D_without_Lists()
	  {
		
		vector<PrimitivForm *> fo =(pforme->forms);
		vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
		Box2 * blo=(static_cast<Box2 *>(*it1));
#else
		Box2 * blo=(dynamic_cast<Box2 *>(*it1));
#endif
		Vector2 Vertex[4];
		//cout<<blo->Axes()[1].x<<" "<<blo->Axes()[1].y<<endl;
		
		blo->ComputeVertices(Vertex);

		int i;
		
		for (i=0;i<4;i++)
		  {
			(Vertex[i])=(Vertex[i])/((Real) SCALE_GL);
		  }
		
		
		float mat_ambi_pl[]= {0.9,0.5,0.9},mat_diff_pl[]= {0.2,0.2,0.2},mat_spec_pl[]= {0.2,0.2,0.2},mat_nphong_pl=40.0;
		
		
		
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
		glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		
		for ( i=0;i<4;i++)
		  {
			glNormal3f(Vertex[(i+1)%4].x-Vertex[i].x,
					   Vertex[(i+1)%4].y-Vertex[i].y,0.0);
			
			glBegin(GL_QUADS);
			
			glVertex3d(Vertex[i].x,Vertex[i].y,0.0);
			glVertex3d(Vertex[(i+1)%4].x,Vertex[(i+1)%4].y,0.0);
			glVertex3d(Vertex[(i+1)%4].x,Vertex[(i+1)%4].y,0.3);
			glVertex3d(Vertex[i].x,Vertex[i].y,0.3);
			
			glEnd();

			
		  }
		glNormal3f(0.0,0.0,-1.0);
		
		glBegin(GL_QUADS);
		glVertex3d(Vertex[0].x,Vertex[0].y,0.0);
		glVertex3d(Vertex[1].x,Vertex[1].y,0.0);
		glVertex3d(Vertex[2].x,Vertex[2].y,0.0);
		glVertex3d(Vertex[3].x,Vertex[3].y,0.0);
		glEnd();

		glNormal3f(0.0,0.0,1.0);
		glBegin(GL_QUADS);
		glVertex3d(Vertex[0].x,Vertex[0].y,0.3);
		glVertex3d(Vertex[1].x,Vertex[1].y,0.3);
		glVertex3d(Vertex[2].x,Vertex[2].y,0.3);
		glVertex3d(Vertex[3].x,Vertex[3].y,0.3);
		glEnd();
		

	  }

	
void bloc::display_2D()
	{
	  
	}
  
void bloc::display_3D()
	{
	  if (!gripped)
		{
		  glPushMatrix();
		  if (glutGetWindow()==winIdMain)
			{
			  GL3D_without_Lists();
			  // glCallList(id_obstacle); 
			} else {
			  GL3D_without_Lists();
			}
		  glPopMatrix();
		  
		  /*  vector<PrimitivForm *> fo =(pforme->forms);
			  vector<PrimitivForm *>::iterator it1=fo.begin();
			  Box2 * b=(dynamic_cast<Box2 *>(*it1));
			  
			  cout<<(pforme->x_min)<<" "<<(pforme->x_max)<<endl;*/

		}
	}



void bloc::save(FILE *Fichier)
	  {
		vector<PrimitivForm *> fo =(pforme->forms);
		vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
		Box2 * blo=(static_cast<Box2 *>(*it1));
#else
		Box2 * blo=(dynamic_cast<Box2 *>(*it1));
#endif

		fprintf(Fichier,"bloc %s %lg %lg %lg %lg %lg %lg %i %d \n",
				name.c_str(),
				blo->Center().x,
				blo->Center().y,
				blo->Axes()[0].x*blo->Extents()[0],
				blo->Axes()[0].y*blo->Extents()[0],
				blo->Axes()[1].x*blo->Extents()[1],
				blo->Axes()[1].y*blo->Extents()[1],
				pforme->color,
				can_be_gripped_);
		
	  }

void bloc::can_be_gripped()
{can_be_gripped_=true;}

void bloc::grip()
{if (can_be_gripped_) {gripped=true;}}

void bloc::release()
{
  if (gripped) {
	
	gripped=false;

	//make a new GL struture to allow display
	glDeleteLists(id_obstacle,1);
	
	int win = glutGetWindow();
  
	glutSetWindow(winIdMain);
	initGL3D();
	
	glutSetWindow(win);
	
  }
  

}




void Food::initGL3D()
	{
	  
	  
	  id_obstacle=glGenLists(1);
	  glNewList(id_obstacle,GL_COMPILE);
	  
	  GL3D_without_Lists();
		
	  glEndList();
		  
	}

void Food::GL3D_without_Lists()
	{
	  vector<PrimitivForm *> fo =(pforme->forms);
	  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef WIN32
	  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
	  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
	  
	  Real r,x,y;

	  x=(cir->Center()).x/SCALE_GL;
	  y=(cir->Center()).y/SCALE_GL;
	  r=((cir->Radius()))/SCALE_GL;
	  
	  float mat_ambi_pl[]= {0.4,0.5,0.4},mat_diff_pl[]= {0.9,0.8,0.2},mat_spec_pl[]= {0.1,0.1,0.1},mat_nphong_pl=40.0;
	  
	  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
	  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
	  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
	  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		
	  glPushMatrix();
	  glTranslatef(x,y,r);	
	  glutSolidSphere(r,15,15);
	  glPopMatrix();
		
	  		  
	}


void Food::display_2D()
	{
	  
	}
	
void Food::display_3D()
	{
	  if (!gripped)
		{
		  glPushMatrix();
		  if (glutGetWindow()==winIdMain)
			{GL3D_without_Lists();
			// glCallList(id_obstacle); 
			} else {
			  GL3D_without_Lists();
			}
		  glPopMatrix();
		}
	  

	}


void Food::save(FILE *Fichier)
	  {
		vector<PrimitivForm *> fo =(pforme->forms);
		vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
		Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
		Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
		
		Real x,y,r;
		x=(cir->Center()).x;
		y=(cir->Center()).y;
		r=((cir->Radius()));
		
		fprintf(Fichier,"food %s %lg %lg %lg %i %d\n",name.c_str(),x,y,r,pforme->color,can_be_gripped_);
	  }
	
void Food::can_be_gripped()
{can_be_gripped_=true;}

void Food:: grip()
{if (can_be_gripped_) {gripped=true;}}

void Food:: release()
{
  if (gripped) {
	
	gripped=false;
 
	//make a new GL struture to allow display
	glDeleteLists(id_obstacle,1);
	
	int win = glutGetWindow();
  
	glutSetWindow(winIdMain);
	initGL3D();
	
	glutSetWindow(win);
	
	

  }
  
}



void environment::initGL3D()
{
  id_env=glGenLists(1);
  glNewList(id_env,GL_COMPILE);
		
  GL3D_without_Lists();
		
  glEndList();
}

void environment::GL3D_without_Lists()
	  {
		Real a,b;
		a=dx/SCALE_GL;
		b=dy/SCALE_GL;

				
		float mat_ambi_pl[]= {0.1,0.1,0.4},
		      mat_diff_pl[]= {0.7,0.1,0.2},
			  mat_spec_pl[]= {0.1,0.1,0.1},
			  mat_nphong_pl=40.0;

		
				
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
		glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		
		
		glNormal3f(0.0,0.0,1.0);
		glBegin(GL_QUADS);
		 glTexCoord2f(0.0,0.0);glVertex3d(0.0,0.0,0.0);
		 glTexCoord2f(0.0,1.0);glVertex3d(0.0,b,0.0);
		 glTexCoord2f(0.0,0.0);glVertex3d(a,b,0.0);
		 glTexCoord2f(1.0,1.0);glVertex3d(a,0.0,0.0);
		glEnd();
		
		glNormal3f(0.0,0.0,-1.0);
		glBegin(GL_QUADS);
		 glVertex3d(0.0,0.0,-0.01);
		 glVertex3d(0.0,b,-0.01);
		 glVertex3d(a,b,-0.01);
		 glVertex3d(a,0.0,-0.01);
		glEnd();
		
	  }
	
void environment::display_2D()
	  {
		for (vector<obstacle*>::iterator it1= all_obstacles.begin();it1!= all_obstacles.end();it1++) 
		  {
			(*it1)->display_2D();
		  }
	  }

void environment::display_3D()
	  {
		vector<obstacle*>::iterator it1;
		// fixed obstacles
		for ( it1= all_obstacles.begin();it1!= all_obstacles.end();it1++) 
		{
		  (*it1)->display_3D();
		}

		// unfixed obstacles
		for ( it1= all_obstacles_unfixed.begin();it1!= all_obstacles_unfixed.end();it1++) 
		{
		  (*it1)->display_3D();
		}
		
		// food
		for ( it1= all_foods.begin();it1!= all_foods.end();it1++) 
		{
		  (*it1)->display_3D();
		}

		// lights
		vector<light*>::iterator it2;
		for ( it2= all_lights.begin();it2!= all_lights.end();it2++) 
		{
		  (*it2)->display_3D();
		}
		
		glPushMatrix();
		if (glutGetWindow()==winIdMain)
		{GL3D_without_Lists();
		// glCallList(id_env); 
		} else {
		  GL3D_without_Lists();
		}
		glPopMatrix();
		
	
	
	  }
void environment::remove_all()
{
  all_obstacles.clear();
  all_obstacles_unfixed.clear();
  all_foods.clear();
  all_lights.clear();
}



void environment::save(const char* _name)
	  {
		FILE *Fichier;
		Fichier=fopen(_name,"w");
		fprintf(Fichier,"Environment\n");
		fprintf(Fichier,"%lg %lg\n",dx,dy);
		unsigned i;
		for (i=0;i<(all_obstacles.size());i++)
		  {
			(all_obstacles[i]->save(Fichier));
		  }
		for (i=0;i<(all_obstacles_unfixed.size());i++)
		  {
			(all_obstacles_unfixed[i]->save(Fichier));
		  }
		for (i=0;i<(all_foods.size());i++)
		  {
			(all_foods[i]->save(Fichier));
		  }
		for (i=0;i<(all_lights.size());i++)
		  {
			(all_lights[i]->save(Fichier));
		  }
		
		
		fprintf(Fichier,"Environment Ends\n"); // Ends the file by an non important line
		fclose(Fichier);
	  }

void environment::load(const char* _name)
{
  FILE *Fichier;
  char name[255];
  strcpy(name,_name);
  strcpy(name + strlen(name), ".env");

  
  Fichier=fopen(name,"r");

  if (Fichier>0)
	{
	  
	  this->remove_all();
	  
  const int taille_buf=255;
	 
  char  buf[taille_buf];
  fscanf(Fichier,"%s\n",buf);
  
  char name[taille_buf];
  Real x1,x2,y1,y2,cx,cy,r,x,y,power;
  unsigned color;
  int b;
	 
	 
  if (strcmp(buf,"Environment")==0) {

	//dimensions of the world
	fscanf(Fichier,"%lg %lg",&x,&y);
	dx=x;
	dy=y;
	rebondlights=false;
	   
	// Reading objects
	while (!feof(Fichier))
	  {
		for (int i=0;i<taille_buf;i++){buf[i]='a' ;}
		fscanf(Fichier,"%s\n",buf);
		//cout<<buf<<endl;
		//cout<<maptoswitch(buf)<<endl;
		
		switch (maptoswitch(buf))
		  {
		  case 0 :
				fscanf(Fichier,"%s %lg %lg %lg %lg %i %d\n",name,&x1,&y1,&x2,&y2,&color,&b);				
				add_wall(name,x1,y1,x2,y2,color,(bool) b);
				break;//wall
			  case 1 :
				fscanf(Fichier,"%s %lg %lg %lg %i %d\n",name,&x,&y,&r,&color,&b);
				add_cylinder(name,x,y,r,color,(bool) b);
				break;   // cylinder
			  case 2 : 
				fscanf(Fichier,"%s %lg %lg %lg %i %d\n",name,&x,&y,&r,&color,&b);
				add_cylinder_unfixed(name,x,y,r,color,(bool) b);
				break; // cylinder unfixed
			  case 3 :
				fscanf(Fichier,"%s %lg %lg %lg %lg %lg %lg %i %d",name,&cx,&cy,&x1,&y1,&x2,&y2,&color,&b);
				add_bloc(name,cx,cy,x1,y1,x2,y2,color,(bool) b);
				break;   // bloc
			  case 4:
				fscanf(Fichier,"%s %lg %lg %lg %i %d\n",name,&x,&y,&r,&color,&b);
				add_food(x,y,r,(bool) b);
				break;   // food
			  case 5:
				fscanf(Fichier,"%s %lg %lg %lg\n",name,&x,&y,&power);
				add_light(name,x,y,power);
				break; // light
			  default: break;
				
			  }
			
		  }
	   
	   // used for having the environnement at the center of the 3D representation
	   gl_shift_cam_x = -(dx)/(2*SCALE_GL);
	   gl_shift_cam_y = -(dy)/(2*SCALE_GL);
	   
	   //GL initialisations

	   glDeleteLists(id_env,1);
	   initGL3D();
	   
	 } else {
		throw breakerror ("You are trying to load as environment a bad type file");
	 }
	} else {
	  cout<<"File "<<name<<" not found"<<endl;
	  
	}
  
  
	 }
	




void environment::change_dimension(double _dx, double _dy) 
	    {
		dx=_dx;
		dy=_dy;
	    initGL3D();
	    }

	


















