#ifndef FAKE_GL_H
#define FAKE_GL_H

#include <stdlib.h>
#include "global.h"

#ifdef DONT_USE_GL

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned int	GLenum;
typedef unsigned char	GLboolean;
typedef unsigned int	GLbitfield;
typedef void		GLvoid;
typedef signed char	GLbyte;		/* 1-byte signed */
typedef short		GLshort;	/* 2-byte signed */
typedef int		GLint;		/* 4-byte signed */
typedef unsigned char	GLubyte;	/* 1-byte unsigned */
typedef unsigned short	GLushort;	/* 2-byte unsigned */
typedef unsigned int	GLuint;		/* 4-byte unsigned */
typedef int		GLsizei;	/* 4-byte signed */
typedef float		GLfloat;	/* single precision float */
typedef float		GLclampf;	/* single precision float in [0,1] */
typedef double		GLdouble;	/* double precision float */
typedef double		GLclampd;	/* double precision float in [0,1] */


typedef GLvoid (*_GLUfuncptr)(GLvoid);

  
#ifdef __cplusplus
}
#endif
  
/*
 *
 * Constants
 *
 */

/* Boolean values */
#define GL_FALSE				0x0
#define GL_TRUE					0x1

/* Data types */
#define GL_BYTE					0x1400
#define GL_UNSIGNED_BYTE			0x1401
#define GL_SHORT				0x1402
#define GL_UNSIGNED_SHORT			0x1403
#define GL_INT					0x1404
#define GL_UNSIGNED_INT				0x1405
#define GL_FLOAT				0x1406
#define GL_DOUBLE				0x140A
#define GL_2_BYTES				0x1407
#define GL_3_BYTES				0x1408
#define GL_4_BYTES				0x1409

/* Primitives */
#define GL_POINTS				0x0000
#define GL_LINES				0x0001
#define GL_LINE_LOOP				0x0002
#define GL_LINE_STRIP				0x0003
#define GL_TRIANGLES				0x0004
#define GL_TRIANGLE_STRIP			0x0005
#define GL_TRIANGLE_FAN				0x0006
#define GL_QUADS				0x0007
#define GL_QUAD_STRIP				0x0008
#define GL_POLYGON				0x0009

/* Vertex Arrays */
#define GL_VERTEX_ARRAY				0x8074
#define GL_NORMAL_ARRAY				0x8075
#define GL_COLOR_ARRAY				0x8076
#define GL_INDEX_ARRAY				0x8077
#define GL_TEXTURE_COORD_ARRAY			0x8078
#define GL_EDGE_FLAG_ARRAY			0x8079
#define GL_VERTEX_ARRAY_SIZE			0x807A
#define GL_VERTEX_ARRAY_TYPE			0x807B
#define GL_VERTEX_ARRAY_STRIDE			0x807C
#define GL_NORMAL_ARRAY_TYPE			0x807E
#define GL_NORMAL_ARRAY_STRIDE			0x807F
#define GL_COLOR_ARRAY_SIZE			0x8081
#define GL_COLOR_ARRAY_TYPE			0x8082
#define GL_COLOR_ARRAY_STRIDE			0x8083
#define GL_INDEX_ARRAY_TYPE			0x8085
#define GL_INDEX_ARRAY_STRIDE			0x8086
#define GL_TEXTURE_COORD_ARRAY_SIZE		0x8088
#define GL_TEXTURE_COORD_ARRAY_TYPE		0x8089
#define GL_TEXTURE_COORD_ARRAY_STRIDE		0x808A
#define GL_EDGE_FLAG_ARRAY_STRIDE		0x808C
#define GL_VERTEX_ARRAY_POINTER			0x808E
#define GL_NORMAL_ARRAY_POINTER			0x808F
#define GL_COLOR_ARRAY_POINTER			0x8090
#define GL_INDEX_ARRAY_POINTER			0x8091
#define GL_TEXTURE_COORD_ARRAY_POINTER		0x8092
#define GL_EDGE_FLAG_ARRAY_POINTER		0x8093
#define GL_V2F					0x2A20
#define GL_V3F					0x2A21
#define GL_C4UB_V2F				0x2A22
#define GL_C4UB_V3F				0x2A23
#define GL_C3F_V3F				0x2A24
#define GL_N3F_V3F				0x2A25
#define GL_C4F_N3F_V3F				0x2A26
#define GL_T2F_V3F				0x2A27
#define GL_T4F_V4F				0x2A28
#define GL_T2F_C4UB_V3F				0x2A29
#define GL_T2F_C3F_V3F				0x2A2A
#define GL_T2F_N3F_V3F				0x2A2B
#define GL_T2F_C4F_N3F_V3F			0x2A2C
#define GL_T4F_C4F_N3F_V4F			0x2A2D

/* Matrix Mode */
#define GL_MATRIX_MODE				0x0BA0
#define GL_MODELVIEW				0x1700
#define GL_PROJECTION				0x1701
#define GL_TEXTURE				0x1702

/* Points */
#define GL_POINT_SMOOTH				0x0B10
#define GL_POINT_SIZE				0x0B11
#define GL_POINT_SIZE_GRANULARITY 		0x0B13
#define GL_POINT_SIZE_RANGE			0x0B12

/* Lines */
#define GL_LINE_SMOOTH				0x0B20
#define GL_LINE_STIPPLE				0x0B24
#define GL_LINE_STIPPLE_PATTERN			0x0B25
#define GL_LINE_STIPPLE_REPEAT			0x0B26
#define GL_LINE_WIDTH				0x0B21
#define GL_LINE_WIDTH_GRANULARITY		0x0B23
#define GL_LINE_WIDTH_RANGE			0x0B22

/* Polygons */
#define GL_POINT				0x1B00
#define GL_LINE					0x1B01
#define GL_FILL					0x1B02
#define GL_CW					0x0900
#define GL_CCW					0x0901
#define GL_FRONT				0x0404
#define GL_BACK					0x0405
#define GL_POLYGON_MODE				0x0B40
#define GL_POLYGON_SMOOTH			0x0B41
#define GL_POLYGON_STIPPLE			0x0B42
#define GL_EDGE_FLAG				0x0B43
#define GL_CULL_FACE				0x0B44
#define GL_CULL_FACE_MODE			0x0B45
#define GL_FRONT_FACE				0x0B46
#define GL_POLYGON_OFFSET_FACTOR		0x8038
#define GL_POLYGON_OFFSET_UNITS			0x2A00
#define GL_POLYGON_OFFSET_POINT			0x2A01
#define GL_POLYGON_OFFSET_LINE			0x2A02
#define GL_POLYGON_OFFSET_FILL			0x8037

/* Display Lists */
#define GL_COMPILE				0x1300
#define GL_COMPILE_AND_EXECUTE			0x1301
#define GL_LIST_BASE				0x0B32
#define GL_LIST_INDEX				0x0B33
#define GL_LIST_MODE				0x0B30

/* Depth buffer */
#define GL_NEVER				0x0200
#define GL_LESS					0x0201
#define GL_EQUAL				0x0202
#define GL_LEQUAL				0x0203
#define GL_GREATER				0x0204
#define GL_NOTEQUAL				0x0205
#define GL_GEQUAL				0x0206
#define GL_ALWAYS				0x0207
#define GL_DEPTH_TEST				0x0B71
#define GL_DEPTH_BITS				0x0D56
#define GL_DEPTH_CLEAR_VALUE			0x0B73
#define GL_DEPTH_FUNC				0x0B74
#define GL_DEPTH_RANGE				0x0B70
#define GL_DEPTH_WRITEMASK			0x0B72
#define GL_DEPTH_COMPONENT			0x1902

/* Lighting */
#define GL_LIGHTING				0x0B50
#define GL_LIGHT0				0x4000
#define GL_LIGHT1				0x4001
#define GL_LIGHT2				0x4002
#define GL_LIGHT3				0x4003
#define GL_LIGHT4				0x4004
#define GL_LIGHT5				0x4005
#define GL_LIGHT6				0x4006
#define GL_LIGHT7				0x4007
#define GL_SPOT_EXPONENT			0x1205
#define GL_SPOT_CUTOFF				0x1206
#define GL_CONSTANT_ATTENUATION			0x1207
#define GL_LINEAR_ATTENUATION			0x1208
#define GL_QUADRATIC_ATTENUATION		0x1209
#define GL_AMBIENT				0x1200
#define GL_DIFFUSE				0x1201
#define GL_SPECULAR				0x1202
#define GL_SHININESS				0x1601
#define GL_EMISSION				0x1600
#define GL_POSITION				0x1203
#define GL_SPOT_DIRECTION			0x1204
#define GL_AMBIENT_AND_DIFFUSE			0x1602
#define GL_COLOR_INDEXES			0x1603
#define GL_LIGHT_MODEL_TWO_SIDE			0x0B52
#define GL_LIGHT_MODEL_LOCAL_VIEWER		0x0B51
#define GL_LIGHT_MODEL_AMBIENT			0x0B53
#define GL_FRONT_AND_BACK			0x0408
#define GL_SHADE_MODEL				0x0B54
#define GL_FLAT					0x1D00
#define GL_SMOOTH				0x1D01
#define GL_COLOR_MATERIAL			0x0B57
#define GL_COLOR_MATERIAL_FACE			0x0B55
#define GL_COLOR_MATERIAL_PARAMETER		0x0B56
#define GL_NORMALIZE				0x0BA1

/* User clipping planes */
#define GL_CLIP_PLANE0				0x3000
#define GL_CLIP_PLANE1				0x3001
#define GL_CLIP_PLANE2				0x3002
#define GL_CLIP_PLANE3				0x3003
#define GL_CLIP_PLANE4				0x3004
#define GL_CLIP_PLANE5				0x3005

/* Accumulation buffer */
#define GL_ACCUM_RED_BITS			0x0D58
#define GL_ACCUM_GREEN_BITS			0x0D59
#define GL_ACCUM_BLUE_BITS			0x0D5A
#define GL_ACCUM_ALPHA_BITS			0x0D5B
#define GL_ACCUM_CLEAR_VALUE			0x0B80
#define GL_ACCUM				0x0100
#define GL_ADD					0x0104
#define GL_LOAD					0x0101
#define GL_MULT					0x0103
#define GL_RETURN				0x0102

/* Alpha testing */
#define GL_ALPHA_TEST				0x0BC0
#define GL_ALPHA_TEST_REF			0x0BC2
#define GL_ALPHA_TEST_FUNC			0x0BC1

/* Blending */
#define GL_BLEND				0x0BE2
#define GL_BLEND_SRC				0x0BE1
#define GL_BLEND_DST				0x0BE0
#define GL_ZERO					0x0
#define GL_ONE					0x1
#define GL_SRC_COLOR				0x0300
#define GL_ONE_MINUS_SRC_COLOR			0x0301
#define GL_SRC_ALPHA				0x0302
#define GL_ONE_MINUS_SRC_ALPHA			0x0303
#define GL_DST_ALPHA				0x0304
#define GL_ONE_MINUS_DST_ALPHA			0x0305
#define GL_DST_COLOR				0x0306
#define GL_ONE_MINUS_DST_COLOR			0x0307
#define GL_SRC_ALPHA_SATURATE			0x0308
#define GL_CONSTANT_COLOR			0x8001
#define GL_ONE_MINUS_CONSTANT_COLOR		0x8002
#define GL_CONSTANT_ALPHA			0x8003
#define GL_ONE_MINUS_CONSTANT_ALPHA		0x8004

/* Render Mode */
#define GL_FEEDBACK				0x1C01
#define GL_RENDER				0x1C00
#define GL_SELECT				0x1C02

/* Feedback */
#define GL_2D					0x0600
#define GL_3D					0x0601
#define GL_3D_COLOR				0x0602
#define GL_3D_COLOR_TEXTURE			0x0603
#define GL_4D_COLOR_TEXTURE			0x0604
#define GL_POINT_TOKEN				0x0701
#define GL_LINE_TOKEN				0x0702
#define GL_LINE_RESET_TOKEN			0x0707
#define GL_POLYGON_TOKEN			0x0703
#define GL_BITMAP_TOKEN				0x0704
#define GL_DRAW_PIXEL_TOKEN			0x0705
#define GL_COPY_PIXEL_TOKEN			0x0706
#define GL_PASS_THROUGH_TOKEN			0x0700
#define GL_FEEDBACK_BUFFER_POINTER		0x0DF0
#define GL_FEEDBACK_BUFFER_SIZE			0x0DF1
#define GL_FEEDBACK_BUFFER_TYPE			0x0DF2

/* Selection */
#define GL_SELECTION_BUFFER_POINTER		0x0DF3
#define GL_SELECTION_BUFFER_SIZE		0x0DF4

/* Fog */
#define GL_FOG					0x0B60
#define GL_FOG_MODE				0x0B65
#define GL_FOG_DENSITY				0x0B62
#define GL_FOG_COLOR				0x0B66
#define GL_FOG_INDEX				0x0B61
#define GL_FOG_START				0x0B63
#define GL_FOG_END				0x0B64
#define GL_LINEAR				0x2601
#define GL_EXP					0x0800
#define GL_EXP2					0x0801

/* Logic Ops */
#define GL_LOGIC_OP				0x0BF1
#define GL_INDEX_LOGIC_OP			0x0BF1
#define GL_COLOR_LOGIC_OP			0x0BF2
#define GL_LOGIC_OP_MODE			0x0BF0
#define GL_CLEAR				0x1500
#define GL_SET					0x150F
#define GL_COPY					0x1503
#define GL_COPY_INVERTED			0x150C
#define GL_NOOP					0x1505
#define GL_INVERT				0x150A
#define GL_AND					0x1501
#define GL_NAND					0x150E
#define GL_OR					0x1507
#define GL_NOR					0x1508
#define GL_XOR					0x1506
#define GL_EQUIV				0x1509
#define GL_AND_REVERSE				0x1502
#define GL_AND_INVERTED				0x1504
#define GL_OR_REVERSE				0x150B
#define GL_OR_INVERTED				0x150D

/* Stencil */
#define GL_STENCIL_TEST				0x0B90
#define GL_STENCIL_WRITEMASK			0x0B98
#define GL_STENCIL_BITS				0x0D57
#define GL_STENCIL_FUNC				0x0B92
#define GL_STENCIL_VALUE_MASK			0x0B93
#define GL_STENCIL_REF				0x0B97
#define GL_STENCIL_FAIL				0x0B94
#define GL_STENCIL_PASS_DEPTH_PASS		0x0B96
#define GL_STENCIL_PASS_DEPTH_FAIL		0x0B95
#define GL_STENCIL_CLEAR_VALUE			0x0B91
#define GL_STENCIL_INDEX			0x1901
#define GL_KEEP					0x1E00
#define GL_REPLACE				0x1E01
#define GL_INCR					0x1E02
#define GL_DECR					0x1E03

/* Buffers, Pixel Drawing/Reading */
#define GL_NONE					0x0
#define GL_LEFT					0x0406
#define GL_RIGHT				0x0407
/*GL_FRONT					0x0404 */
/*GL_BACK					0x0405 */
/*GL_FRONT_AND_BACK				0x0408 */
#define GL_FRONT_LEFT				0x0400
#define GL_FRONT_RIGHT				0x0401
#define GL_BACK_LEFT				0x0402
#define GL_BACK_RIGHT				0x0403
#define GL_AUX0					0x0409
#define GL_AUX1					0x040A
#define GL_AUX2					0x040B
#define GL_AUX3					0x040C
#define GL_COLOR_INDEX				0x1900
#define GL_RED					0x1903
#define GL_GREEN				0x1904
#define GL_BLUE					0x1905
#define GL_ALPHA				0x1906
#define GL_LUMINANCE				0x1909
#define GL_LUMINANCE_ALPHA			0x190A
#define GL_ALPHA_BITS				0x0D55
#define GL_RED_BITS				0x0D52
#define GL_GREEN_BITS				0x0D53
#define GL_BLUE_BITS				0x0D54
#define GL_INDEX_BITS				0x0D51
#define GL_SUBPIXEL_BITS			0x0D50
#define GL_AUX_BUFFERS				0x0C00
#define GL_READ_BUFFER				0x0C02
#define GL_DRAW_BUFFER				0x0C01
#define GL_DOUBLEBUFFER				0x0C32
#define GL_STEREO				0x0C33
#define GL_BITMAP				0x1A00
#define GL_COLOR				0x1800
#define GL_DEPTH				0x1801
#define GL_STENCIL				0x1802
#define GL_DITHER				0x0BD0
#define GL_RGB					0x1907
#define GL_RGBA					0x1908

/* Implementation limits */
#define GL_MAX_LIST_NESTING			0x0B31
#define GL_MAX_ATTRIB_STACK_DEPTH		0x0D35
#define GL_MAX_MODELVIEW_STACK_DEPTH		0x0D36
#define GL_MAX_NAME_STACK_DEPTH			0x0D37
#define GL_MAX_PROJECTION_STACK_DEPTH		0x0D38
#define GL_MAX_TEXTURE_STACK_DEPTH		0x0D39
#define GL_MAX_EVAL_ORDER			0x0D30
#define GL_MAX_LIGHTS				0x0D31
#define GL_MAX_CLIP_PLANES			0x0D32
#define GL_MAX_TEXTURE_SIZE			0x0D33
#define GL_MAX_PIXEL_MAP_TABLE			0x0D34
#define GL_MAX_VIEWPORT_DIMS			0x0D3A
#define GL_MAX_CLIENT_ATTRIB_STACK_DEPTH	0x0D3B

/* Gets */
#define GL_ATTRIB_STACK_DEPTH			0x0BB0
#define GL_CLIENT_ATTRIB_STACK_DEPTH		0x0BB1
#define GL_COLOR_CLEAR_VALUE			0x0C22
#define GL_COLOR_WRITEMASK			0x0C23
#define GL_CURRENT_INDEX			0x0B01
#define GL_CURRENT_COLOR			0x0B00
#define GL_CURRENT_NORMAL			0x0B02
#define GL_CURRENT_RASTER_COLOR			0x0B04
#define GL_CURRENT_RASTER_DISTANCE		0x0B09
#define GL_CURRENT_RASTER_INDEX			0x0B05
#define GL_CURRENT_RASTER_POSITION		0x0B07
#define GL_CURRENT_RASTER_TEXTURE_COORDS	0x0B06
#define GL_CURRENT_RASTER_POSITION_VALID	0x0B08
#define GL_CURRENT_TEXTURE_COORDS		0x0B03
#define GL_INDEX_CLEAR_VALUE			0x0C20
#define GL_INDEX_MODE				0x0C30
#define GL_INDEX_WRITEMASK			0x0C21
#define GL_MODELVIEW_MATRIX			0x0BA6
#define GL_MODELVIEW_STACK_DEPTH		0x0BA3
#define GL_NAME_STACK_DEPTH			0x0D70
#define GL_PROJECTION_MATRIX			0x0BA7
#define GL_PROJECTION_STACK_DEPTH		0x0BA4
#define GL_RENDER_MODE				0x0C40
#define GL_RGBA_MODE				0x0C31
#define GL_TEXTURE_MATRIX			0x0BA8
#define GL_TEXTURE_STACK_DEPTH			0x0BA5
#define GL_VIEWPORT				0x0BA2

/* Evaluators */
#define GL_AUTO_NORMAL				0x0D80
#define GL_MAP1_COLOR_4				0x0D90
#define GL_MAP1_GRID_DOMAIN			0x0DD0
#define GL_MAP1_GRID_SEGMENTS			0x0DD1
#define GL_MAP1_INDEX				0x0D91
#define GL_MAP1_NORMAL				0x0D92
#define GL_MAP1_TEXTURE_COORD_1			0x0D93
#define GL_MAP1_TEXTURE_COORD_2			0x0D94
#define GL_MAP1_TEXTURE_COORD_3			0x0D95
#define GL_MAP1_TEXTURE_COORD_4			0x0D96
#define GL_MAP1_VERTEX_3			0x0D97
#define GL_MAP1_VERTEX_4			0x0D98
#define GL_MAP2_COLOR_4				0x0DB0
#define GL_MAP2_GRID_DOMAIN			0x0DD2
#define GL_MAP2_GRID_SEGMENTS			0x0DD3
#define GL_MAP2_INDEX				0x0DB1
#define GL_MAP2_NORMAL				0x0DB2
#define GL_MAP2_TEXTURE_COORD_1			0x0DB3
#define GL_MAP2_TEXTURE_COORD_2			0x0DB4
#define GL_MAP2_TEXTURE_COORD_3			0x0DB5
#define GL_MAP2_TEXTURE_COORD_4			0x0DB6
#define GL_MAP2_VERTEX_3			0x0DB7
#define GL_MAP2_VERTEX_4			0x0DB8
#define GL_COEFF				0x0A00
#define GL_DOMAIN				0x0A02
#define GL_ORDER				0x0A01

/* Hints */
#define GL_FOG_HINT				0x0C54
#define GL_LINE_SMOOTH_HINT			0x0C52
#define GL_PERSPECTIVE_CORRECTION_HINT		0x0C50
#define GL_POINT_SMOOTH_HINT			0x0C51
#define GL_POLYGON_SMOOTH_HINT			0x0C53
#define GL_DONT_CARE				0x1100
#define GL_FASTEST				0x1101
#define GL_NICEST				0x1102

/* Scissor box */
#define GL_SCISSOR_TEST				0x0C11
#define GL_SCISSOR_BOX				0x0C10

/* Pixel Mode / Transfer */
#define GL_MAP_COLOR				0x0D10
#define GL_MAP_STENCIL				0x0D11
#define GL_INDEX_SHIFT				0x0D12
#define GL_INDEX_OFFSET				0x0D13
#define GL_RED_SCALE				0x0D14
#define GL_RED_BIAS				0x0D15
#define GL_GREEN_SCALE				0x0D18
#define GL_GREEN_BIAS				0x0D19
#define GL_BLUE_SCALE				0x0D1A
#define GL_BLUE_BIAS				0x0D1B
#define GL_ALPHA_SCALE				0x0D1C
#define GL_ALPHA_BIAS				0x0D1D
#define GL_DEPTH_SCALE				0x0D1E
#define GL_DEPTH_BIAS				0x0D1F
#define GL_PIXEL_MAP_S_TO_S_SIZE		0x0CB1
#define GL_PIXEL_MAP_I_TO_I_SIZE		0x0CB0
#define GL_PIXEL_MAP_I_TO_R_SIZE		0x0CB2
#define GL_PIXEL_MAP_I_TO_G_SIZE		0x0CB3
#define GL_PIXEL_MAP_I_TO_B_SIZE		0x0CB4
#define GL_PIXEL_MAP_I_TO_A_SIZE		0x0CB5
#define GL_PIXEL_MAP_R_TO_R_SIZE		0x0CB6
#define GL_PIXEL_MAP_G_TO_G_SIZE		0x0CB7
#define GL_PIXEL_MAP_B_TO_B_SIZE		0x0CB8
#define GL_PIXEL_MAP_A_TO_A_SIZE		0x0CB9
#define GL_PIXEL_MAP_S_TO_S			0x0C71
#define GL_PIXEL_MAP_I_TO_I			0x0C70
#define GL_PIXEL_MAP_I_TO_R			0x0C72
#define GL_PIXEL_MAP_I_TO_G			0x0C73
#define GL_PIXEL_MAP_I_TO_B			0x0C74
#define GL_PIXEL_MAP_I_TO_A			0x0C75
#define GL_PIXEL_MAP_R_TO_R			0x0C76
#define GL_PIXEL_MAP_G_TO_G			0x0C77
#define GL_PIXEL_MAP_B_TO_B			0x0C78
#define GL_PIXEL_MAP_A_TO_A			0x0C79
#define GL_PACK_ALIGNMENT			0x0D05
#define GL_PACK_LSB_FIRST			0x0D01
#define GL_PACK_ROW_LENGTH			0x0D02
#define GL_PACK_SKIP_PIXELS			0x0D04
#define GL_PACK_SKIP_ROWS			0x0D03
#define GL_PACK_SWAP_BYTES			0x0D00
#define GL_UNPACK_ALIGNMENT			0x0CF5
#define GL_UNPACK_LSB_FIRST			0x0CF1
#define GL_UNPACK_ROW_LENGTH			0x0CF2
#define GL_UNPACK_SKIP_PIXELS			0x0CF4
#define GL_UNPACK_SKIP_ROWS			0x0CF3
#define GL_UNPACK_SWAP_BYTES			0x0CF0
#define GL_ZOOM_X				0x0D16
#define GL_ZOOM_Y				0x0D17

/* Texture mapping */
#define GL_TEXTURE_ENV				0x2300
#define GL_TEXTURE_ENV_MODE			0x2200
#define GL_TEXTURE_1D				0x0DE0
#define GL_TEXTURE_2D				0x0DE1
#define GL_TEXTURE_WRAP_S			0x2802
#define GL_TEXTURE_WRAP_T			0x2803
#define GL_TEXTURE_MAG_FILTER			0x2800
#define GL_TEXTURE_MIN_FILTER			0x2801
#define GL_TEXTURE_ENV_COLOR			0x2201
#define GL_TEXTURE_GEN_S			0x0C60
#define GL_TEXTURE_GEN_T			0x0C61
#define GL_TEXTURE_GEN_MODE			0x2500
#define GL_TEXTURE_BORDER_COLOR			0x1004
#define GL_TEXTURE_WIDTH			0x1000
#define GL_TEXTURE_HEIGHT			0x1001
#define GL_TEXTURE_BORDER			0x1005
#define GL_TEXTURE_COMPONENTS			0x1003
#define GL_TEXTURE_RED_SIZE			0x805C
#define GL_TEXTURE_GREEN_SIZE			0x805D
#define GL_TEXTURE_BLUE_SIZE			0x805E
#define GL_TEXTURE_ALPHA_SIZE			0x805F
#define GL_TEXTURE_LUMINANCE_SIZE		0x8060
#define GL_TEXTURE_INTENSITY_SIZE		0x8061
#define GL_NEAREST_MIPMAP_NEAREST		0x2700
#define GL_NEAREST_MIPMAP_LINEAR		0x2702
#define GL_LINEAR_MIPMAP_NEAREST		0x2701
#define GL_LINEAR_MIPMAP_LINEAR			0x2703
#define GL_OBJECT_LINEAR			0x2401
#define GL_OBJECT_PLANE				0x2501
#define GL_EYE_LINEAR				0x2400
#define GL_EYE_PLANE				0x2502
#define GL_SPHERE_MAP				0x2402
#define GL_DECAL				0x2101
#define GL_MODULATE				0x2100
#define GL_NEAREST				0x2600
#define GL_REPEAT				0x2901
#define GL_CLAMP				0x2900
#define GL_S					0x2000
#define GL_T					0x2001
#define GL_R					0x2002
#define GL_Q					0x2003
#define GL_TEXTURE_GEN_R			0x0C62
#define GL_TEXTURE_GEN_Q			0x0C63

/* Utility */
#define GL_VENDOR				0x1F00
#define GL_RENDERER				0x1F01
#define GL_VERSION				0x1F02
#define GL_EXTENSIONS				0x1F03

/* Errors */
#define GL_NO_ERROR 				0x0
#define GL_INVALID_VALUE			0x0501
#define GL_INVALID_ENUM				0x0500
#define GL_INVALID_OPERATION			0x0502
#define GL_STACK_OVERFLOW			0x0503
#define GL_STACK_UNDERFLOW			0x0504
#define GL_OUT_OF_MEMORY			0x0505

/* glPush/PopAttrib bits */
#define GL_CURRENT_BIT				0x00000001
#define GL_POINT_BIT				0x00000002
#define GL_LINE_BIT				0x00000004
#define GL_POLYGON_BIT				0x00000008
#define GL_POLYGON_STIPPLE_BIT			0x00000010
#define GL_PIXEL_MODE_BIT			0x00000020
#define GL_LIGHTING_BIT				0x00000040
#define GL_FOG_BIT				0x00000080
#define GL_DEPTH_BUFFER_BIT			0x00000100
#define GL_ACCUM_BUFFER_BIT			0x00000200
#define GL_STENCIL_BUFFER_BIT			0x00000400
#define GL_VIEWPORT_BIT				0x00000800
#define GL_TRANSFORM_BIT			0x00001000
#define GL_ENABLE_BIT				0x00002000
#define GL_COLOR_BUFFER_BIT			0x00004000
#define GL_HINT_BIT				0x00008000
#define GL_EVAL_BIT				0x00010000
#define GL_LIST_BIT				0x00020000
#define GL_TEXTURE_BIT				0x00040000
#define GL_SCISSOR_BIT				0x00080000
#define GL_ALL_ATTRIB_BITS			0x000FFFFF


/* OpenGL 1.1 */
#define GL_PROXY_TEXTURE_1D			0x8063
#define GL_PROXY_TEXTURE_2D			0x8064
#define GL_TEXTURE_PRIORITY			0x8066
#define GL_TEXTURE_RESIDENT			0x8067
#define GL_TEXTURE_BINDING_1D			0x8068
#define GL_TEXTURE_BINDING_2D			0x8069
#define GL_TEXTURE_INTERNAL_FORMAT		0x1003
#define GL_ALPHA4				0x803B
#define GL_ALPHA8				0x803C
#define GL_ALPHA12				0x803D
#define GL_ALPHA16				0x803E
#define GL_LUMINANCE4				0x803F
#define GL_LUMINANCE8				0x8040
#define GL_LUMINANCE12				0x8041
#define GL_LUMINANCE16				0x8042
#define GL_LUMINANCE4_ALPHA4			0x8043
#define GL_LUMINANCE6_ALPHA2			0x8044
#define GL_LUMINANCE8_ALPHA8			0x8045
#define GL_LUMINANCE12_ALPHA4			0x8046
#define GL_LUMINANCE12_ALPHA12			0x8047
#define GL_LUMINANCE16_ALPHA16			0x8048
#define GL_INTENSITY				0x8049
#define GL_INTENSITY4				0x804A
#define GL_INTENSITY8				0x804B
#define GL_INTENSITY12				0x804C
#define GL_INTENSITY16				0x804D
#define GL_R3_G3_B2				0x2A10
#define GL_RGB4					0x804F
#define GL_RGB5					0x8050
#define GL_RGB8					0x8051
#define GL_RGB10				0x8052
#define GL_RGB12				0x8053
#define GL_RGB16				0x8054
#define GL_RGBA2				0x8055
#define GL_RGBA4				0x8056
#define GL_RGB5_A1				0x8057
#define GL_RGBA8				0x8058
#define GL_RGB10_A2				0x8059
#define GL_RGBA12				0x805A
#define GL_RGBA16				0x805B
#define GL_CLIENT_PIXEL_STORE_BIT		0x00000001
#define GL_CLIENT_VERTEX_ARRAY_BIT		0x00000002
#define GL_ALL_CLIENT_ATTRIB_BITS 		0xFFFFFFFF
#define GL_CLIENT_ALL_ATTRIB_BITS 		0xFFFFFFFF


/* OpenGL 1.2 */
#define GL_RESCALE_NORMAL			0x803A
#define GL_CLAMP_TO_EDGE			0x812F
#define GL_MAX_ELEMENTS_VERTICES		0x80E8
#define GL_MAX_ELEMENTS_INDICES			0x80E9
#define GL_BGR					0x80E0
#define GL_BGRA					0x80E1
#define GL_UNSIGNED_BYTE_3_3_2			0x8032
#define GL_UNSIGNED_BYTE_2_3_3_REV		0x8362
#define GL_UNSIGNED_SHORT_5_6_5			0x8363
#define GL_UNSIGNED_SHORT_5_6_5_REV		0x8364
#define GL_UNSIGNED_SHORT_4_4_4_4		0x8033
#define GL_UNSIGNED_SHORT_4_4_4_4_REV		0x8365
#define GL_UNSIGNED_SHORT_5_5_5_1		0x8034
#define GL_UNSIGNED_SHORT_1_5_5_5_REV		0x8366
#define GL_UNSIGNED_INT_8_8_8_8			0x8035
#define GL_UNSIGNED_INT_8_8_8_8_REV		0x8367
#define GL_UNSIGNED_INT_10_10_10_2		0x8036
#define GL_UNSIGNED_INT_2_10_10_10_REV		0x8368
#define GL_LIGHT_MODEL_COLOR_CONTROL		0x81F8
#define GL_SINGLE_COLOR				0x81F9
#define GL_SEPARATE_SPECULAR_COLOR		0x81FA
#define GL_TEXTURE_MIN_LOD			0x813A
#define GL_TEXTURE_MAX_LOD			0x813B
#define GL_TEXTURE_BASE_LEVEL			0x813C
#define GL_TEXTURE_MAX_LEVEL			0x813D
#define GL_SMOOTH_POINT_SIZE_RANGE		0x0B12
#define GL_SMOOTH_POINT_SIZE_GRANULARITY	0x0B13
#define GL_SMOOTH_LINE_WIDTH_RANGE		0x0B22
#define GL_SMOOTH_LINE_WIDTH_GRANULARITY	0x0B23
#define GL_ALIASED_POINT_SIZE_RANGE		0x846D
#define GL_ALIASED_LINE_WIDTH_RANGE		0x846E
#define GL_PACK_SKIP_IMAGES			0x806B
#define GL_PACK_IMAGE_HEIGHT			0x806C
#define GL_UNPACK_SKIP_IMAGES			0x806D
#define GL_UNPACK_IMAGE_HEIGHT			0x806E
#define GL_TEXTURE_3D				0x806F
#define GL_PROXY_TEXTURE_3D			0x8070
#define GL_TEXTURE_DEPTH			0x8071
#define GL_TEXTURE_WRAP_R			0x8072
#define GL_MAX_3D_TEXTURE_SIZE			0x8073
#define GL_TEXTURE_BINDING_3D			0x806A


/*
 * OpenGL 1.2 imaging subset
 */
/* GL_EXT_color_table */
#define GL_COLOR_TABLE				0x80D0
#define GL_POST_CONVOLUTION_COLOR_TABLE		0x80D1
#define GL_POST_COLOR_MATRIX_COLOR_TABLE	0x80D2
#define GL_PROXY_COLOR_TABLE			0x80D3
#define GL_PROXY_POST_CONVOLUTION_COLOR_TABLE	0x80D4
#define GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE	0x80D5
#define GL_COLOR_TABLE_SCALE			0x80D6
#define GL_COLOR_TABLE_BIAS			0x80D7
#define GL_COLOR_TABLE_FORMAT			0x80D8
#define GL_COLOR_TABLE_WIDTH			0x80D9
#define GL_COLOR_TABLE_RED_SIZE			0x80DA
#define GL_COLOR_TABLE_GREEN_SIZE		0x80DB
#define GL_COLOR_TABLE_BLUE_SIZE		0x80DC
#define GL_COLOR_TABLE_ALPHA_SIZE		0x80DD
#define GL_COLOR_TABLE_LUMINANCE_SIZE		0x80DE
#define GL_COLOR_TABLE_INTENSITY_SIZE		0x80DF
/* GL_EXT_convolution and GL_HP_convolution_border_modes */
#define GL_CONVOLUTION_1D			0x8010
#define GL_CONVOLUTION_2D			0x8011
#define GL_SEPARABLE_2D				0x8012
#define GL_CONVOLUTION_BORDER_MODE		0x8013
#define GL_CONVOLUTION_FILTER_SCALE		0x8014
#define GL_CONVOLUTION_FILTER_BIAS		0x8015
#define GL_REDUCE				0x8016
#define GL_CONVOLUTION_FORMAT			0x8017
#define GL_CONVOLUTION_WIDTH			0x8018
#define GL_CONVOLUTION_HEIGHT			0x8019
#define GL_MAX_CONVOLUTION_WIDTH		0x801A
#define GL_MAX_CONVOLUTION_HEIGHT		0x801B
#define GL_POST_CONVOLUTION_RED_SCALE		0x801C
#define GL_POST_CONVOLUTION_GREEN_SCALE		0x801D
#define GL_POST_CONVOLUTION_BLUE_SCALE		0x801E
#define GL_POST_CONVOLUTION_ALPHA_SCALE		0x801F
#define GL_POST_CONVOLUTION_RED_BIAS		0x8020
#define GL_POST_CONVOLUTION_GREEN_BIAS		0x8021
#define GL_POST_CONVOLUTION_BLUE_BIAS		0x8022
#define GL_POST_CONVOLUTION_ALPHA_BIAS		0x8023
#define GL_CONSTANT_BORDER			0x8151
#define GL_REPLICATE_BORDER			0x8153
#define GL_CONVOLUTION_BORDER_COLOR		0x8154
/* GL_SGI_color_matrix */
#define GL_COLOR_MATRIX				0x80B1
#define GL_COLOR_MATRIX_STACK_DEPTH		0x80B2
#define GL_MAX_COLOR_MATRIX_STACK_DEPTH		0x80B3
#define GL_POST_COLOR_MATRIX_RED_SCALE		0x80B4
#define GL_POST_COLOR_MATRIX_GREEN_SCALE	0x80B5
#define GL_POST_COLOR_MATRIX_BLUE_SCALE		0x80B6
#define GL_POST_COLOR_MATRIX_ALPHA_SCALE	0x80B7
#define GL_POST_COLOR_MATRIX_RED_BIAS		0x80B8
#define GL_POST_COLOR_MATRIX_GREEN_BIAS		0x80B9
#define GL_POST_COLOR_MATRIX_BLUE_BIAS		0x80BA
#define GL_POST_COLOR_MATRIX_ALPHA_BIAS		0x80BB
/* GL_EXT_histogram */
#define GL_HISTOGRAM				0x8024
#define GL_PROXY_HISTOGRAM			0x8025
#define GL_HISTOGRAM_WIDTH			0x8026
#define GL_HISTOGRAM_FORMAT			0x8027
#define GL_HISTOGRAM_RED_SIZE			0x8028
#define GL_HISTOGRAM_GREEN_SIZE			0x8029
#define GL_HISTOGRAM_BLUE_SIZE			0x802A
#define GL_HISTOGRAM_ALPHA_SIZE			0x802B
#define GL_HISTOGRAM_LUMINANCE_SIZE		0x802C
#define GL_HISTOGRAM_SINK			0x802D
#define GL_MINMAX				0x802E
#define GL_MINMAX_FORMAT			0x802F
#define GL_MINMAX_SINK				0x8030
#define GL_TABLE_TOO_LARGE			0x8031
/* GL_EXT_blend_color, GL_EXT_blend_minmax */
#define GL_BLEND_EQUATION			0x8009
#define GL_MIN					0x8007
#define GL_MAX					0x8008
#define GL_FUNC_ADD				0x8006
#define GL_FUNC_SUBTRACT			0x800A
#define GL_FUNC_REVERSE_SUBTRACT		0x800B
#define GL_BLEND_COLOR				0x8005


/* OpenGL 1.3 */
/* multitexture */
#define GL_TEXTURE0				0x84C0
#define GL_TEXTURE1				0x84C1
#define GL_TEXTURE2				0x84C2
#define GL_TEXTURE3				0x84C3
#define GL_TEXTURE4				0x84C4
#define GL_TEXTURE5				0x84C5
#define GL_TEXTURE6				0x84C6
#define GL_TEXTURE7				0x84C7
#define GL_TEXTURE8				0x84C8
#define GL_TEXTURE9				0x84C9
#define GL_TEXTURE10				0x84CA
#define GL_TEXTURE11				0x84CB
#define GL_TEXTURE12				0x84CC
#define GL_TEXTURE13				0x84CD
#define GL_TEXTURE14				0x84CE
#define GL_TEXTURE15				0x84CF
#define GL_TEXTURE16				0x84D0
#define GL_TEXTURE17				0x84D1
#define GL_TEXTURE18				0x84D2
#define GL_TEXTURE19				0x84D3
#define GL_TEXTURE20				0x84D4
#define GL_TEXTURE21				0x84D5
#define GL_TEXTURE22				0x84D6
#define GL_TEXTURE23				0x84D7
#define GL_TEXTURE24				0x84D8
#define GL_TEXTURE25				0x84D9
#define GL_TEXTURE26				0x84DA
#define GL_TEXTURE27				0x84DB
#define GL_TEXTURE28				0x84DC
#define GL_TEXTURE29				0x84DD
#define GL_TEXTURE30				0x84DE
#define GL_TEXTURE31				0x84DF
#define GL_ACTIVE_TEXTURE			0x84E0
#define GL_CLIENT_ACTIVE_TEXTURE		0x84E1
#define GL_MAX_TEXTURE_UNITS			0x84E2
/* texture_cube_map */
#define GL_NORMAL_MAP				0x8511
#define GL_REFLECTION_MAP			0x8512
#define GL_TEXTURE_CUBE_MAP			0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP		0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X		0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X		0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y		0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y		0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z		0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z		0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP		0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE		0x851C
/* texture_compression */
#define GL_COMPRESSED_ALPHA			0x84E9
#define GL_COMPRESSED_LUMINANCE			0x84EA
#define GL_COMPRESSED_LUMINANCE_ALPHA		0x84EB
#define GL_COMPRESSED_INTENSITY			0x84EC
#define GL_COMPRESSED_RGB			0x84ED
#define GL_COMPRESSED_RGBA			0x84EE
#define GL_TEXTURE_COMPRESSION_HINT		0x84EF
#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE	0x86A0
#define GL_TEXTURE_COMPRESSED			0x86A1
#define GL_NUM_COMPRESSED_TEXTURE_FORMATS	0x86A2
#define GL_COMPRESSED_TEXTURE_FORMATS		0x86A3
/* multisample */
#define GL_MULTISAMPLE				0x809D
#define GL_SAMPLE_ALPHA_TO_COVERAGE		0x809E
#define GL_SAMPLE_ALPHA_TO_ONE			0x809F
#define GL_SAMPLE_COVERAGE			0x80A0
#define GL_SAMPLE_BUFFERS			0x80A8
#define GL_SAMPLES				0x80A9
#define GL_SAMPLE_COVERAGE_VALUE		0x80AA
#define GL_SAMPLE_COVERAGE_INVERT		0x80AB
#define GL_MULTISAMPLE_BIT			0x20000000
/* transpose_matrix */
#define GL_TRANSPOSE_MODELVIEW_MATRIX		0x84E3
#define GL_TRANSPOSE_PROJECTION_MATRIX		0x84E4
#define GL_TRANSPOSE_TEXTURE_MATRIX		0x84E5
#define GL_TRANSPOSE_COLOR_MATRIX		0x84E6
/* texture_env_combine */
#define GL_COMBINE				0x8570
#define GL_COMBINE_RGB				0x8571
#define GL_COMBINE_ALPHA			0x8572
#define GL_SOURCE0_RGB				0x8580
#define GL_SOURCE1_RGB				0x8581
#define GL_SOURCE2_RGB				0x8582
#define GL_SOURCE0_ALPHA			0x8588
#define GL_SOURCE1_ALPHA			0x8589
#define GL_SOURCE2_ALPHA			0x858A
#define GL_OPERAND0_RGB				0x8590
#define GL_OPERAND1_RGB				0x8591
#define GL_OPERAND2_RGB				0x8592
#define GL_OPERAND0_ALPHA			0x8598
#define GL_OPERAND1_ALPHA			0x8599
#define GL_OPERAND2_ALPHA			0x859A
#define GL_RGB_SCALE				0x8573
#define GL_ADD_SIGNED				0x8574
#define GL_INTERPOLATE				0x8575
#define GL_SUBTRACT				0x84E7
#define GL_CONSTANT				0x8576
#define GL_PRIMARY_COLOR			0x8577
#define GL_PREVIOUS				0x8578
/* texture_env_dot3 */
#define GL_DOT3_RGB				0x86AE
#define GL_DOT3_RGBA				0x86AF
/* texture_border_clamp */
#define GL_CLAMP_TO_BORDER			0x812



/*
 * Miscellaneous
 */

void  glClearIndex( GLfloat c );

void  glClearColor( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha );

void  glClear( GLbitfield mask );

void  glIndexMask( GLuint mask );

void  glColorMask( GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha );

void  glAlphaFunc( GLenum func, GLclampf ref );

void  glBlendFunc( GLenum sfactor, GLenum dfactor );

void  glLogicOp( GLenum opcode );

void  glCullFace( GLenum mode );

void  glFrontFace( GLenum mode );

void  glPointSize( GLfloat size );

void  glLineWidth( GLfloat width );

void  glLineStipple( GLint factor, GLushort pattern );

void  glPolygonMode( GLenum face, GLenum mode );

void  glPolygonOffset( GLfloat factor, GLfloat units );

void  glPolygonStipple( const GLubyte *mask );

void  glGetPolygonStipple( GLubyte *mask );

void  glEdgeFlag( GLboolean flag );

void  glEdgeFlagv( const GLboolean *flag );

void  glScissor( GLint x, GLint y, GLsizei width, GLsizei height);

void  glClipPlane( GLenum plane, const GLdouble *equation );

void  glGetClipPlane( GLenum plane, GLdouble *equation );

void  glDrawBuffer( GLenum mode );

void  glReadBuffer( GLenum mode );

void  glEnable( GLenum cap );

void  glDisable( GLenum cap );

GLboolean  glIsEnabled( GLenum cap );


void  glEnableClientState( GLenum cap );  /* 1.1 */

void  glDisableClientState( GLenum cap );  /* 1.1 */


void  glGetBooleanv( GLenum pname, GLboolean *params );

void  glGetDoublev( GLenum pname, GLdouble *params );

void  glGetFloatv( GLenum pname, GLfloat *params );

void  glGetIntegerv( GLenum pname, GLint *params );


void  glPushAttrib( GLbitfield mask );

void  glPopAttrib( void );


void  glPushClientAttrib( GLbitfield mask );  /* 1.1 */

void  glPopClientAttrib( void );  /* 1.1 */


GLint  glRenderMode( GLenum mode );

GLenum  glGetError( void );

const GLubyte*  glGetString( GLenum name );

void  glFinish( void );

void  glFlush( void );

void  glHint( GLenum target, GLenum mode );



/*
 * Depth Buffer
 */

void  glClearDepth( GLclampd depth );

void  glDepthFunc( GLenum func );

void  glDepthMask( GLboolean flag );

void  glDepthRange( GLclampd near_val, GLclampd far_val );


/*
 * Accumulation Buffer
 */

void  glClearAccum( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha );

void  glAccum( GLenum op, GLfloat value );



/*
 * Transformation
 */

void  glMatrixMode( GLenum mode );

void  glOrtho( GLdouble left, GLdouble right,
                                 GLdouble bottom, GLdouble top,
                                 GLdouble near_val, GLdouble far_val );

void  glFrustum( GLdouble left, GLdouble right,
                                   GLdouble bottom, GLdouble top,
                                   GLdouble near_val, GLdouble far_val );

void  glViewport( GLint x, GLint y,
                                    GLsizei width, GLsizei height );

void  glPushMatrix( void );

void  glPopMatrix( void );

void  glLoadIdentity( void );

void  glLoadMatrixd( const GLdouble *m );
void  glLoadMatrixf( const GLfloat *m );

void  glMultMatrixd( const GLdouble *m );
void  glMultMatrixf( const GLfloat *m );

void  glRotated( GLdouble angle,
                                   GLdouble x, GLdouble y, GLdouble z );
void  glRotatef( GLfloat angle,
                                   GLfloat x, GLfloat y, GLfloat z );

void  glScaled( GLdouble x, GLdouble y, GLdouble z );
void  glScalef( GLfloat x, GLfloat y, GLfloat z );

void  glTranslated( GLdouble x, GLdouble y, GLdouble z );
void  glTranslatef( GLfloat x, GLfloat y, GLfloat z );



/*
 * Display Lists
 */

GLboolean  glIsList( GLuint list );

void  glDeleteLists( GLuint list, GLsizei range );

GLuint  glGenLists( GLsizei range );

void  glNewList( GLuint list, GLenum mode );

void  glEndList( void );

void  glCallList( GLuint list );

void  glCallLists( GLsizei n, GLenum type,
                                     const GLvoid *lists );

void  glListBase( GLuint base );



/*
 * Drawing Functions
 */

void  glBegin( GLenum mode );

void  glEnd( void );


void  glVertex2d( GLdouble x, GLdouble y );
void  glVertex2f( GLfloat x, GLfloat y );
void  glVertex2i( GLint x, GLint y );
void  glVertex2s( GLshort x, GLshort y );

void  glVertex3d( GLdouble x, GLdouble y, GLdouble z );
void  glVertex3f( GLfloat x, GLfloat y, GLfloat z );
void  glVertex3i( GLint x, GLint y, GLint z );
void  glVertex3s( GLshort x, GLshort y, GLshort z );

void  glVertex4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w );
void  glVertex4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w );
void  glVertex4i( GLint x, GLint y, GLint z, GLint w );
void  glVertex4s( GLshort x, GLshort y, GLshort z, GLshort w );

void  glVertex2dv( const GLdouble *v );
void  glVertex2fv( const GLfloat *v );
void  glVertex2iv( const GLint *v );
void  glVertex2sv( const GLshort *v );

void  glVertex3dv( const GLdouble *v );
void  glVertex3fv( const GLfloat *v );
void  glVertex3iv( const GLint *v );
void  glVertex3sv( const GLshort *v );

void  glVertex4dv( const GLdouble *v );
void  glVertex4fv( const GLfloat *v );
void  glVertex4iv( const GLint *v );
void  glVertex4sv( const GLshort *v );


void  glNormal3b( GLbyte nx, GLbyte ny, GLbyte nz );
void  glNormal3d( GLdouble nx, GLdouble ny, GLdouble nz );
void  glNormal3f( GLfloat nx, GLfloat ny, GLfloat nz );
void  glNormal3i( GLint nx, GLint ny, GLint nz );
void  glNormal3s( GLshort nx, GLshort ny, GLshort nz );

void  glNormal3bv( const GLbyte *v );
void  glNormal3dv( const GLdouble *v );
void  glNormal3fv( const GLfloat *v );
void  glNormal3iv( const GLint *v );
void  glNormal3sv( const GLshort *v );


void  glIndexd( GLdouble c );
void  glIndexf( GLfloat c );
void  glIndexi( GLint c );
void  glIndexs( GLshort c );
void  glIndexub( GLubyte c );  /* 1.1 */

void  glIndexdv( const GLdouble *c );
void  glIndexfv( const GLfloat *c );
void  glIndexiv( const GLint *c );
void  glIndexsv( const GLshort *c );
void  glIndexubv( const GLubyte *c );  /* 1.1 */

void  glColor3b( GLbyte red, GLbyte green, GLbyte blue );
void  glColor3d( GLdouble red, GLdouble green, GLdouble blue );
void  glColor3f( GLfloat red, GLfloat green, GLfloat blue );
void  glColor3i( GLint red, GLint green, GLint blue );
void  glColor3s( GLshort red, GLshort green, GLshort blue );
void  glColor3ub( GLubyte red, GLubyte green, GLubyte blue );
void  glColor3ui( GLuint red, GLuint green, GLuint blue );
void  glColor3us( GLushort red, GLushort green, GLushort blue );

void  glColor4b( GLbyte red, GLbyte green,
                                   GLbyte blue, GLbyte alpha );
void  glColor4d( GLdouble red, GLdouble green,
                                   GLdouble blue, GLdouble alpha );
void  glColor4f( GLfloat red, GLfloat green,
                                   GLfloat blue, GLfloat alpha );
void  glColor4i( GLint red, GLint green,
                                   GLint blue, GLint alpha );
void  glColor4s( GLshort red, GLshort green,
                                   GLshort blue, GLshort alpha );
void  glColor4ub( GLubyte red, GLubyte green,
                                    GLubyte blue, GLubyte alpha );
void  glColor4ui( GLuint red, GLuint green,
                                    GLuint blue, GLuint alpha );
void  glColor4us( GLushort red, GLushort green,
                                    GLushort blue, GLushort alpha );


void  glColor3bv( const GLbyte *v );
void  glColor3dv( const GLdouble *v );
void  glColor3fv( const GLfloat *v );
void  glColor3iv( const GLint *v );
void  glColor3sv( const GLshort *v );
void  glColor3ubv( const GLubyte *v );
void  glColor3uiv( const GLuint *v );
void  glColor3usv( const GLushort *v );

void  glColor4bv( const GLbyte *v );
void  glColor4dv( const GLdouble *v );
void  glColor4fv( const GLfloat *v );
void  glColor4iv( const GLint *v );
void  glColor4sv( const GLshort *v );
void  glColor4ubv( const GLubyte *v );
void  glColor4uiv( const GLuint *v );
void  glColor4usv( const GLushort *v );


void  glTexCoord1d( GLdouble s );
void  glTexCoord1f( GLfloat s );
void  glTexCoord1i( GLint s );
void  glTexCoord1s( GLshort s );

void  glTexCoord2d( GLdouble s, GLdouble t );
void  glTexCoord2f( GLfloat s, GLfloat t );
void  glTexCoord2i( GLint s, GLint t );
void  glTexCoord2s( GLshort s, GLshort t );

void  glTexCoord3d( GLdouble s, GLdouble t, GLdouble r );
void  glTexCoord3f( GLfloat s, GLfloat t, GLfloat r );
void  glTexCoord3i( GLint s, GLint t, GLint r );
void  glTexCoord3s( GLshort s, GLshort t, GLshort r );

void  glTexCoord4d( GLdouble s, GLdouble t, GLdouble r, GLdouble q );
void  glTexCoord4f( GLfloat s, GLfloat t, GLfloat r, GLfloat q );
void  glTexCoord4i( GLint s, GLint t, GLint r, GLint q );
void  glTexCoord4s( GLshort s, GLshort t, GLshort r, GLshort q );

void  glTexCoord1dv( const GLdouble *v );
void  glTexCoord1fv( const GLfloat *v );
void  glTexCoord1iv( const GLint *v );
void  glTexCoord1sv( const GLshort *v );

void  glTexCoord2dv( const GLdouble *v );
void  glTexCoord2fv( const GLfloat *v );
void  glTexCoord2iv( const GLint *v );
void  glTexCoord2sv( const GLshort *v );

void  glTexCoord3dv( const GLdouble *v );
void  glTexCoord3fv( const GLfloat *v );
void  glTexCoord3iv( const GLint *v );
void  glTexCoord3sv( const GLshort *v );

void  glTexCoord4dv( const GLdouble *v );
void  glTexCoord4fv( const GLfloat *v );
void  glTexCoord4iv( const GLint *v );
void  glTexCoord4sv( const GLshort *v );


void  glRasterPos2d( GLdouble x, GLdouble y );
void  glRasterPos2f( GLfloat x, GLfloat y );
void  glRasterPos2i( GLint x, GLint y );
void  glRasterPos2s( GLshort x, GLshort y );

void  glRasterPos3d( GLdouble x, GLdouble y, GLdouble z );
void  glRasterPos3f( GLfloat x, GLfloat y, GLfloat z );
void  glRasterPos3i( GLint x, GLint y, GLint z );
void  glRasterPos3s( GLshort x, GLshort y, GLshort z );

void  glRasterPos4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w );
void  glRasterPos4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w );
void  glRasterPos4i( GLint x, GLint y, GLint z, GLint w );
void  glRasterPos4s( GLshort x, GLshort y, GLshort z, GLshort w );

void  glRasterPos2dv( const GLdouble *v );
void  glRasterPos2fv( const GLfloat *v );
void  glRasterPos2iv( const GLint *v );
void  glRasterPos2sv( const GLshort *v );

void  glRasterPos3dv( const GLdouble *v );
void  glRasterPos3fv( const GLfloat *v );
void  glRasterPos3iv( const GLint *v );
void  glRasterPos3sv( const GLshort *v );

void  glRasterPos4dv( const GLdouble *v );
void  glRasterPos4fv( const GLfloat *v );
void  glRasterPos4iv( const GLint *v );
void  glRasterPos4sv( const GLshort *v );


void  glRectd( GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2 );
void  glRectf( GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2 );
void  glRecti( GLint x1, GLint y1, GLint x2, GLint y2 );
void  glRects( GLshort x1, GLshort y1, GLshort x2, GLshort y2 );


void  glRectdv( const GLdouble *v1, const GLdouble *v2 );
void  glRectfv( const GLfloat *v1, const GLfloat *v2 );
void  glRectiv( const GLint *v1, const GLint *v2 );
void  glRectsv( const GLshort *v1, const GLshort *v2 );



/*
 * Vertex Arrays  (1.1)
 */

void  glVertexPointer( GLint size, GLenum type,
                                       GLsizei stride, const GLvoid *ptr );

void  glNormalPointer( GLenum type, GLsizei stride,
                                       const GLvoid *ptr );

void  glColorPointer( GLint size, GLenum type,
                                      GLsizei stride, const GLvoid *ptr );

void  glIndexPointer( GLenum type, GLsizei stride,
                                      const GLvoid *ptr );

void  glTexCoordPointer( GLint size, GLenum type,
                                         GLsizei stride, const GLvoid *ptr );

void  glEdgeFlagPointer( GLsizei stride, const GLvoid *ptr );

void  glGetPointerv( GLenum pname, GLvoid **params );

void  glArrayElement( GLint i );

void  glDrawArrays( GLenum mode, GLint first, GLsizei count );

void  glDrawElements( GLenum mode, GLsizei count,
                                      GLenum type, const GLvoid *indices );

void  glInterleavedArrays( GLenum format, GLsizei stride,
                                           const GLvoid *pointer );


/*
 * Lighting
 */

void  glShadeModel( GLenum mode );

void  glLightf( GLenum light, GLenum pname, GLfloat param );
void  glLighti( GLenum light, GLenum pname, GLint param );
void  glLightfv( GLenum light, GLenum pname,
                                 const GLfloat *params );
void  glLightiv( GLenum light, GLenum pname,
                                 const GLint *params );

void  glGetLightfv( GLenum light, GLenum pname,
                                    GLfloat *params );
void  glGetLightiv( GLenum light, GLenum pname,
                                    GLint *params );

void  glLightModelf( GLenum pname, GLfloat param );
void  glLightModeli( GLenum pname, GLint param );
void  glLightModelfv( GLenum pname, const GLfloat *params );
void  glLightModeliv( GLenum pname, const GLint *params );

void  glMaterialf( GLenum face, GLenum pname, GLfloat param );
void  glMateriali( GLenum face, GLenum pname, GLint param );
void  glMaterialfv( GLenum face, GLenum pname, const GLfloat *params );
void  glMaterialiv( GLenum face, GLenum pname, const GLint *params );

void  glGetMaterialfv( GLenum face, GLenum pname, GLfloat *params );
void  glGetMaterialiv( GLenum face, GLenum pname, GLint *params );

void  glColorMaterial( GLenum face, GLenum mode );




/*
 * Raster functions
 */

void  glPixelZoom( GLfloat xfactor, GLfloat yfactor );

void  glPixelStoref( GLenum pname, GLfloat param );
void  glPixelStorei( GLenum pname, GLint param );

void  glPixelTransferf( GLenum pname, GLfloat param );
void  glPixelTransferi( GLenum pname, GLint param );

void  glPixelMapfv( GLenum map, GLint mapsize,
                                    const GLfloat *values );
void  glPixelMapuiv( GLenum map, GLint mapsize,
                                     const GLuint *values );
void  glPixelMapusv( GLenum map, GLint mapsize,
                                     const GLushort *values );

void  glGetPixelMapfv( GLenum map, GLfloat *values );
void  glGetPixelMapuiv( GLenum map, GLuint *values );
void  glGetPixelMapusv( GLenum map, GLushort *values );

void  glBitmap( GLsizei width, GLsizei height,
                                GLfloat xorig, GLfloat yorig,
                                GLfloat xmove, GLfloat ymove,
                                const GLubyte *bitmap );

void  glReadPixels( GLint x, GLint y,
                                    GLsizei width, GLsizei height,
                                    GLenum format, GLenum type,
                                    GLvoid *pixels );

void  glDrawPixels( GLsizei width, GLsizei height,
                                    GLenum format, GLenum type,
                                    const GLvoid *pixels );

void  glCopyPixels( GLint x, GLint y,
                                    GLsizei width, GLsizei height,
                                    GLenum type );



/*
 * Stenciling
 */

void  glStencilFunc( GLenum func, GLint ref, GLuint mask );

void  glStencilMask( GLuint mask );

void  glStencilOp( GLenum fail, GLenum zfail, GLenum zpass );

void  glClearStencil( GLint s );



/*
 * Texture mapping
 */

void  glTexGend( GLenum coord, GLenum pname, GLdouble param );
void  glTexGenf( GLenum coord, GLenum pname, GLfloat param );
void  glTexGeni( GLenum coord, GLenum pname, GLint param );

void  glTexGendv( GLenum coord, GLenum pname, const GLdouble *params );
void  glTexGenfv( GLenum coord, GLenum pname, const GLfloat *params );
void  glTexGeniv( GLenum coord, GLenum pname, const GLint *params );

void  glGetTexGendv( GLenum coord, GLenum pname, GLdouble *params );
void  glGetTexGenfv( GLenum coord, GLenum pname, GLfloat *params );
void  glGetTexGeniv( GLenum coord, GLenum pname, GLint *params );


void  glTexEnvf( GLenum target, GLenum pname, GLfloat param );
void  glTexEnvi( GLenum target, GLenum pname, GLint param );

void  glTexEnvfv( GLenum target, GLenum pname, const GLfloat *params );
void  glTexEnviv( GLenum target, GLenum pname, const GLint *params );

void  glGetTexEnvfv( GLenum target, GLenum pname, GLfloat *params );
void  glGetTexEnviv( GLenum target, GLenum pname, GLint *params );


void  glTexParameterf( GLenum target, GLenum pname, GLfloat param );
void  glTexParameteri( GLenum target, GLenum pname, GLint param );

void  glTexParameterfv( GLenum target, GLenum pname,
                                          const GLfloat *params );
void  glTexParameteriv( GLenum target, GLenum pname,
                                          const GLint *params );

void  glGetTexParameterfv( GLenum target,
                                           GLenum pname, GLfloat *params);
void  glGetTexParameteriv( GLenum target,
                                           GLenum pname, GLint *params );

void  glGetTexLevelParameterfv( GLenum target, GLint level,
                                                GLenum pname, GLfloat *params );
void  glGetTexLevelParameteriv( GLenum target, GLint level,
                                                GLenum pname, GLint *params );


void  glTexImage1D( GLenum target, GLint level,
                                    GLint internalFormat,
                                    GLsizei width, GLint border,
                                    GLenum format, GLenum type,
                                    const GLvoid *pixels );

void  glTexImage2D( GLenum target, GLint level,
                                    GLint internalFormat,
                                    GLsizei width, GLsizei height,
                                    GLint border, GLenum format, GLenum type,
                                    const GLvoid *pixels );

void  glGetTexImage( GLenum target, GLint level,
                                     GLenum format, GLenum type,
                                     GLvoid *pixels );



/* 1.1 functions */

void  glGenTextures( GLsizei n, GLuint *textures );

void  glDeleteTextures( GLsizei n, const GLuint *textures);

void  glBindTexture( GLenum target, GLuint texture );

void  glPrioritizeTextures( GLsizei n,
                                            const GLuint *textures,
                                            const GLclampf *priorities );

GLboolean  glAreTexturesResident( GLsizei n,
                                                  const GLuint *textures,
                                                  GLboolean *residences );

GLboolean  glIsTexture( GLuint texture );


void  glTexSubImage1D( GLenum target, GLint level,
                                       GLint xoffset,
                                       GLsizei width, GLenum format,
                                       GLenum type, const GLvoid *pixels );


void  glTexSubImage2D( GLenum target, GLint level,
                                       GLint xoffset, GLint yoffset,
                                       GLsizei width, GLsizei height,
                                       GLenum format, GLenum type,
                                       const GLvoid *pixels );


void  glCopyTexImage1D( GLenum target, GLint level,
                                        GLenum internalformat,
                                        GLint x, GLint y,
                                        GLsizei width, GLint border );


void  glCopyTexImage2D( GLenum target, GLint level,
                                        GLenum internalformat,
                                        GLint x, GLint y,
                                        GLsizei width, GLsizei height,
                                        GLint border );


void  glCopyTexSubImage1D( GLenum target, GLint level,
                                           GLint xoffset, GLint x, GLint y,
                                           GLsizei width );


void  glCopyTexSubImage2D( GLenum target, GLint level,
                                           GLint xoffset, GLint yoffset,
                                           GLint x, GLint y,
                                           GLsizei width, GLsizei height );




/*
 * Evaluators
 */

void  glMap1d( GLenum target, GLdouble u1, GLdouble u2,
                               GLint stride,
                               GLint order, const GLdouble *points );
void  glMap1f( GLenum target, GLfloat u1, GLfloat u2,
                               GLint stride,
                               GLint order, const GLfloat *points );

void  glMap2d( GLenum target,
		     GLdouble u1, GLdouble u2, GLint ustride, GLint uorder,
		     GLdouble v1, GLdouble v2, GLint vstride, GLint vorder,
		     const GLdouble *points );
void  glMap2f( GLenum target,
		     GLfloat u1, GLfloat u2, GLint ustride, GLint uorder,
		     GLfloat v1, GLfloat v2, GLint vstride, GLint vorder,
		     const GLfloat *points );

void  glGetMapdv( GLenum target, GLenum query, GLdouble *v );
void  glGetMapfv( GLenum target, GLenum query, GLfloat *v );
void  glGetMapiv( GLenum target, GLenum query, GLint *v );

void  glEvalCoord1d( GLdouble u );
void  glEvalCoord1f( GLfloat u );

void  glEvalCoord1dv( const GLdouble *u );
void  glEvalCoord1fv( const GLfloat *u );

void  glEvalCoord2d( GLdouble u, GLdouble v );
void  glEvalCoord2f( GLfloat u, GLfloat v );

void  glEvalCoord2dv( const GLdouble *u );
void  glEvalCoord2fv( const GLfloat *u );

void  glMapGrid1d( GLint un, GLdouble u1, GLdouble u2 );
void  glMapGrid1f( GLint un, GLfloat u1, GLfloat u2 );

void  glMapGrid2d( GLint un, GLdouble u1, GLdouble u2,
                                   GLint vn, GLdouble v1, GLdouble v2 );
void  glMapGrid2f( GLint un, GLfloat u1, GLfloat u2,
                                   GLint vn, GLfloat v1, GLfloat v2 );

void  glEvalPoint1( GLint i );

void  glEvalPoint2( GLint i, GLint j );

void  glEvalMesh1( GLenum mode, GLint i1, GLint i2 );

void  glEvalMesh2( GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2 );



/*
 * Fog
 */

void  glFogf( GLenum pname, GLfloat param );

void  glFogi( GLenum pname, GLint param );

void  glFogfv( GLenum pname, const GLfloat *params );

void  glFogiv( GLenum pname, const GLint *params );



/*
 * Selection and Feedback
 */

void  glFeedbackBuffer( GLsizei size, GLenum type, GLfloat *buffer );

void  glPassThrough( GLfloat token );

void  glSelectBuffer( GLsizei size, GLuint *buffer );

void  glInitNames( void );

void  glLoadName( GLuint name );

void  glPushName( GLuint name );

void  glPopName( void );



/* 1.2 functions */
void  glDrawRangeElements( GLenum mode, GLuint start,
	GLuint end, GLsizei count, GLenum type, const GLvoid *indices );

void  glTexImage3D( GLenum target, GLint level,
                                      GLenum internalFormat,
                                      GLsizei width, GLsizei height,
                                      GLsizei depth, GLint border,
                                      GLenum format, GLenum type,
                                      const GLvoid *pixels );

void  glTexSubImage3D( GLenum target, GLint level,
                                         GLint xoffset, GLint yoffset,
                                         GLint zoffset, GLsizei width,
                                         GLsizei height, GLsizei depth,
                                         GLenum format,
                                         GLenum type, const GLvoid *pixels);

void  glCopyTexSubImage3D( GLenum target, GLint level,
                                             GLint xoffset, GLint yoffset,
                                             GLint zoffset, GLint x,
                                             GLint y, GLsizei width,
                                             GLsizei height );


/* 1.2 imaging extension functions */

void  glColorTable( GLenum target, GLenum internalformat,
                                    GLsizei width, GLenum format,
                                    GLenum type, const GLvoid *table );

void  glColorSubTable( GLenum target,
                                       GLsizei start, GLsizei count,
                                       GLenum format, GLenum type,
                                       const GLvoid *data );

void  glColorTableParameteriv(GLenum target, GLenum pname,
                                              const GLint *params);

void  glColorTableParameterfv(GLenum target, GLenum pname,
                                              const GLfloat *params);

void  glCopyColorSubTable( GLenum target, GLsizei start,
                                           GLint x, GLint y, GLsizei width );

void  glCopyColorTable( GLenum target, GLenum internalformat,
                                        GLint x, GLint y, GLsizei width );

void  glGetColorTable( GLenum target, GLenum format,
                                       GLenum type, GLvoid *table );

void  glGetColorTableParameterfv( GLenum target, GLenum pname,
                                                  GLfloat *params );

void  glGetColorTableParameteriv( GLenum target, GLenum pname,
                                                  GLint *params );

void  glBlendEquation( GLenum mode );

void  glBlendColor( GLclampf red, GLclampf green,
                                    GLclampf blue, GLclampf alpha );

void  glHistogram( GLenum target, GLsizei width,
				   GLenum internalformat, GLboolean sink );

void  glResetHistogram( GLenum target );

void  glGetHistogram( GLenum target, GLboolean reset,
				      GLenum format, GLenum type,
				      GLvoid *values );

void  glGetHistogramParameterfv( GLenum target, GLenum pname,
						 GLfloat *params );

void  glGetHistogramParameteriv( GLenum target, GLenum pname,
						 GLint *params );

void  glMinmax( GLenum target, GLenum internalformat,
				GLboolean sink );

void  glResetMinmax( GLenum target );

void  glGetMinmax( GLenum target, GLboolean reset,
                                   GLenum format, GLenum types,
                                   GLvoid *values );

void  glGetMinmaxParameterfv( GLenum target, GLenum pname,
					      GLfloat *params );

void  glGetMinmaxParameteriv( GLenum target, GLenum pname,
					      GLint *params );

void  glConvolutionFilter1D( GLenum target,
	GLenum internalformat, GLsizei width, GLenum format, GLenum type,
	const GLvoid *image );

void  glConvolutionFilter2D( GLenum target,
	GLenum internalformat, GLsizei width, GLsizei height, GLenum format,
	GLenum type, const GLvoid *image );

void  glConvolutionParameterf( GLenum target, GLenum pname,
	GLfloat params );

void  glConvolutionParameterfv( GLenum target, GLenum pname,
	const GLfloat *params );

void  glConvolutionParameteri( GLenum target, GLenum pname,
	GLint params );

void  glConvolutionParameteriv( GLenum target, GLenum pname,
	const GLint *params );

void  glCopyConvolutionFilter1D( GLenum target,
	GLenum internalformat, GLint x, GLint y, GLsizei width );

void  glCopyConvolutionFilter2D( GLenum target,
	GLenum internalformat, GLint x, GLint y, GLsizei width,
	GLsizei height);

void  glGetConvolutionFilter( GLenum target, GLenum format,
	GLenum type, GLvoid *image );

void  glGetConvolutionParameterfv( GLenum target, GLenum pname,
	GLfloat *params );

void  glGetConvolutionParameteriv( GLenum target, GLenum pname,
	GLint *params );

void  glSeparableFilter2D( GLenum target,
	GLenum internalformat, GLsizei width, GLsizei height, GLenum format,
	GLenum type, const GLvoid *row, const GLvoid *column );

void  glGetSeparableFilter( GLenum target, GLenum format,
	GLenum type, GLvoid *row, GLvoid *column, GLvoid *span );



/* 1.3 functions */

void  glActiveTexture( GLenum texture );

void  glClientActiveTexture( GLenum texture );

void  glCompressedTexImage1D( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data );

void  glCompressedTexImage2D( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data );

void  glCompressedTexImage3D( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data );

void  glCompressedTexSubImage1D( GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data );

void  glCompressedTexSubImage2D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data );

void  glCompressedTexSubImage3D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data );

void  glGetCompressedTexImage( GLenum target, GLint lod, GLvoid *img );

void  glMultiTexCoord1d( GLenum target, GLdouble s );

void  glMultiTexCoord1dv( GLenum target, const GLdouble *v );

void  glMultiTexCoord1f( GLenum target, GLfloat s );

void  glMultiTexCoord1fv( GLenum target, const GLfloat *v );

void  glMultiTexCoord1i( GLenum target, GLint s );

void  glMultiTexCoord1iv( GLenum target, const GLint *v );

void  glMultiTexCoord1s( GLenum target, GLshort s );

void  glMultiTexCoord1sv( GLenum target, const GLshort *v );

void  glMultiTexCoord2d( GLenum target, GLdouble s, GLdouble t );

void  glMultiTexCoord2dv( GLenum target, const GLdouble *v );

void  glMultiTexCoord2f( GLenum target, GLfloat s, GLfloat t );

void  glMultiTexCoord2fv( GLenum target, const GLfloat *v );

void  glMultiTexCoord2i( GLenum target, GLint s, GLint t );

void  glMultiTexCoord2iv( GLenum target, const GLint *v );

void  glMultiTexCoord2s( GLenum target, GLshort s, GLshort t );

void  glMultiTexCoord2sv( GLenum target, const GLshort *v );

void  glMultiTexCoord3d( GLenum target, GLdouble s, GLdouble t, GLdouble r );

void  glMultiTexCoord3dv( GLenum target, const GLdouble *v );

void  glMultiTexCoord3f( GLenum target, GLfloat s, GLfloat t, GLfloat r );

void  glMultiTexCoord3fv( GLenum target, const GLfloat *v );

void  glMultiTexCoord3i( GLenum target, GLint s, GLint t, GLint r );

void  glMultiTexCoord3iv( GLenum target, const GLint *v );

void  glMultiTexCoord3s( GLenum target, GLshort s, GLshort t, GLshort r );

void  glMultiTexCoord3sv( GLenum target, const GLshort *v );

void  glMultiTexCoord4d( GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q );

void  glMultiTexCoord4dv( GLenum target, const GLdouble *v );

void  glMultiTexCoord4f( GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q );

void  glMultiTexCoord4fv( GLenum target, const GLfloat *v );

void  glMultiTexCoord4i( GLenum target, GLint s, GLint t, GLint r, GLint q );

void  glMultiTexCoord4iv( GLenum target, const GLint *v );

void  glMultiTexCoord4s( GLenum target, GLshort s, GLshort t, GLshort r, GLshort q );

void  glMultiTexCoord4sv( GLenum target, const GLshort *v );


void  glLoadTransposeMatrixd( const GLdouble m[16] );

void  glLoadTransposeMatrixf( const GLfloat m[16] );

void  glMultTransposeMatrixd( const GLdouble m[16] );

void  glMultTransposeMatrixf( const GLfloat m[16] );

void  glSampleCoverage( GLclampf value, GLboolean invert );


//#ifdefined(GL_GLEXT_LEGACY)


/*
 * GL_ARB_multitexture (ARB extension 1 and OpenGL 1.2.1)
 */
//#ifndef GL_ARB_multitexture
#define GL_ARB_multitexture 1

#define GL_TEXTURE0_ARB				0x84C0
#define GL_TEXTURE1_ARB				0x84C1
#define GL_TEXTURE2_ARB				0x84C2
#define GL_TEXTURE3_ARB				0x84C3
#define GL_TEXTURE4_ARB				0x84C4
#define GL_TEXTURE5_ARB				0x84C5
#define GL_TEXTURE6_ARB				0x84C6
#define GL_TEXTURE7_ARB				0x84C7
#define GL_TEXTURE8_ARB				0x84C8
#define GL_TEXTURE9_ARB				0x84C9
#define GL_TEXTURE10_ARB			0x84CA
#define GL_TEXTURE11_ARB			0x84CB
#define GL_TEXTURE12_ARB			0x84CC
#define GL_TEXTURE13_ARB			0x84CD
#define GL_TEXTURE14_ARB			0x84CE
#define GL_TEXTURE15_ARB			0x84CF
#define GL_TEXTURE16_ARB			0x84D0
#define GL_TEXTURE17_ARB			0x84D1
#define GL_TEXTURE18_ARB			0x84D2
#define GL_TEXTURE19_ARB			0x84D3
#define GL_TEXTURE20_ARB			0x84D4
#define GL_TEXTURE21_ARB			0x84D5
#define GL_TEXTURE22_ARB			0x84D6
#define GL_TEXTURE23_ARB			0x84D7
#define GL_TEXTURE24_ARB			0x84D8
#define GL_TEXTURE25_ARB			0x84D9
#define GL_TEXTURE26_ARB			0x84DA
#define GL_TEXTURE27_ARB			0x84DB
#define GL_TEXTURE28_ARB			0x84DC
#define GL_TEXTURE29_ARB			0x84DD
#define GL_TEXTURE30_ARB			0x84DE
#define GL_TEXTURE31_ARB			0x84DF
#define GL_ACTIVE_TEXTURE_ARB			0x84E0
#define GL_CLIENT_ACTIVE_TEXTURE_ARB		0x84E1
#define GL_MAX_TEXTURE_UNITS_ARB		0x84E2

void  glActiveTextureARB(GLenum texture);
void  glClientActiveTextureARB(GLenum texture);
void  glMultiTexCoord1dARB(GLenum target, GLdouble s);
void  glMultiTexCoord1dvARB(GLenum target, const GLdouble *v);
void  glMultiTexCoord1fARB(GLenum target, GLfloat s);
void  glMultiTexCoord1fvARB(GLenum target, const GLfloat *v);
void  glMultiTexCoord1iARB(GLenum target, GLint s);
void  glMultiTexCoord1ivARB(GLenum target, const GLint *v);
void  glMultiTexCoord1sARB(GLenum target, GLshort s);
void  glMultiTexCoord1svARB(GLenum target, const GLshort *v);
void  glMultiTexCoord2dARB(GLenum target, GLdouble s, GLdouble t);
void  glMultiTexCoord2dvARB(GLenum target, const GLdouble *v);
void  glMultiTexCoord2fARB(GLenum target, GLfloat s, GLfloat t);
void  glMultiTexCoord2fvARB(GLenum target, const GLfloat *v);
void  glMultiTexCoord2iARB(GLenum target, GLint s, GLint t);
void  glMultiTexCoord2ivARB(GLenum target, const GLint *v);
void  glMultiTexCoord2sARB(GLenum target, GLshort s, GLshort t);
void  glMultiTexCoord2svARB(GLenum target, const GLshort *v);
void  glMultiTexCoord3dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r);
void  glMultiTexCoord3dvARB(GLenum target, const GLdouble *v);
void  glMultiTexCoord3fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r);
void  glMultiTexCoord3fvARB(GLenum target, const GLfloat *v);
void  glMultiTexCoord3iARB(GLenum target, GLint s, GLint t, GLint r);
void  glMultiTexCoord3ivARB(GLenum target, const GLint *v);
void  glMultiTexCoord3sARB(GLenum target, GLshort s, GLshort t, GLshort r);
void  glMultiTexCoord3svARB(GLenum target, const GLshort *v);
void  glMultiTexCoord4dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
void  glMultiTexCoord4dvARB(GLenum target, const GLdouble *v);
void  glMultiTexCoord4fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
void  glMultiTexCoord4fvARB(GLenum target, const GLfloat *v);
void  glMultiTexCoord4iARB(GLenum target, GLint s, GLint t, GLint r, GLint q);
void  glMultiTexCoord4ivARB(GLenum target, const GLint *v);
void  glMultiTexCoord4sARB(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
void  glMultiTexCoord4svARB(GLenum target, const GLshort *v);
#ifdef __cplusplus
extern "C" {
#endif

typedef void ( * PFNGLACTIVETEXTUREARBPROC) (GLenum texture);
typedef void ( * PFNGLCLIENTACTIVETEXTUREARBPROC) (GLenum texture);
typedef void ( * PFNGLMULTITEXCOORD1DARBPROC) (GLenum target, GLdouble s);
typedef void ( * PFNGLMULTITEXCOORD1DVARBPROC) (GLenum target, const GLdouble *v);
typedef void ( * PFNGLMULTITEXCOORD1FARBPROC) (GLenum target, GLfloat s);
typedef void ( * PFNGLMULTITEXCOORD1FVARBPROC) (GLenum target, const GLfloat *v);
typedef void ( * PFNGLMULTITEXCOORD1IARBPROC) (GLenum target, GLint s);
typedef void ( * PFNGLMULTITEXCOORD1IVARBPROC) (GLenum target, const GLint *v);
typedef void ( * PFNGLMULTITEXCOORD1SARBPROC) (GLenum target, GLshort s);
typedef void ( * PFNGLMULTITEXCOORD1SVARBPROC) (GLenum target, const GLshort *v);
typedef void ( * PFNGLMULTITEXCOORD2DARBPROC) (GLenum target, GLdouble s, GLdouble t);
typedef void ( * PFNGLMULTITEXCOORD2DVARBPROC) (GLenum target, const GLdouble *v);
typedef void ( * PFNGLMULTITEXCOORD2FARBPROC) (GLenum target, GLfloat s, GLfloat t);
typedef void ( * PFNGLMULTITEXCOORD2FVARBPROC) (GLenum target, const GLfloat *v);
typedef void ( * PFNGLMULTITEXCOORD2IARBPROC) (GLenum target, GLint s, GLint t);
typedef void ( * PFNGLMULTITEXCOORD2IVARBPROC) (GLenum target, const GLint *v);
typedef void ( * PFNGLMULTITEXCOORD2SARBPROC) (GLenum target, GLshort s, GLshort t);
typedef void ( * PFNGLMULTITEXCOORD2SVARBPROC) (GLenum target, const GLshort *v);
typedef void ( * PFNGLMULTITEXCOORD3DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r);
typedef void ( * PFNGLMULTITEXCOORD3DVARBPROC) (GLenum target, const GLdouble *v);
typedef void ( * PFNGLMULTITEXCOORD3FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r);
typedef void ( * PFNGLMULTITEXCOORD3FVARBPROC) (GLenum target, const GLfloat *v);
typedef void ( * PFNGLMULTITEXCOORD3IARBPROC) (GLenum target, GLint s, GLint t, GLint r);
typedef void ( * PFNGLMULTITEXCOORD3IVARBPROC) (GLenum target, const GLint *v);
typedef void ( * PFNGLMULTITEXCOORD3SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r);
typedef void ( * PFNGLMULTITEXCOORD3SVARBPROC) (GLenum target, const GLshort *v);
typedef void ( * PFNGLMULTITEXCOORD4DARBPROC) (GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
typedef void ( * PFNGLMULTITEXCOORD4DVARBPROC) (GLenum target, const GLdouble *v);
typedef void ( * PFNGLMULTITEXCOORD4FARBPROC) (GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
typedef void ( * PFNGLMULTITEXCOORD4FVARBPROC) (GLenum target, const GLfloat *v);
typedef void ( * PFNGLMULTITEXCOORD4IARBPROC) (GLenum target, GLint s, GLint t, GLint r, GLint q);
typedef void ( * PFNGLMULTITEXCOORD4IVARBPROC) (GLenum target, const GLint *v);
typedef void ( * PFNGLMULTITEXCOORD4SARBPROC) (GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
typedef void ( * PFNGLMULTITEXCOORD4SVARBPROC) (GLenum target, const GLshort *v);

//#endif /* GL_ARB_multitexture */
#ifdef __cplusplus
}
#endif



/*
 * 1. GL_EXT_abgr
 */
//#ifndef GL_EXT_abgr
#define GL_EXT_abgr 1

#define GL_ABGR_EXT				0x8000

//#endif /* GL_EXT_abgr */



/*
 * 2. GL_EXT_blend_color
 */
//#ifndef GL_EXT_blend_color
#define GL_EXT_blend_color 1

#define GL_CONSTANT_COLOR_EXT			0x8001
#define GL_ONE_MINUS_CONSTANT_COLOR_EXT		0x8002
#define GL_CONSTANT_ALPHA_EXT			0x8003
#define GL_ONE_MINUS_CONSTANT_ALPHA_EXT		0x8004
#define GL_BLEND_COLOR_EXT			0x8005

void  glBlendColorEXT( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha );

//#endif /* GL_EXT_blend_color */



/*
 * 3. GL_EXT_polygon_offset
 */
//#ifndef GL_EXT_polygon_offset
#define GL_EXT_polygon_offset 1

#define GL_POLYGON_OFFSET_EXT			0x8037
#define GL_POLYGON_OFFSET_FACTOR_EXT		0x8038
#define GL_POLYGON_OFFSET_BIAS_EXT		0x8039

void  glPolygonOffsetEXT( GLfloat factor, GLfloat bias );

//#endif /* GL_EXT_polygon_offset */



/*
 * 6. GL_EXT_texture3D
 */
//#ifndef GL_EXT_texture3D
#define GL_EXT_texture3D 1

#define GL_PACK_SKIP_IMAGES_EXT			0x806B
#define GL_PACK_IMAGE_HEIGHT_EXT		0x806C
#define GL_UNPACK_SKIP_IMAGES_EXT		0x806D
#define GL_UNPACK_IMAGE_HEIGHT_EXT		0x806E
#define GL_TEXTURE_3D_EXT			0x806F
#define GL_PROXY_TEXTURE_3D_EXT			0x8070
#define GL_TEXTURE_DEPTH_EXT			0x8071
#define GL_TEXTURE_WRAP_R_EXT			0x8072
#define GL_MAX_3D_TEXTURE_SIZE_EXT		0x8073
#define GL_TEXTURE_3D_BINDING_EXT		0x806A

void  glTexImage3DEXT( GLenum target, GLint level, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels );

void  glTexSubImage3DEXT( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels);

void  glCopyTexSubImage3DEXT( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height );

//#endif /* GL_EXT_texture3D */



/*
 * 20. GL_EXT_texture_object
 */
//#ifndef GL_EXT_texture_object
#define GL_EXT_texture_object 1

#define GL_TEXTURE_PRIORITY_EXT			0x8066
#define GL_TEXTURE_RESIDENT_EXT			0x8067
#define GL_TEXTURE_1D_BINDING_EXT		0x8068
#define GL_TEXTURE_2D_BINDING_EXT		0x8069

void  glGenTexturesEXT( GLsizei n, GLuint *textures );

void  glDeleteTexturesEXT( GLsizei n, const GLuint *textures);

void  glBindTextureEXT( GLenum target, GLuint texture );

void  glPrioritizeTexturesEXT( GLsizei n, const GLuint *textures, const GLclampf *priorities );

GLboolean  glAreTexturesResidentEXT( GLsizei n, const GLuint *textures, GLboolean *residences );

GLboolean  glIsTextureEXT( GLuint texture );

//#endif /* GL_EXT_texture_object */



/*
 * 27. GL_EXT_rescale_normal
 */
//#ifndef GL_EXT_rescale_normal
#define GL_EXT_rescale_normal 1

#define GL_RESCALE_NORMAL_EXT			0x803A

//#endif /* GL_EXT_rescale_normal */



/*
 * 30. GL_EXT_vertex_array
 */
//#ifndef GL_EXT_vertex_array
#define GL_EXT_vertex_array 1

#define GL_VERTEX_ARRAY_EXT			0x8074
#define GL_NORMAL_ARRAY_EXT			0x8075
#define GL_COLOR_ARRAY_EXT			0x8076
#define GL_INDEX_ARRAY_EXT			0x8077
#define GL_TEXTURE_COORD_ARRAY_EXT		0x8078
#define GL_EDGE_FLAG_ARRAY_EXT			0x8079
#define GL_VERTEX_ARRAY_SIZE_EXT		0x807A
#define GL_VERTEX_ARRAY_TYPE_EXT		0x807B
#define GL_VERTEX_ARRAY_STRIDE_EXT		0x807C
#define GL_VERTEX_ARRAY_COUNT_EXT		0x807D
#define GL_NORMAL_ARRAY_TYPE_EXT		0x807E
#define GL_NORMAL_ARRAY_STRIDE_EXT		0x807F
#define GL_NORMAL_ARRAY_COUNT_EXT		0x8080
#define GL_COLOR_ARRAY_SIZE_EXT			0x8081
#define GL_COLOR_ARRAY_TYPE_EXT			0x8082
#define GL_COLOR_ARRAY_STRIDE_EXT		0x8083
#define GL_COLOR_ARRAY_COUNT_EXT		0x8084
#define GL_INDEX_ARRAY_TYPE_EXT			0x8085
#define GL_INDEX_ARRAY_STRIDE_EXT		0x8086
#define GL_INDEX_ARRAY_COUNT_EXT		0x8087
#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT		0x8088
#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT		0x8089
#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT	0x808A
#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT	0x808B
#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT		0x808C
#define GL_EDGE_FLAG_ARRAY_COUNT_EXT		0x808D
#define GL_VERTEX_ARRAY_POINTER_EXT		0x808E
#define GL_NORMAL_ARRAY_POINTER_EXT		0x808F
#define GL_COLOR_ARRAY_POINTER_EXT		0x8090
#define GL_INDEX_ARRAY_POINTER_EXT		0x8091
#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT	0x8092
#define GL_EDGE_FLAG_ARRAY_POINTER_EXT		0x8093

void  glVertexPointerEXT( GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr );

void  glNormalPointerEXT( GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr );

void  glColorPointerEXT( GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr );

void  glIndexPointerEXT( GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr );

void  glTexCoordPointerEXT( GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr );

void  glEdgeFlagPointerEXT( GLsizei stride, GLsizei count, const GLboolean *ptr );

void  glGetPointervEXT( GLenum pname, GLvoid **params );

void  glArrayElementEXT( GLint i );

void  glDrawArraysEXT( GLenum mode, GLint first, GLsizei count );

//#endif /* GL_EXT_vertex_array */



/*
 * 35. GL_SGIS_texture_edge_clamp
 */
//#ifndef GL_SGIS_texture_edge_clamp
#define GL_SGIS_texture_edge_clamp 1

#define GL_CLAMP_TO_EDGE_SGIS			0x812F

//#endif /* GL_SGIS_texture_edge_clamp */



/*
 * 37. GL_EXT_blend_minmax
 */
//#ifndef GL_EXT_blend_minmax
#define GL_EXT_blend_minmax 1

#define GL_FUNC_ADD_EXT				0x8006
#define GL_MIN_EXT				0x8007
#define GL_MAX_EXT				0x8008
#define GL_BLEND_EQUATION_EXT			0x8009

void  glBlendEquationEXT( GLenum mode );

//#endif /* GL_EXT_blend_minmax */



/*
 * 38. GL_EXT_blend_subtract (requires GL_EXT_blend_max )
 */
//#ifndef GL_EXT_blend_subtract
#define GL_EXT_blend_subtract 1

#define GL_FUNC_SUBTRACT_EXT			0x800A
#define GL_FUNC_REVERSE_SUBTRACT_EXT		0x800B

//#endif /* GL_EXT_blend_subtract */



/*
 * 39. GL_EXT_blend_logic_op
 */
//#ifndef GL_EXT_blend_logic_op
#define GL_EXT_blend_logic_op 1

/* No new tokens or functions */

//#endif /* GL_EXT_blend_logic_op */



/*
 * 54. GL_EXT_point_parameters
 */
//#ifndef GL_EXT_point_parameters
#define GL_EXT_point_parameters 1

#define GL_POINT_SIZE_MIN_EXT			0x8126
#define GL_POINT_SIZE_MAX_EXT			0x8127
#define GL_POINT_FADE_THRESHOLD_SIZE_EXT	0x8128
#define GL_DISTANCE_ATTENUATION_EXT		0x8129

void  glPointParameterfEXT( GLenum pname, GLfloat param );
void  glPointParameterfvEXT( GLenum pname, const GLfloat *params );
void  glPointParameterfSGIS(GLenum pname, GLfloat param);
void  glPointParameterfvSGIS(GLenum pname, const GLfloat *params);

//#endif /* GL_EXT_point_parameters */



/*
 * 78. GL_EXT_paletted_texture
 */
//#ifndef GL_EXT_paletted_texture
#define GL_EXT_paletted_texture 1

#define GL_TABLE_TOO_LARGE_EXT			0x8031
#define GL_COLOR_TABLE_FORMAT_EXT		0x80D8
#define GL_COLOR_TABLE_WIDTH_EXT		0x80D9
#define GL_COLOR_TABLE_RED_SIZE_EXT		0x80DA
#define GL_COLOR_TABLE_GREEN_SIZE_EXT		0x80DB
#define GL_COLOR_TABLE_BLUE_SIZE_EXT		0x80DC
#define GL_COLOR_TABLE_ALPHA_SIZE_EXT	 	0x80DD
#define GL_COLOR_TABLE_LUMINANCE_SIZE_EXT	0x80DE
#define GL_COLOR_TABLE_INTENSITY_SIZE_EXT	0x80DF
#define GL_TEXTURE_INDEX_SIZE_EXT		0x80ED
#define GL_COLOR_INDEX1_EXT			0x80E2
#define GL_COLOR_INDEX2_EXT			0x80E3
#define GL_COLOR_INDEX4_EXT			0x80E4
#define GL_COLOR_INDEX8_EXT			0x80E5
#define GL_COLOR_INDEX12_EXT			0x80E6
#define GL_COLOR_INDEX16_EXT			0x80E7

void  glColorTableEXT( GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table );

void  glColorSubTableEXT( GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data );

void  glGetColorTableEXT( GLenum target, GLenum format, GLenum type, GLvoid *table );

void  glGetColorTableParameterfvEXT( GLenum target, GLenum pname, GLfloat *params );

void  glGetColorTableParameterivEXT( GLenum target, GLenum pname, GLint *params );

//#endif /* GL_EXT_paletted_texture */



/*
 * 79. GL_EXT_clip_volume_hint
 */
//#ifndef GL_EXT_clip_volume_hint
#define GL_EXT_clip_volume_hint 1

#define GL_CLIP_VOLUME_CLIPPING_HINT_EXT	0x80F0

//#endif /* GL_EXT_clip_volume_hint */



/*
 * 97. GL_EXT_compiled_vertex_array
 */
//#ifndef GL_EXT_compiled_vertex_array
#define GL_EXT_compiled_vertex_array 1

#define GL_ARRAY_ELEMENT_LOCK_FIRST_EXT		0x81A8
#define GL_ARRAY_ELEMENT_LOCK_COUNT_EXT		0x81A9

void  glLockArraysEXT( GLint first, GLsizei count );
void  glUnlockArraysEXT( void );

//#endif /* GL_EXT_compiled_vertex_array */

/*
 * 137. GL_HP_occlusion_test
 */
//#ifndef GL_HP_occlusion_test
#define GL_HP_occlusion_test 1

#define GL_OCCLUSION_TEST_HP                    0x8165
#define GL_OCCLUSION_TEST_RESULT_HP             0x8166

//#endif /* GL_HP_occlusion_test */


/*
 * 141. GL_EXT_shared_texture_palette (req's GL_EXT_paletted_texture)
 */
//#ifndef GL_EXT_shared_texture_palette
#define GL_EXT_shared_texture_palette 1

#define GL_SHARED_TEXTURE_PALETTE_EXT		0x81FB

//#endif /* GL_EXT_shared_texture_palette */




///////////////////

/* Extensions */
#define GLU_EXT_object_space_tess          1
#define GLU_EXT_nurbs_tessellator          1

/* Boolean */
#define GLU_FALSE                          0
#define GLU_TRUE                           1

/* Version */
#define GLU_VERSION_1_1                    1
#define GLU_VERSION_1_2                    1
#define GLU_VERSION_1_3                    1

/* StringName */
#define GLU_VERSION                        100800
#define GLU_EXTENSIONS                     100801

/* ErrorCode */
#define GLU_INVALID_ENUM                   100900
#define GLU_INVALID_VALUE                  100901
#define GLU_OUT_OF_MEMORY                  100902
#define GLU_INVALID_OPERATION              100904

/* NurbsDisplay */
/*      GLU_FILL */
#define GLU_OUTLINE_POLYGON                100240
#define GLU_OUTLINE_PATCH                  100241

/* NurbsCallback */
#define GLU_NURBS_ERROR                    100103
#define GLU_ERROR                          100103
#define GLU_NURBS_BEGIN                    100164
#define GLU_NURBS_BEGIN_EXT                100164
#define GLU_NURBS_VERTEX                   100165
#define GLU_NURBS_VERTEX_EXT               100165
#define GLU_NURBS_NORMAL                   100166
#define GLU_NURBS_NORMAL_EXT               100166
#define GLU_NURBS_COLOR                    100167
#define GLU_NURBS_COLOR_EXT                100167
#define GLU_NURBS_TEXTURE_COORD            100168
#define GLU_NURBS_TEX_COORD_EXT            100168
#define GLU_NURBS_END                      100169
#define GLU_NURBS_END_EXT                  100169
#define GLU_NURBS_BEGIN_DATA               100170
#define GLU_NURBS_BEGIN_DATA_EXT           100170
#define GLU_NURBS_VERTEX_DATA              100171
#define GLU_NURBS_VERTEX_DATA_EXT          100171
#define GLU_NURBS_NORMAL_DATA              100172
#define GLU_NURBS_NORMAL_DATA_EXT          100172
#define GLU_NURBS_COLOR_DATA               100173
#define GLU_NURBS_COLOR_DATA_EXT           100173
#define GLU_NURBS_TEXTURE_COORD_DATA       100174
#define GLU_NURBS_TEX_COORD_DATA_EXT       100174
#define GLU_NURBS_END_DATA                 100175
#define GLU_NURBS_END_DATA_EXT             100175

/* NurbsError */
#define GLU_NURBS_ERROR1                   100251
#define GLU_NURBS_ERROR2                   100252
#define GLU_NURBS_ERROR3                   100253
#define GLU_NURBS_ERROR4                   100254
#define GLU_NURBS_ERROR5                   100255
#define GLU_NURBS_ERROR6                   100256
#define GLU_NURBS_ERROR7                   100257
#define GLU_NURBS_ERROR8                   100258
#define GLU_NURBS_ERROR9                   100259
#define GLU_NURBS_ERROR10                  100260
#define GLU_NURBS_ERROR11                  100261
#define GLU_NURBS_ERROR12                  100262
#define GLU_NURBS_ERROR13                  100263
#define GLU_NURBS_ERROR14                  100264
#define GLU_NURBS_ERROR15                  100265
#define GLU_NURBS_ERROR16                  100266
#define GLU_NURBS_ERROR17                  100267
#define GLU_NURBS_ERROR18                  100268
#define GLU_NURBS_ERROR19                  100269
#define GLU_NURBS_ERROR20                  100270
#define GLU_NURBS_ERROR21                  100271
#define GLU_NURBS_ERROR22                  100272
#define GLU_NURBS_ERROR23                  100273
#define GLU_NURBS_ERROR24                  100274
#define GLU_NURBS_ERROR25                  100275
#define GLU_NURBS_ERROR26                  100276
#define GLU_NURBS_ERROR27                  100277
#define GLU_NURBS_ERROR28                  100278
#define GLU_NURBS_ERROR29                  100279
#define GLU_NURBS_ERROR30                  100280
#define GLU_NURBS_ERROR31                  100281
#define GLU_NURBS_ERROR32                  100282
#define GLU_NURBS_ERROR33                  100283
#define GLU_NURBS_ERROR34                  100284
#define GLU_NURBS_ERROR35                  100285
#define GLU_NURBS_ERROR36                  100286
#define GLU_NURBS_ERROR37                  100287

/* NurbsProperty */
#define GLU_AUTO_LOAD_MATRIX               100200
#define GLU_CULLING                        100201
#define GLU_SAMPLING_TOLERANCE             100203
#define GLU_DISPLAY_MODE                   100204
#define GLU_PARAMETRIC_TOLERANCE           100202
#define GLU_SAMPLING_METHOD                100205
#define GLU_U_STEP                         100206
#define GLU_V_STEP                         100207
#define GLU_NURBS_MODE                     100160
#define GLU_NURBS_MODE_EXT                 100160
#define GLU_NURBS_TESSELLATOR              100161
#define GLU_NURBS_TESSELLATOR_EXT          100161
#define GLU_NURBS_RENDERER                 100162
#define GLU_NURBS_RENDERER_EXT             100162

/* NurbsSampling */
#define GLU_OBJECT_PARAMETRIC_ERROR        100208
#define GLU_OBJECT_PARAMETRIC_ERROR_EXT    100208
#define GLU_OBJECT_PATH_LENGTH             100209
#define GLU_OBJECT_PATH_LENGTH_EXT         100209
#define GLU_PATH_LENGTH                    100215
#define GLU_PARAMETRIC_ERROR               100216
#define GLU_DOMAIN_DISTANCE                100217

/* NurbsTrim */
#define GLU_MAP1_TRIM_2                    100210
#define GLU_MAP1_TRIM_3                    100211

/* QuadricDrawStyle */
#define GLU_POINT                          100010
#define GLU_LINE                           100011
#define GLU_FILL                           100012
#define GLU_SILHOUETTE                     100013

/* QuadricCallback */
/*      GLU_ERROR */

/* QuadricNormal */
#define GLU_SMOOTH                         100000
#define GLU_FLAT                           100001
#define GLU_NONE                           100002

/* QuadricOrientation */
#define GLU_OUTSIDE                        100020
#define GLU_INSIDE                         100021

/* TessCallback */
#define GLU_TESS_BEGIN                     100100
#define GLU_BEGIN                          100100
#define GLU_TESS_VERTEX                    100101
#define GLU_VERTEX                         100101
#define GLU_TESS_END                       100102
#define GLU_END                            100102
#define GLU_TESS_ERROR                     100103
#define GLU_TESS_EDGE_FLAG                 100104
#define GLU_EDGE_FLAG                      100104
#define GLU_TESS_COMBINE                   100105
#define GLU_TESS_BEGIN_DATA                100106
#define GLU_TESS_VERTEX_DATA               100107
#define GLU_TESS_END_DATA                  100108
#define GLU_TESS_ERROR_DATA                100109
#define GLU_TESS_EDGE_FLAG_DATA            100110
#define GLU_TESS_COMBINE_DATA              100111

/* TessContour */
#define GLU_CW                             100120
#define GLU_CCW                            100121
#define GLU_INTERIOR                       100122
#define GLU_EXTERIOR                       100123
#define GLU_UNKNOWN                        100124

/* TessProperty */
#define GLU_TESS_WINDING_RULE              100140
#define GLU_TESS_BOUNDARY_ONLY             100141
#define GLU_TESS_TOLERANCE                 100142

/* TessError */
#define GLU_TESS_ERROR1                    100151
#define GLU_TESS_ERROR2                    100152
#define GLU_TESS_ERROR3                    100153
#define GLU_TESS_ERROR4                    100154
#define GLU_TESS_ERROR5                    100155
#define GLU_TESS_ERROR6                    100156
#define GLU_TESS_ERROR7                    100157
#define GLU_TESS_ERROR8                    100158
#define GLU_TESS_MISSING_BEGIN_POLYGON     100151
#define GLU_TESS_MISSING_BEGIN_CONTOUR     100152
#define GLU_TESS_MISSING_END_POLYGON       100153
#define GLU_TESS_MISSING_END_CONTOUR       100154
#define GLU_TESS_COORD_TOO_LARGE           100155
#define GLU_TESS_NEED_COMBINE_CALLBACK     100156

/* TessWinding */
#define GLU_TESS_WINDING_ODD               100130
#define GLU_TESS_WINDING_NONZERO           100131
#define GLU_TESS_WINDING_POSITIVE          100132
#define GLU_TESS_WINDING_NEGATIVE          100133
#define GLU_TESS_WINDING_ABS_GEQ_TWO       100134

/*************************************************************/



class GLUnurbs;
class GLUquadric;
class GLUtesselator;

typedef struct GLUnurbs GLUnurbsObj;
typedef struct GLUquadric GLUquadricObj;
typedef struct GLUtesselator GLUtesselatorObj;
typedef struct GLUtesselator GLUtriangulatorObj;

#define GLU_TESS_MAX_COORD 1.0e150

/* Internal convenience typedefs */
typedef GLvoid (*_GLUfuncptr)(GLvoid);

 void gluBeginCurve (GLUnurbs* nurb);
 void gluBeginPolygon (GLUtesselator* tess);
 void gluBeginSurface (GLUnurbs* nurb);
 void gluBeginTrim (GLUnurbs* nurb);
 GLint gluBuild1DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data);
 GLint gluBuild1DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, const void *data);
 GLint gluBuild2DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data);
 GLint gluBuild2DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, const void *data);
 GLint gluBuild3DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data);
 GLint gluBuild3DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void *data);
 GLboolean gluCheckExtension (const GLubyte *extName, const GLubyte *extString);
 void gluCylinder (GLUquadric* quad, GLdouble base, GLdouble top, GLdouble height, GLint slices, GLint stacks);
 void gluDeleteNurbsRenderer (GLUnurbs* nurb);
 void gluDeleteQuadric (GLUquadric* quad);
 void gluDeleteTess (GLUtesselator* tess);
 void gluDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops);
 void gluEndCurve (GLUnurbs* nurb);
 void gluEndPolygon (GLUtesselator* tess);
 void gluEndSurface (GLUnurbs* nurb);
 void gluEndTrim (GLUnurbs* nurb);
 const GLubyte * gluErrorString (GLenum error);
 void gluGetNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat* data);
 const GLubyte * gluGetString (GLenum name);
 void gluGetTessProperty (GLUtesselator* tess, GLenum which, GLdouble* data);
 void gluLoadSamplingMatrices (GLUnurbs* nurb, const GLfloat *model, const GLfloat *perspective, const GLint *view);
 void gluLookAt (GLdouble eyeX, GLdouble eyeY, GLdouble eyeZ, GLdouble centerX, GLdouble centerY, GLdouble centerZ, GLdouble upX, GLdouble upY, GLdouble upZ);
 GLUnurbs* gluNewNurbsRenderer (void);
 GLUquadric* gluNewQuadric (void);
 GLUtesselator* gluNewTess (void);
 void gluNextContour (GLUtesselator* tess, GLenum type);
 void gluNurbsCallback (GLUnurbs* nurb, GLenum which, _GLUfuncptr CallBackFunc);
 void gluNurbsCallbackData (GLUnurbs* nurb, GLvoid* userData);
 void gluNurbsCallbackDataEXT (GLUnurbs* nurb, GLvoid* userData);
 void gluNurbsCurve (GLUnurbs* nurb, GLint knotCount, GLfloat *knots, GLint stride, GLfloat *control, GLint order, GLenum type);
 void gluNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat value);
 void gluNurbsSurface (GLUnurbs* nurb, GLint sKnotCount, GLfloat* sKnots, GLint tKnotCount, GLfloat* tKnots, GLint sStride, GLint tStride, GLfloat* control, GLint sOrder, GLint tOrder, GLenum type);
 void gluOrtho2D (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top);
 void gluPartialDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops, GLdouble start, GLdouble sweep);
 void gluPerspective (GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar);
 void gluPickMatrix (GLdouble x, GLdouble y, GLdouble delX, GLdouble delY, GLint *viewport);
 GLint gluProject (GLdouble objX, GLdouble objY, GLdouble objZ, const GLdouble *model, const GLdouble *proj, const GLint *view, GLdouble* winX, GLdouble* winY, GLdouble* winZ);
 void gluPwlCurve (GLUnurbs* nurb, GLint count, GLfloat* data, GLint stride, GLenum type);
 void gluQuadricCallback (GLUquadric* quad, GLenum which, _GLUfuncptr CallBackFunc);
 void gluQuadricDrawStyle (GLUquadric* quad, GLenum draw);
 void gluQuadricNormals (GLUquadric* quad, GLenum normal);
 void gluQuadricOrientation (GLUquadric* quad, GLenum orientation);
 void gluQuadricTexture (GLUquadric* quad, GLboolean texture);
 GLint gluScaleImage (GLenum format, GLsizei wIn, GLsizei hIn, GLenum typeIn, const void *dataIn, GLsizei wOut, GLsizei hOut, GLenum typeOut, GLvoid* dataOut);
 void gluSphere (GLUquadric* quad, GLdouble radius, GLint slices, GLint stacks);
 void gluTessBeginContour (GLUtesselator* tess);
 void gluTessBeginPolygon (GLUtesselator* tess, GLvoid* data);
 void gluTessCallback (GLUtesselator* tess, GLenum which, _GLUfuncptr CallBackFunc);
 void gluTessEndContour (GLUtesselator* tess);
 void gluTessEndPolygon (GLUtesselator* tess);
 void gluTessNormal (GLUtesselator* tess, GLdouble valueX, GLdouble valueY, GLdouble valueZ);
 void gluTessProperty (GLUtesselator* tess, GLenum which, GLdouble data);
 void gluTessVertex (GLUtesselator* tess, GLdouble *location, GLvoid* data);
 GLint gluUnProject (GLdouble winX, GLdouble winY, GLdouble winZ, const GLdouble *model, const GLdouble *proj, const GLint *view, GLdouble* objX, GLdouble* objY, GLdouble* objZ);
 GLint gluUnProject4 (GLdouble winX, GLdouble winY, GLdouble winZ, GLdouble clipW, const GLdouble *model, const GLdouble *proj, const GLint *view, GLdouble near, GLdouble far, GLdouble* objX, GLdouble* objY, GLdouble* objZ, GLdouble* objW);



/////////////////////////


/* Display mode bit masks. */
#define GLUT_RGB			0
#define GLUT_RGBA			GLUT_RGB
#define GLUT_INDEX			1
#define GLUT_SINGLE			0
#define GLUT_DOUBLE			2
#define GLUT_ACCUM			4
#define GLUT_ALPHA			8
#define GLUT_DEPTH			16
#define GLUT_STENCIL			32
//#if(GLUT_API_VERSION >= 2)
#define GLUT_MULTISAMPLE		128
#define GLUT_STEREO			256

//#if(GLUT_API_VERSION >= 3)
#define GLUT_LUMINANCE			512
//#endif

/* Mouse buttons. */
#define GLUT_LEFT_BUTTON		0
#define GLUT_MIDDLE_BUTTON		1
#define GLUT_RIGHT_BUTTON		2

/* Mouse button  state. */
#define GLUT_DOWN			0
#define GLUT_UP				1

//#if(GLUT_API_VERSION >= 2)
/* function keys */
#define GLUT_KEY_F1			1
#define GLUT_KEY_F2			2
#define GLUT_KEY_F3			3
#define GLUT_KEY_F4			4
#define GLUT_KEY_F5			5
#define GLUT_KEY_F6			6
#define GLUT_KEY_F7			7
#define GLUT_KEY_F8			8
#define GLUT_KEY_F9			9
#define GLUT_KEY_F10			10
#define GLUT_KEY_F11			11
#define GLUT_KEY_F12			12
/* directional keys */
#define GLUT_KEY_LEFT			100
#define GLUT_KEY_UP			101
#define GLUT_KEY_RIGHT			102
#define GLUT_KEY_DOWN			103
#define GLUT_KEY_PAGE_UP		104
#define GLUT_KEY_PAGE_DOWN		105
#define GLUT_KEY_HOME			106
#define GLUT_KEY_END			107
#define GLUT_KEY_INSERT			108
//#endif

/* Entry/exit  state. */
#define GLUT_LEFT			0
#define GLUT_ENTERED			1

/* Menu usage  state. */
#define GLUT_MENU_NOT_IN_USE		0
#define GLUT_MENU_IN_USE		1

/* Visibility  state. */
#define GLUT_NOT_VISIBLE		0
#define GLUT_VISIBLE			1

/* Window status  state. */
#define GLUT_HIDDEN			0
#define GLUT_FULLY_RETAINED		1
#define GLUT_PARTIALLY_RETAINED		2
#define GLUT_FULLY_COVERED		3

/* Color index component selection values. */
#define GLUT_RED			0
#define GLUT_GREEN			1
#define GLUT_BLUE			2

/* Layers for use. */
#define GLUT_NORMAL			0
#define GLUT_OVERLAY			1

/* Stroke font constants (use these in GLUT program). */
#define GLUT_STROKE_ROMAN		((void*)0)
#define GLUT_STROKE_MONO_ROMAN		((void*)1)

/* Bitmap font constants (use these in GLUT program). */
#define GLUT_BITMAP_9_BY_15		((void*)2)
#define GLUT_BITMAP_8_BY_13		((void*)3)
#define GLUT_BITMAP_TIMES_ROMAN_10	((void*)4)
#define GLUT_BITMAP_TIMES_ROMAN_24	((void*)5)

#define GLUT_BITMAP_HELVETICA_10	((void*)6)
#define GLUT_BITMAP_HELVETICA_12	((void*)7)
#define GLUT_BITMAP_HELVETICA_18	((void*)8)

/* Bitmap font constants (use these in GLUT program). */
//#define GLUT_BITMAP_9_BY_15		(&glutBitmap9By15)
//#define GLUT_BITMAP_8_BY_13		(&glutBitmap8By13)
//#define GLUT_BITMAP_TIMES_ROMAN_10	(&glutBitmapTimesRoman10)
//#define GLUT_BITMAP_TIMES_ROMAN_24	(&glutBitmapTimesRoman24)
//#if(GLUT_API_VERSION >= 3)
//#define GLUT_BITMAP_HELVETICA_10	(&glutBitmapHelvetica10)
//#define GLUT_BITMAP_HELVETICA_12	(&glutBitmapHelvetica12)
//#define GLUT_BITMAP_HELVETICA_18	(&glutBitmapHelvetica18)
//#endif
//#endif

/* glutGet parameters. */
#define GLUT_WINDOW_X			100
#define GLUT_WINDOW_Y			101
#define GLUT_WINDOW_WIDTH		102
#define GLUT_WINDOW_HEIGHT		103
#define GLUT_WINDOW_BUFFER_SIZE		104
#define GLUT_WINDOW_STENCIL_SIZE	105
#define GLUT_WINDOW_DEPTH_SIZE		106
#define GLUT_WINDOW_RED_SIZE		107
#define GLUT_WINDOW_GREEN_SIZE		108
#define GLUT_WINDOW_BLUE_SIZE		109
#define GLUT_WINDOW_ALPHA_SIZE		110
#define GLUT_WINDOW_ACCUM_RED_SIZE	111
#define GLUT_WINDOW_ACCUM_GREEN_SIZE	112
#define GLUT_WINDOW_ACCUM_BLUE_SIZE	113
#define GLUT_WINDOW_ACCUM_ALPHA_SIZE	114
#define GLUT_WINDOW_DOUBLEBUFFER	115
#define GLUT_WINDOW_RGBA		116
#define GLUT_WINDOW_PARENT		117
#define GLUT_WINDOW_NUM_CHILDREN	118
#define GLUT_WINDOW_COLORMAP_SIZE	119
//#if(GLUT_API_VERSION >= 2)
#define GLUT_WINDOW_NUM_SAMPLES		120
#define GLUT_WINDOW_STEREO		121
//#endif
//#if(GLUT_API_VERSION >= 3)
#define GLUT_WINDOW_CURSOR		122
//#endif
#define GLUT_SCREEN_WIDTH		200
#define GLUT_SCREEN_HEIGHT		201
#define GLUT_SCREEN_WIDTH_MM		202
#define GLUT_SCREEN_HEIGHT_MM		203
#define GLUT_MENU_NUM_ITEMS		300
#define GLUT_DISPLAY_MODE_POSSIBLE	400
#define GLUT_INIT_WINDOW_X		500
#define GLUT_INIT_WINDOW_Y		501
#define GLUT_INIT_WINDOW_WIDTH		502
#define GLUT_INIT_WINDOW_HEIGHT		503
#define GLUT_INIT_DISPLAY_MODE		504
//#if(GLUT_API_VERSION >= 2)
#define GLUT_ELAPSED_TIME		700
//#endif
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
#define GLUT_WINDOW_FORMAT_ID		123
//#endif

//#if(GLUT_API_VERSION >= 2)
/* glutDeviceGet parameters. */
#define GLUT_HAS_KEYBOARD		600
#define GLUT_HAS_MOUSE			601
#define GLUT_HAS_SPACEBALL		602
#define GLUT_HAS_DIAL_AND_BUTTON_BOX	603
#define GLUT_HAS_TABLET			604
#define GLUT_NUM_MOUSE_BUTTONS		605
#define GLUT_NUM_SPACEBALL_BUTTONS	606
#define GLUT_NUM_BUTTON_BOX_BUTTONS	607
#define GLUT_NUM_DIALS			608
#define GLUT_NUM_TABLET_BUTTONS		609
//#endif
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
#define GLUT_DEVICE_IGNORE_KEY_REPEAT   610
#define GLUT_DEVICE_KEY_REPEAT          611
#define GLUT_HAS_JOYSTICK		612
#define GLUT_OWNS_JOYSTICK		613
#define GLUT_JOYSTICK_BUTTONS		614
#define GLUT_JOYSTICK_AXES		615
#define GLUT_JOYSTICK_POLL_RATE		616
//#endif

//#if(GLUT_API_VERSION >= 3)
/* glutLayerGet parameters. */
#define GLUT_OVERLAY_POSSIBLE           800
#define GLUT_LAYER_IN_USE		801
#define GLUT_HAS_OVERLAY		802
#define GLUT_TRANSPARENT_INDEX		803
#define GLUT_NORMAL_DAMAGED		804
#define GLUT_OVERLAY_DAMAGED		805

//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
/* glutVideoResizeGet parameters. */
#define GLUT_VIDEO_RESIZE_POSSIBLE	900
#define GLUT_VIDEO_RESIZE_IN_USE	901
#define GLUT_VIDEO_RESIZE_X_DELTA	902
#define GLUT_VIDEO_RESIZE_Y_DELTA	903
#define GLUT_VIDEO_RESIZE_WIDTH_DELTA	904
#define GLUT_VIDEO_RESIZE_HEIGHT_DELTA	905
#define GLUT_VIDEO_RESIZE_X		906
#define GLUT_VIDEO_RESIZE_Y		907
#define GLUT_VIDEO_RESIZE_WIDTH		908
#define GLUT_VIDEO_RESIZE_HEIGHT	909
//#endif

/* glutUseLayer parameters. */
#define GLUT_NORMAL			0
#define GLUT_OVERLAY			1

/* glutGetModifiers return mask. */
#define GLUT_ACTIVE_SHIFT               1
#define GLUT_ACTIVE_CTRL                2
#define GLUT_ACTIVE_ALT                 4

/* glutSetCursor parameters. */
/* Basic arrows. */
#define GLUT_CURSOR_RIGHT_ARROW		0
#define GLUT_CURSOR_LEFT_ARROW		1
/* Symbolic cursor shapes. */
#define GLUT_CURSOR_INFO		2
#define GLUT_CURSOR_DESTROY		3
#define GLUT_CURSOR_HELP		4
#define GLUT_CURSOR_CYCLE		5
#define GLUT_CURSOR_SPRAY		6
#define GLUT_CURSOR_WAIT		7
#define GLUT_CURSOR_TEXT		8
#define GLUT_CURSOR_CROSSHAIR		9
/* Directional cursors. */
#define GLUT_CURSOR_UP_DOWN		10
#define GLUT_CURSOR_LEFT_RIGHT		11
/* Sizing cursors. */
#define GLUT_CURSOR_TOP_SIDE		12
#define GLUT_CURSOR_BOTTOM_SIDE		13
#define GLUT_CURSOR_LEFT_SIDE		14
#define GLUT_CURSOR_RIGHT_SIDE		15
#define GLUT_CURSOR_TOP_LEFT_CORNER	16
#define GLUT_CURSOR_TOP_RIGHT_CORNER	17
#define GLUT_CURSOR_BOTTOM_RIGHT_CORNER	18
#define GLUT_CURSOR_BOTTOM_LEFT_CORNER	19
/* Inherit from parent window. */
#define GLUT_CURSOR_INHERIT		100
/* Blank cursor. */
#define GLUT_CURSOR_NONE		101
/* Fullscreen crosshair (if available). */
#define GLUT_CURSOR_FULL_CROSSHAIR	102



/* GLUT initialization sub-API. */
 void  glutInit(int *argcp, char **argv);
 void  glutInitDisplayMode(unsigned int mode);
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 void  glutInitDisplayString(const char *string);
//#endif
 void  glutInitWindowPosition(int x, int y);
 void  glutInitWindowSize(int width, int height);
 void  glutMainLoop(void);

/* GLUT window sub-API. */
 int  glutCreateWindow(const char *title);
 int  glutCreateSubWindow(int win, int x, int y, int width, int height);
 void  glutDestroyWindow(int win);
 void  glutPostRedisplay(void);
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 11)
 void  glutPostWindowRedisplay(int win);
//#endif
 void  glutSwapBuffers(void);
 int  glutGetWindow(void);
 void  glutSetWindow(int win);
 void  glutSetWindowTitle(const char *title);
 void  glutSetIconTitle(const char *title);
 void  glutPositionWindow(int x, int y);
 void  glutReshapeWindow(int width, int height);
 void  glutPopWindow(void);
 void  glutPushWindow(void);
 void  glutIconifyWindow(void);
 void  glutShowWindow(void);
 void  glutHideWindow(void);
//#if(GLUT_API_VERSION >= 3)
 void  glutFullScreen(void);
 void  glutSetCursor(int cursor);
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 void  glutWarpPointer(int x, int y);
//#endif

/* GLUT overlay sub-API. */
 void  glutEstablishOverlay(void);
 void  glutRemoveOverlay(void);
 void  glutUseLayer(GLenum layer);
 void  glutPostOverlayRedisplay(void);
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 11)
 void  glutPostWindowOverlayRedisplay(int win);
//#endif
 void  glutShowOverlay(void);
 void  glutHideOverlay(void);
//#endif

/* GLUT menu sub-API. */
 int  glutCreateMenu(void (*)(int));
 void  glutDestroyMenu(int menu);
 int  glutGetMenu(void);
 void  glutSetMenu(int menu);
 void  glutAddMenuEntry(const char *label, int value);
 void  glutAddSubMenu(const char *label, int submenu);
 void  glutChangeToMenuEntry(int item, const char *label, int value);
 void  glutChangeToSubMenu(int item, const char *label, int submenu);
 void  glutRemoveMenuItem(int item);
 void  glutAttachMenu(int button);
 void  glutDetachMenu(int button);

/* GLUT window callback sub-API. */
 void  glutDisplayFunc(void (*func)(void));
 void  glutReshapeFunc(void (*func)(int width, int height));
 void  glutKeyboardFunc(void (*func)(unsigned char key, int x, int y));
 void  glutMouseFunc(void (*func)(int button, int state, int x, int y));
 void  glutMotionFunc(void (*func)(int x, int y));
 void  glutPassiveMotionFunc(void (*func)(int x, int y));
 void  glutEntryFunc(void (*func)(int state));
 void  glutVisibilityFunc(void (*func)(int state));
 void  glutIdleFunc(void (*func)(void));
 void  glutTimerFunc(unsigned int millis, void (*func)(int value), int value);
 void  glutMenuStateFunc(void (*func)(int state));
//#if(GLUT_API_VERSION >= 2)
 void  glutSpecialFunc(void (*func)(int key, int x, int y));
 void  glutSpaceballMotionFunc(void (*func)(int x, int y, int z));
 void  glutSpaceballRotateFunc(void (*func)(int x, int y, int z));
 void  glutSpaceballButtonFunc(void (*func)(int button, int state));
 void  glutButtonBoxFunc(void (*func)(int button, int state));
 void  glutDialsFunc(void (*func)(int dial, int value));
 void  glutTabletMotionFunc(void (*func)(int x, int y));
 void  glutTabletButtonFunc(void (*func)(int button, int state, int x, int y));
//#if(GLUT_API_VERSION >= 3)
 void  glutMenuStatusFunc(void (*func)(int status, int x, int y));
 void  glutOverlayDisplayFunc(void (*func)(void));
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 void  glutWindowStatusFunc(void (*func)(int state));
//#endif
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
 void  glutKeyboardUpFunc(void (*func)(unsigned char key, int x, int y));
 void  glutSpecialUpFunc(void (*func)(int key, int x, int y));
 void  glutJoystickFunc(void (*func)(unsigned int buttonMask, int x, int y, int z), int pollInterval);
//#endif
//#endif
//#endif

/* GLUT color index sub-API. */
 void  glutSetColor(int, GLfloat red, GLfloat green, GLfloat blue);
 GLfloat  glutGetColor(int ndx, int component);
 void  glutCopyColormap(int win);

/* GLUT state retrieval sub-API. */
 int  glutGet(GLenum type);
 int  glutDeviceGet(GLenum type);
//#if(GLUT_API_VERSION >= 2)
/* GLUT extension support sub-API */
 int  glutExtensionSupported(const char *name);
//#endif
//#if(GLUT_API_VERSION >= 3)
 int  glutGetModifiers(void);
 int  glutLayerGet(GLenum type);
//#endif

/* GLUT font sub-API */
 void  glutBitmapCharacter(void *font, int character);
 int  glutBitmapWidth(void *font, int character);
 void  glutStrokeCharacter(void *font, int character);
 int  glutStrokeWidth(void *font, int character);
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 int  glutBitmapLength(void *font, const unsigned char *string);
 int  glutStrokeLength(void *font, const unsigned char *string);
//#endif

/* GLUT pre-built models sub-API */
 void  glutWireSphere(GLdouble radius, GLint slices, GLint stacks);
 void  glutSolidSphere(GLdouble radius, GLint slices, GLint stacks);
 void  glutWireCone(GLdouble base, GLdouble height, GLint slices, GLint stacks);
 void  glutSolidCone(GLdouble base, GLdouble height, GLint slices, GLint stacks);
 void  glutWireCube(GLdouble size);
 void  glutSolidCube(GLdouble size);
 void  glutWireTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings);
 void  glutSolidTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings);
 void  glutWireDodecahedron(void);
 void  glutSolidDodecahedron(void);
 void  glutWireTeapot(GLdouble size);
 void  glutSolidTeapot(GLdouble size);
 void  glutWireOctahedron(void);
 void  glutSolidOctahedron(void);
 void  glutWireTetrahedron(void);
 void  glutSolidTetrahedron(void);
 void  glutWireIcosahedron(void);
 void  glutSolidIcosahedron(void);

//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
/* GLUT video resize sub-API. */
 int  glutVideoResizeGet(GLenum param);
 void  glutSetupVideoResizing(void);
 void  glutStopVideoResizing(void);
 void  glutVideoResize(int x, int y, int width, int height);
 void  glutVideoPan(int x, int y, int width, int height);

/* GLUT debugging sub-API. */
 void  glutReportErrors(void);
//#endif

//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
/* GLUT device control sub-API. */
/* glutSetKeyRepeat modes. */
#define GLUT_KEY_REPEAT_OFF		0
#define GLUT_KEY_REPEAT_ON		1
#define GLUT_KEY_REPEAT_DEFAULT		2

/* Joystick button masks. */
#define GLUT_JOYSTICK_BUTTON_A		1
#define GLUT_JOYSTICK_BUTTON_B		2
#define GLUT_JOYSTICK_BUTTON_C		4
#define GLUT_JOYSTICK_BUTTON_D		8

 void  glutIgnoreKeyRepeat(int ignore);
 void  glutSetKeyRepeat(int repeatMode);
 void  glutForceJoystickFunc(void);

/* GLUT game mode sub-API. */
/* glutGameModeGet. */
#define GLUT_GAME_MODE_ACTIVE           0
#define GLUT_GAME_MODE_POSSIBLE         1
#define GLUT_GAME_MODE_WIDTH            2
#define GLUT_GAME_MODE_HEIGHT           3
#define GLUT_GAME_MODE_PIXEL_DEPTH      4
#define GLUT_GAME_MODE_REFRESH_RATE     5
#define GLUT_GAME_MODE_DISPLAY_CHANGED  6

 void  glutGameModeString(const char *string);
 int  glutEnterGameMode(void);
 void  glutLeaveGameMode(void);
 int  glutGameModeGet(GLenum mode);
//#endif

#ifdef __cplusplus
extern "C" {
#endif

enum muiObjType { MUI_BUTTON, MUI_LABEL, MUI_BOLDLABEL, MUI_TEXTBOX, 
		  MUI_VSLIDER, MUI_TEXTLIST, MUI_RADIOBUTTON, 
		  MUI_TINYRADIOBUTTON, MUI_PULLDOWN, MUI_HSLIDER };

/* MUI Return Values: */

enum muiReturnValue { MUI_NO_ACTION,
			MUI_SLIDER_MOVE,
			MUI_SLIDER_RETURN,
			MUI_SLIDER_SCROLLDOWN,
			MUI_SLIDER_SCROLLUP, 
			MUI_SLIDER_THUMB, 
			MUI_BUTTON_PRESS,
			MUI_TEXTBOX_RETURN,
			MUI_TEXTLIST_RETURN,
			MUI_TEXTLIST_RETURN_CONFIRM
};

typedef struct muiobj {
    enum muiObjType	type;
    int	xmin, xmax, ymin, ymax;	    /* bounding box */
    short	active;	    /* 1 = toggled on, or pressed radio button, or can
				be typed in (textbox), etc */
    short	enable;	    /* 1 = can be accessed; drawn with solid text */
    short	select;	    /* 1 = pressed (must be located at the time */
    short	locate;	    /* 1 = located; usually the cursor is over it */
    short	visible;    /* 1 = drawn.  not visible => not enabled */
    enum muiReturnValue	    (*handler)(struct muiobj *obj, int event, int value, int x, int y);
    int		id;	    /* available for users */
    int		uilist;
    void *	object;
    void	(*callback)(struct muiobj *, enum muiReturnValue);
} muiObject;

/* General MUI Routines */

void	    muiInit(void);
void        muiAttachUIList(int uilist);
void	    muiNewUIList(int  listid);
void	    muiAddToUIList(int  uilist, muiObject *obj);
void	    muiSetCallback(muiObject *obj, void (*callback)(muiObject *, enum muiReturnValue));
void	    muiGetObjectSize(muiObject *obj, int *xmin, int *ymin, int *xmax, int *ymax);
void	    muiSetID(muiObject *obj, int id);
int	    muiGetID(muiObject *obj);

/* for a click that doesn't hit anything: */

void	    muiSetNonMUIcallback(void (*nc)(int, int));

int	    muiGetVisible(muiObject *obj);
void	    muiSetVisible(muiObject *obj, int state);
int	    muiGetActive(muiObject *obj);
void	    muiSetActive(muiObject *obj, int state);
int	    muiGetEnable(muiObject *obj);
void	    muiSetEnable(muiObject *obj, int state);
void	    muiSetActiveUIList(int i);
int	    muiGetActiveUIList(void);

/* Button Routines */

muiObject   *muiNewButton(int xmin, int xmax, int ymin, int ymax);
void	    muiLoadButton(muiObject *but, char *str);
muiObject   *muiNewRadioButton(int xmin, int ymin);
muiObject   *muiNewTinyRadioButton(int xmin, int ymin);
void	    muiLinkButtons(muiObject *obj1, muiObject *obj2);
void	    muiClearRadio(muiObject *rad);

/* Label Routines */

muiObject   *muiNewLabel(int xmin, int ymin, char *label);
muiObject   *muiNewBoldLabel(int xmin, int ymin, char *label);
void	    muiChangeLabel(muiObject *obj, char *s);

/* Text Box Routines */

muiObject   *muiNewTextbox(int xmin, int xmax, int ymin);
char	    *muiGetTBString(muiObject *obj);
void	    muiClearTBString(muiObject *obj);
void	    muiSetTBString(muiObject *obj, char *s);

/* Vertical Slider Routines */

muiObject   *muiNewVSlider(int xmin, int ymin, int ymax, int scenter, int shalf);
float	    muiGetVSVal(muiObject *obj);
void	    muiSetVSValue(muiObject *obj, float val);
void	    muiSetVSArrowDelta(muiObject *obj, int newd);

/* Horizontal Slider Routines */

muiObject   *muiNewHSlider(int xmin, int ymin, int xmax, int scenter, int shalf);
float	    muiGetHSVal(muiObject *obj);
void	    muiSetHSValue(muiObject *obj, float val);
void	    muiSetHSArrowDelta(muiObject *obj, int newd);

/* Text List Routines */

muiObject   *muiNewTextList(int xmin, int ymin, int xmax, int listheight);
void	    muiSetTLTop(muiObject *obj, float p);
int	    muiGetTLSelectedItem(muiObject *obj);
void	    muiSetTLStrings(muiObject *obj, char **s);
void	    muiSetTLTopInt(muiObject *obj, int top);

/* Pulldown Menu Routines */

muiObject   *muiNewPulldown(void);
void	    muiAddPulldownEntry(muiObject *obj, char *title, int menu, int ishelp);

#ifdef __cplusplus
}
#endif

typedef void (*GLUTidleCB) (void);
//GLUTidleCB __glutIdleFunc = NULL;
extern GLUTidleCB  __glutIdleFunc;


#endif
#endif
