#ifndef GLOBAL_H
#define GLOBAL_H

#include "../../config.h"

#ifndef HAVE_LIB_DISPLAY
#define DONT_USE_GL
#endif

#ifndef HAVE_LIBEO
#define DONT_USE_EO
#endif

#ifdef _WIN32
#include <windows.h>
#endif


#include "../GEOMsources/Real.h"
#include "../GEOMsources/GeomForm.h"



//#include "list_controllers.h"

class map_controllers;


/********************************************************************
 *   Global Variables
 *******************************************************************/

#ifndef M_PI
#define M_PI 3.1415926535897932384626433832795
#endif
#ifndef SCALE_GL
#define SCALE_GL 200
#endif

#define KHEPERA_IR_BIAS 5
#define KHEPERA_IR_NOISE 2
#define KHEPERA_IR_PASSIVE_BIAS 5
#define KHEPERA_IR_PASSIVE_NOISE 2
#define KHEPERA_IR_perception_angle M_PI/3
#define KHEPERA_IR_range 60
#define KHEPERA_IR_Intensity 1023
#define KHEPERA_passive_IR_Intensity 500

#define KHEPERA_DEFAULT_RADIUS 27.5
#define KHEPERA_vitesse_maxi_lineaire 0.1 // m/s
#define KHEPERA_GL_HEIGHT 0.1

#define SIZE_OF_LIGHTS 500 //For Battery Experiment size of environement 600x600

#define KHEPERA_CAM_2D_X 320 //Beware this value should be a multiple of 2 (to allow transcoding of the camera in divx)
#define KHEPERA_CAM_2D_Y 200 //Beware this value should be a multiple of 2 (to allow transcoding of the camera in divx)
#define KHEPERA_CAM_ANGLE_X 20.0
#define KHEPERA_CAM_ANGLE_Y 12.5

#define KHEPERA_CAM_1D_X 32
#define KHEPERA_CAM_1D_ANGLE_X M_PI/6

#ifndef _WIN32
#define SERIAL_PORT0 "/dev/ttyS1"
#define SERIAL_PORT1 "/dev/ttyS1"
#else
#define SERIAL_PORT0 "COM0"
#define SERIAL_PORT1 "COM1"
#endif

#define MIN_LENGTH_OF_GRIPPER 35
#define MAX_LENGTH_OF_GRIPPER 45
#define WIDTH_OF_GRIPPER      50  

#define SIMULATION_STEPS_BY_PICTURE 2
#define MAX_ROBOTS_BY_LINE 6
//#define FPS 30

//Global variable for the controller map,
//this map is destinated to be activated all the time during the execution
//of the program, in order to simplify the writings, it is really better
//to declare this in global variable  

extern bool save_display;
extern unsigned nb_frame_saved;
extern bool use_real_khepera;
extern int mode_follow;
extern int take_over;
extern const bool real_sensor_position;
extern char* GLenv_name;
extern unsigned size_of_win_sensors;


extern Real simulated_time;


extern map_controllers all_the_controllers;

#ifndef DONT_USE_EO
//extern bool eo_activated; // In fact, it is necessary to know for the
//opengl idle function if eo is activated or not,
//if it is the case so eo is computing, else graphics are activated
//we are well in the glutmainloop but eo blocks the processus making graphics impossible while it is running
//extern bool draw_eo;
//extern void run_ea(eoAlgo<Indi>& _ga, eoPop<Indi>& _pop);
#endif


extern Geom::Form* EMPTY_FORM_POINTER;


#endif
