#ifndef _GRIPPER_H_
#define _GRIPPER_H_

#include "global.h"
#include "khepera_serial.h"
#include "environment.h"

extern bool use_real_khepera;

using namespace Geom;


class Gripper 
{
 private:
  bool angle_have_changed;
  vector<obstacle*> gripped_obs;
  
 public:
  
  bool gripper_take;
  bool gripper_release;
  int  gripper_angle;
 
  Gripper() 
  {
	gripper_take=false;
	gripper_release=false;
	gripper_angle=250;
	
	gripped_obs.clear();
  }

  bool gripper_should_move();

  void gripper_set_angle(int angle);
  
  void move(int khepera_fd);
  
  void try_to_grip(vector<obstacle *> _obs,Real _robotx,Real _roboty,Real _direction);

  void release();
  
  void Translate (Real _tx,Real _ty);

  void Rotate (Real _theta,Real _centerx, Real _centery);
  

  
  ~Gripper()
	{
	}
  
};



#endif
