#ifndef LIGHT_H
#define LIGHT_H

#include "global.h"
#include "GLheader.h"

class light 

{
 private:
  GLint id_light;
  
 public:
    string name;
    double x;
    double y;
    double power;

	void init_3D()
	  {
		float mat_ambi_pl[]= {0.0,0.0,0.0},mat_diff_pl[]= {1.0,1.0,1.0},mat_spec_pl[]= {1.0,1.0,1.0},mat_nphong_pl=0.0;

		id_light=glGenLists(1);
		glNewList(id_light,GL_COMPILE);
		
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
		glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		
		glTranslatef(x/SCALE_GL,y/SCALE_GL,0.1);
		glRotatef(60,1.0,-1.0,0.0);
		glScalef(0.2F,0.2F,0.2F);
		glutWireTetrahedron ( );
		
		glEndList();
		
	  }
	

    light(string _name,double _x,double _y, double _power)
	{
	    name=_name;
	    x=_x;
	    y=_y;
	    power=_power;
		this->init_3D();
	}

	void save(FILE *Fichier)
	  {
		fprintf(Fichier,"light %s %lg %lg %lg \n",name.c_str(),x,y,power);
	  }

	void display_3D()
	  {
		glPushMatrix();
		//	glCallList(id_light);
			float mat_ambi_pl[]= {0.0,0.0,0.0},mat_diff_pl[]= {1.0,1.0,1.0},mat_spec_pl[]= {1.0,1.0,1.0},mat_nphong_pl=0.0;

			//id_light=glGenLists(1);
		//	glNewList(id_light,GL_COMPILE);
		
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_pl);
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_pl);
		glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_pl);
		
		glTranslatef(x/SCALE_GL,y/SCALE_GL,0.1);
		glRotatef(60,1.0,-1.0,0.0);
		glScalef(0.2F,0.2F,0.2F);
		glutWireTetrahedron ( );
			glPopMatrix();
	  }
	
	

    ~light(){};
};

#endif
