#include "robot.h"
#include "GL_3D.h" //To have ask_a_cam


using namespace std; // for string and gcc-3.2
using namespace Geom;

class Form* robot::give_form()
{
  return Forme_robot_pointeur;
}
  
void robot::set_world(class world *wl)
{
  wld=wl;
}
  

void robot::reset_crash_sensors ()
	  
{
  crash_obstacle_unfixed=false;
  crash_obstacle=false;
  crash_other_robot=false;
}
  
bool robot::crash()
{
  if (use_real_khepera)
	{
	  cout<<"Warning : you cannot use crash sensor in REAL mode. crash return false"<<endl;
	  return false;
	}
  else
	{
	  return (crash_obstacle_unfixed||(crash_obstacle||crash_other_robot));
	}
}
  

string khepera::type()
{
  return "khepera";
}


void khepera::add_2D_cam()
{
  if (have_a_2D_cam==false){
	
	camera2D_picture=new(GLubyte[KHEPERA_CAM_2D_X*KHEPERA_CAM_2D_Y*3]);

	if (ask_a_cam(this,namerobot,KHEPERA_CAM_2D_X,KHEPERA_CAM_2D_Y)==1)
	  {
		throw breakerror("I cannot initialize OpenGL for the 2D cameras. You cannot use them.");
	  }
	have_a_2D_cam=true;
	
  }
  else {
	cout<<"beware you asked two 2D cameras for same robot, only one initialized"<<endl;
  }
}


GLubyte* khepera::camera2D()
{
  
  if (have_a_2D_cam==true)
	{
	  if (use_real_khepera)
		{
		  cout<<"Warning CAM2D not coded for REAL khepera. Return empty picture"<<endl;
		}
	  
	  return camera2D_picture;
	}
  else
	{
	  throw breakerror("You tried to access to an inexistant 2D camera (robot "+this->namerobot+").");
	}  
}

void khepera::add_1D_cam()
{
  if (have_a_1D_cam==false)
	{

	  cam1D=new Camera_1D(centerx,centery,direction);
	  have_a_1D_cam=true;
	
	}
  else {
	cout<<"beware you asked two 1D cameras for same robot, only one initialized"<<endl;
  }
  
}

unsigned* khepera::camera1D()
{
  if (have_a_1D_cam==true)
	{
	  if (use_real_khepera)
		{
		  cout<<"Warning : REAL 1D cameras not coded yet. Return empty picture";
		  return cam1D->camera1D();
		}
	  

	  try
		{
		  return cam1D->camera1D();
		}
	  
	  catch(int except)
		{
		  if (except==0)
			{
			  
			  cam1D->calcule_picture(find_forms(KEEP_FIXED|KEEP_UNFIXED|KEEP_OTHER_ROBOTS|KEEP_FOOD));
			}
		  
		}
	}
  else
	{
	  throw breakerror("You tried to access to an inexistant 1D camera (robot "+this->namerobot+").");
	}
  return cam1D->camera1D(); 
}
	
	
    //Real speed; //The speed is between -10.0 and 10.0
void khepera::IRplace_from_center(const Real radius,const int nthsensor,Real reply[3] )
{
  if (real_sensor_position)
	{
	  //Real position of sensors
	  switch (nthsensor) {
			  
	  case 0 :
		reply[0] = radius*0.36; // absciss of captor in the khepera axes
		reply[1] = radius*0.89; // ordonne of captor in the khepera axes
		reply[2] = M_PI-M_PI/2; // direction (angle in radian) of sensor
		break; 
	  case 1 :
		reply[0] = radius*0.67; // absciss of captor in the khepera axes
		reply[1] = radius*0.67; // ordonne of captor in the khepera axes
		reply[2] = 3*M_PI/4-M_PI/2; // direction (angle in radian) of sensor
		break;
	  case 2 :
		reply[0] = radius*0.96; // absciss of captor in the khepera axes
		reply[1] = radius*0.21; // ordonne of captor in the khepera axes
		reply[2] = M_PI/2-M_PI/2; // direction (angle in radian) of sensor
		break;
	  case 3 :
		reply[0] = radius*0.96; // absciss of captor in the khepera axes
		reply[1] = -radius*0.21; // ordonne of captor in the khepera axes
		reply[2] = M_PI/2-M_PI/2; // direction (angle in radian) of sensor
		break;
	  case 4 :
		reply[0] = radius*0.67; // absciss of captor in the khepera axes
		reply[1] = -radius*0.67; // ordonne of captor in the khepera axes
		reply[2] = M_PI/4-M_PI/2; // direction (angle in radian) of sensor
		break;
	  case 5 :
		reply[0] = radius*0.36; // absciss of captor in the khepera axes
		reply[1] = -radius*0.89; // ordonne of captor in the khepera axes
		reply[2] = 0.0-M_PI/2; // direction (angle in radian) of sensor
		break; 
	  case 6 :
		reply[0] = -radius*0.86; // absciss of captor in the khepera axes
		reply[1] = -radius*0.38; // ordonne of captor in the khepera axes
		reply[2] = 3*M_PI/2-M_PI/2; // direction (angle in radian) of sensor
		break; 
	  case 7 :
		reply[0] = -radius*0.86; // absciss of captor in the khepera axes
		reply[1] = radius*0.38; // ordonne of captor in the khepera axes
		reply[2] = 3*M_PI/2-M_PI/2; // direction (angle in radian) of sensor
		break;
		
	  default : break;
	  }
	}
  else
		  {
			// sensors all around the robot
			Real pos=nthsensor*2*M_PI/8.0;
			reply[0]=radius*cos(pos);
			reply[1]=radius*sin(pos);
			reply[2]=pos;
		  }
  
	  }

	
void khepera::IRplace(Real radius)
{
  Real  x_y_d[3];
  for (int i=0; i<8; i++)
	{
	  IRplace_from_center(radius,i,x_y_d);
	  (IR_[i]->Center).x=centerx+x_y_d[0]*cos(direction)-x_y_d[1]*sin(direction);
	  (IR_[i]->Center).y=centery+x_y_d[0]*sin(direction)+x_y_d[1]*cos(direction);
	  (IR_[i]->direction)=direction+x_y_d[2];
	}
  
}
	
	
void khepera::IRinit(Real radius)
{
  Real pos;
  
  pos=direction;
		
  // IR_[0] = new IRsensor(0.0,0.0,0.0,KHEPERA_IR_range,KHEPERA_IR_perception_angle,KHEPERA_IR_Intensity,KHEPERA_IR_BIAS,KHEPERA_IR_NOISE);
  

  for (int i=0; i<8; i++)

	{
	  //pos+=2*M_PI/8.0;
	  IR_[i] = new IRsensor(0.0,0.0,0.0,KHEPERA_IR_range,KHEPERA_IR_perception_angle,KHEPERA_IR_Intensity,KHEPERA_IR_BIAS,KHEPERA_IR_NOISE);
	}
		
  IRplace(radius);
		
}

		


//initialize the GL representation of the robot
void khepera::robot_GL3D()
{
  id_robot = glGenLists(1);
  glNewList(id_robot,GL_COMPILE);

  
  //glColor3f(0.8,0.8,0.8);
  
  float mat_ambi_ag[]= {0.2,0.2,0.2},
	    mat_diff_ag[]= {0.8,0.8,0.8},
	    mat_spec_ag[]= {0.8,0.8,0.8},
		mat_nphong_ag=40.0;
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_ag);
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_ag);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_ag);
		
  
  glPushMatrix();
		
  vector<PrimitivForm *> fo =(Forme_robot_pointeur->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
  drawCylinder(cir->Radius()/SCALE_GL,KHEPERA_GL_HEIGHT,20,1,true);
  
  glPopMatrix();

  //glColor3f(0.0,0.0,0.0);
		
  
  glEndList();

  //sensors representation initialisation
#ifdef _WIN32
  Real kr=(static_cast<Circle2 *>(*((this->give_form())->forms).begin()))->Radius();
#else
  Real kr=(dynamic_cast<Circle2 *>(*((this->give_form())->forms).begin()))->Radius();
#endif
  Real x_y_d[3];
  for (int i=0;i<8;i++)
	{
	  id_sensors[i] = glGenLists(1);
	  glNewList(id_sensors[i],GL_COMPILE);
	  glPushMatrix();
		

	
	  if (((real_sensor_position==false)&&(i==0))
				||
		  ((real_sensor_position==true)&&((i==2)||(i==3)))
		  ) {
		
			  float mat_ambi_ag[]= {0.6,0.8,0.1};
			  float mat_diff_ag[]= {0.6,0.9,1};
			  float mat_spec_ag[]= {0.2,0.5,0.9};
			  float mat_nphong_ag=40.0;
			  
			  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_ag);
			  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_ag);
  
			} else {

			  
			  float mat_ambi_ag[]= {0.2,0.8,0.8};
			  float mat_diff_ag[]= {0.8,0.4,1};
			  float mat_spec_ag[]= {1,1,1};
			  float mat_nphong_ag=40.0;
			  
			  
			  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_ag);
			  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_ag);
  
			}



		
	  IRplace_from_center(kr,i,x_y_d);
	  
	  /*
		glTranslatef((kr*cos(IR_[i]->direction-direction))/SCALE_GL,
		(kr*sin(IR_[i]->direction-direction))/SCALE_GL,
		0.05);*/
	  glTranslatef(x_y_d[0]/SCALE_GL,
				   x_y_d[1]/SCALE_GL,
				   KHEPERA_GL_HEIGHT/2);
	  
	  glRotatef(360*(IR_[i]->direction-direction)/(M_PI*2),0.0,0.0,1.0);
	  glRotatef(-360*(M_PI/2)/(M_PI*2),0.0,1.0,0.0);
	  glTranslatef(0.0,0.0,-((IR_[i]->Range))/SCALE_GL);

			
			
	  drawConea ((tan(IR_[i]->Perception_Angle)*(IR_[i]->Range))/SCALE_GL,
				 KHEPERA_GL_HEIGHT/2,
				 (IR_[i]->Range)/SCALE_GL,
				 31);

			
	  //glutSolidCone((tan(IR_[i]->Perception_Angle)*(IR_[i]->Range))/SCALE_GL,(IR_[i]->Range)/SCALE_GL,20,2);
			
			
	  //drawCylinder((tan(IR_[i]->Perception_Angle)*(IR_[i]->Range))/SCALE_GL,(IR_[i]->Range)/SCALE_GL,20,2,false);
	  
			
			
	  glPopMatrix();
	  glEndList();
	}
		
  
}

void khepera::robot_GL3D_without_Lists()
{
  //id_robot = glGenLists(1);
  //glNewList(id_robot,GL_COMPILE);

  
  //glColor3f(0.8,0.8,0.8);
  
  float mat_ambi_ag[]= {0.2,0.2,0.2},
	    mat_diff_ag[]= {0.8,0.8,0.8},
	    mat_spec_ag[]= {0.8,0.8,0.8},
		mat_nphong_ag=40.0;
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_ag);
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_ag);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_ag);
		
  
  glPushMatrix();
		
  vector<PrimitivForm *> fo =(Forme_robot_pointeur->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
  drawCylinder(cir->Radius()/SCALE_GL,KHEPERA_GL_HEIGHT,20,1,true);
  
  glPopMatrix();


  if (display_sensor_around==true) {
	
  //sensors representation initialisation
#ifdef _WIN32
  Real kr=(static_cast<Circle2 *>(*((this->give_form())->forms).begin()))->Radius();
#else
  Real kr=(dynamic_cast<Circle2 *>(*((this->give_form())->forms).begin()))->Radius();
#endif
  Real x_y_d[3];
  for (int i=0;i<8;i++)
	{
	  glPushMatrix();
			
	  if (((real_sensor_position==false)&&(i==0))
				||
		  ((real_sensor_position==true)&&((i==2)||(i==3)))
		  ) {
		
			  float mat_ambi_ag[]= {0.6,0.8,0.1};
			  float mat_diff_ag[]= {0.6,0.9,1};
			  float mat_spec_ag[]= {0.2,0.5,0.9};
			  float mat_nphong_ag=40.0;
			  
			  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_ag);
			  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_ag);
  
			} else {

			  
			  float mat_ambi_ag[]= {0.2,0.8,0.8};
			  float mat_diff_ag[]= {0.8,0.4,1};
			  float mat_spec_ag[]= {1,1,1};
			  float mat_nphong_ag=40.0;
			  
			  
			  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambi_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diff_ag);
			  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_spec_ag);
			  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,mat_nphong_ag);
  
			}

	  IRplace_from_center(kr,i,x_y_d);
	  
	  glTranslatef(x_y_d[0]/SCALE_GL,
				   x_y_d[1]/SCALE_GL,
				   KHEPERA_GL_HEIGHT/2);
	  
	  glRotatef(360*(IR_[i]->direction-direction)/(M_PI*2),0.0,0.0,1.0);
	  glRotatef(-360*(M_PI/2)/(M_PI*2),0.0,1.0,0.0);
	  glTranslatef(0.0,0.0,-((IR_[i]->Range))/SCALE_GL);

			
			
	  drawConea ((tan(IR_[i]->Perception_Angle)*(IR_[i]->Range))/SCALE_GL,
				 KHEPERA_GL_HEIGHT/2,
				 (IR_[i]->Range)/SCALE_GL,
				 31);

	  glPopMatrix();
	}
  }
  
}



bool khepera::test_collision()
{
  vector<Form *> vector_form;
  vector_form.clear();
  vector<obstacle*>::iterator it1;
  vector<robot*>::iterator it2;
  
  //fixed forms from the environment
  for ( it1=((wld->env)->all_obstacles).begin();it1!=((wld->env)->all_obstacles).end();it1++) 
	{
	  vector_form.push_back( (*it1)->give_form());
						
	}
  crash_obstacle=GeomFormCollisionDetection(*Forme_robot_pointeur,vector_form);
  //crash_obstacle=GeomFormCollisionDetection(*Forme_robot_pointeur,find_forms(KEEP_FIXED));
  
		
  //unfixed forms from the environment
  vector_form.clear();
  for (it1=((wld->env)->all_obstacles_unfixed).begin();it1!=((wld->env)->all_obstacles_unfixed).end();it1++) 
	{
	  vector_form.push_back( (*it1)->give_form());
						
	}
  crash_obstacle_unfixed=GeomFormCollisionDetection(*Forme_robot_pointeur,vector_form);

  
  //forms from the other robots
  //  vector_form.clear();
  crash_other_robot=false;
  for (it2=((wld->vector_robot)).begin();it2!=((wld->vector_robot)).end();it2++) 
	{
	  if (this!=(*it2))	// To avoid self-collision
		{
		  if (GeomFormCollisionDetection(*Forme_robot_pointeur,*((*it2)->Forme_robot_pointeur))) // Detect collision
			{
			  //set crash to true for the two robots
			  crash_other_robot=true;
			  (*it2)->crash_other_robot=true;
			}
				
		}

			
	}
  
  //  crash_other_robot=(crash_other_robot||GeomFormCollisionDetection(*Forme_robot_pointeur,vector_form));

  vector_form.clear();
  on_food=false;
  //forms from the foods
  for (it1=((wld->env)->all_foods).begin();it1!=((wld->env)->all_foods).end();it1++) 
	{
	  vector_form.push_back(((*it1)->give_form()));
	}
		
  on_food=GeomFormCollisionDetection(*Forme_robot_pointeur,vector_form);

		

  return (crash_obstacle_unfixed||(crash_obstacle||crash_other_robot));
}
	

	
void khepera::update_position()
{
  //crash_obstacle_unfixed=false; // reinitialisation is done in the world for all robots at the same time
  //crash_obstacle=false;
  //crash_other_robot=false;
  
  //double rayon_roue = 0.005; // m
  double distance_roue = 0.054; // m
  //double vitesse_maxi_lineaire=0.1; // m/s
  //double vitesse_maxi_angulaire=vitesse_maxi_lineaire/rayon_roue;
  //double speed_motor_gauche=(decision.left_motor-0.5)*2.0*vitesse_maxi_angulaire;
  //double speed_motor_droite=(decision.right_motor-0.5)*2.0*vitesse_maxi_angulaire;
  double speed_R=decision.right_motor;
  double speed_L=decision.left_motor;
  
  	  
  double vitesse_lineaire_roue_gauche=(speed_L-0.5)*2.0*KHEPERA_vitesse_maxi_lineaire;
  double vitesse_lineaire_roue_droite=(speed_R-0.5)*2.0*KHEPERA_vitesse_maxi_lineaire;
  double vitesse_moyenne_lineaire_robot=(vitesse_lineaire_roue_gauche+vitesse_lineaire_roue_droite)/2.0; //cause the center is right in the middle
  double direction_radian=direction; ///180.0*3.14;
  double vitesse_midle_robot_x=vitesse_moyenne_lineaire_robot*cos(direction_radian);
  double vitesse_midle_robot_y=vitesse_moyenne_lineaire_robot*sin(direction_radian);
  double vitesse_angulaire_robot= (vitesse_lineaire_roue_droite-vitesse_lineaire_roue_gauche)/distance_roue;

  right_motor_speed=speed_R;
  left_motor_speed=speed_L;
  
  Real cx,cy,di;
  cx=centerx;
  cy=centery;
  di=direction;
		
  centerx+=(vitesse_midle_robot_x*cycle_simulation)*1000.0; //mm
  centery+=(vitesse_midle_robot_y*cycle_simulation)*1000.0; //mm
  direction+=(vitesse_angulaire_robot*cycle_simulation); ///3.14*180.0);  //radians
		
  this->set_robot_according_center_and_direction();
		
  //cout<<test_collision()<<endl;
  if (this->test_collision())
	{
	  if ((this->crash_obstacle)||(this->crash_other_robot))
		{//if fixed obstacle cancel the move
				centerx=cx;
				centery=cy;
				//direction=di;//don't cancel direction change
				this->set_robot_according_center_and_direction();
		} else {
				//if unfixed obstacle search where is the problem
		  
		  //vector<vector<obstacle*>::iterator> vector_of_iterators;
		  vector<obstacle*>::iterator it1;
		  for (it1=((wld->env)->all_obstacles_unfixed).begin();it1!=((wld->env)->all_obstacles_unfixed).end();it1++) 
			{
			  if(	GeomFormCollisionDetection(*Forme_robot_pointeur,*((*it1)->give_form())))
				{
				  //keep the iterators of the forms which collide.
				  //vector_of_iterators.push_back(it1);
						
				  // Translate the forms which Collide
				  Real xf,yf,scal,tx,ty;
				  
				  xf=(((*it1)->give_form())->x_max+((*it1)->give_form())->x_min)/2;
				  yf=(((*it1)->give_form())->y_max+((*it1)->give_form())->y_min)/2;
				  scal=(xf-cx)*(centerx-cx)+(yf-cy)*(centery-cy);
				  tx=(xf-cx)*scal/((xf-cx)*(xf-cx)+(yf-cy)*(yf-cy));
				  ty=(yf-cy)*scal/((xf-cx)*(xf-cx)+(yf-cy)*(yf-cy));
				  
					  
				  ((*it1)->give_form())->Translate(tx,ty);

						
				  //Verify that the moved form doesn't collide with a fixed part
				  vector<obstacle*>::iterator it2;
				  for (it2=((wld->env)->all_obstacles).begin();it2!=((wld->env)->all_obstacles).end();it2++) 
					{
					  if(GeomFormCollisionDetection(*((*it1)->give_form()),*((*it2)->give_form())))
						{
						  //cancel all moves
						  centerx=cx;
						  centery=cy;
						  //direction=di; //don't cancel direction change
						  ((*it1)->give_form())->Translate(-tx,-ty);
						  this->set_robot_according_center_and_direction();
						  (this->crash_obstacle=true);
								
						}
					}
						
				  //Verify that the moved form doesn't collide with an other unfixed part
				  for (it2=((wld->env)->all_obstacles_unfixed).begin();it2!=((wld->env)->all_obstacles_unfixed).end();it2++) 
					{
					  if ((*it1)!=(*it2)){
						if(GeomFormCollisionDetection(*((*it1)->give_form()),*((*it2)->give_form())))
						  {
							//cancel all moves
							centerx=cx;
							centery=cy;
							//direction=di;//don't cancel direction change
							((*it1)->give_form())->Translate(-tx,-ty);
							this->set_robot_according_center_and_direction();
							(this->crash_obstacle=true);
						  }
					  }
					  
					}
						
						

				  //Verify that the moved form doesn't collide with an other robot
				  vector<robot*>::iterator it3;
				  for (it3=(wld->vector_robot).begin();it3!=(wld->vector_robot).end();it3++) 
					{
					  if (this!=(*it3)){
						
						if(GeomFormCollisionDetection(*((*it1)->give_form()),*((*it3)->Forme_robot_pointeur)))
						  {
							//cancel all moves
							centerx=cx;
							centery=cy;
							//direction=di; //don't cancel direction change
							((*it1)->give_form())->Translate(-tx,-ty);
							this->set_robot_according_center_and_direction();
							(this->crash_obstacle=true);
							(*it3)->crash_obstacle=true; // say to the other robot that it have a collision
						  }
					  }
					  
					}
						
						
						  
				}


					  
					  
			}
				  
		}
	}

  //Manage the movement of gripped objects
  gripper_.Translate(centerx-cx,centery-cy);
  gripper_.Rotate(direction-di,centerx,centery);

  
  //ut <<  centerx << " " << centery << " " << direction <<endl;
  if (direction<0) {direction+=2*M_PI;}
  if (direction>=2*M_PI) {direction-=2*M_PI;}


  
  //Manage grip and release
  this->manage_gripper_khepera();
  
}
	
//OpenGL Procedures for drawing robot

	
void khepera::display_2D ()
{
  //	  Forme_robot_pointeur->Display_2D();
}
	
	
void khepera::display_3D ()
{
  glPushMatrix();
  
  //centerx+=1;centery+=1;
  //direction+=0.01;

  glTranslatef(centerx/SCALE_GL,centery/SCALE_GL,0.0);		
  glRotatef(360*direction/(M_PI*2),0.0,0.0,1.0);

  // glutSolidTeapot(0.1);
  
  
  if (glutGetWindow()==winIdMain)
	{
	  glCallList(id_robot); 
	} else {
	  robot_GL3D_without_Lists();
	}
  
  //glPopMatrix();
  //glPushMatrix();
 
  if (display_sensor_around)
	{
		  
	  for (int i=0;i<8;i++)
		{
		  glCallList(id_sensors[i]);
		}
	}

	  
  if (show_name_robots) {
	glColor3f(0.2,0.4,1.0);
	DrawString (0,0,((this->namerobot).c_str()),0.12);
  }

	  
  glPopMatrix();
	  


  //glRasterPos2f(1.0,1.0);
  //glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,'a');
	  
}

void khepera::display_winSensors(Real shiftx,Real shifty)
{ //glClear(GL_COLOR_BUFFER_BIT);
  
  float r=0.05;
		
  if (use_real_khepera){
	DrawCircle2D(0.5+shiftx,0.5+shifty,0.4,0.8,0.8,0.8);
  }
  else {
	// Not use crash detection in REAL mode
	if (this->crash()){
	  // Red Circle
	  DrawCircle2D(0.5+shiftx,0.5+shifty,0.4,1.0,0.0,0.0);
	}
	else {
	  // White Circle
	  DrawCircle2D(0.5+shiftx,0.5+shifty,0.4,0.8,0.8,0.8);
  }
  }
  


  Real x_y_d[3];
  char buf[10];
  Real bi;
		
  for (int i=0;i<8;i++)
	{
	  IRplace_from_center(0.4,i,x_y_d);
	  
	  DrawCircle2D(-x_y_d[1]+0.5+shiftx,x_y_d[0]+0.5+shifty,r,log(this->IR(i)+1)/7,0.0F,0.0F);

	  if (display_sensor_value)
		{
				  
		  bi=(this->IR(i));
		  sprintf(buf,"%.0f",(bi));
				  
		  glColor3f(0.2,0.4,1.0);
		  IRplace_from_center(0.45,i,x_y_d);
				  
		  glColor3f(0.2,0.4,1.0);
		  DrawBigString(-x_y_d[1]+0.5-0.05+shiftx,x_y_d[0]+0.5+shifty-0.05,buf);
		  
		  //cout<<x_y_d[0]<<" "<<x_y_d[1]<<" "<<x_y_d[2]<<endl;
		  //cout<<(this->IR(i))/1024<<endl;
		}
			  
			  
	}
	  
	
  if (show_name_robots) {
	glColor3f(0.2,0.4,1.0);
	DrawString (0.4+shiftx,0.5+shifty,((this->namerobot).c_str()));
  }
		
}
	

//used after giving a new center and direction to have a coherent robot
//This procedure is EVIL ... but it's also the fastest... the good way is to use Rotate and Translate methods of robot
void khepera::set_robot_according_center_and_direction()
{
#ifdef _WIN32
  Circle2* c= (static_cast<Circle2 *>(*((this->give_form())->forms).begin()));
#else
  Circle2* c= (dynamic_cast<Circle2 *>(*((this->give_form())->forms).begin()));
#endif
		
  (c->Center()).x=centerx;
  (c->Center()).y=centery;

  //replace the boudinx box around the robot (what ? you didn't hear about it... you should look at the GeomForm.h file ;o) )
  (this->give_form())->x_min=centerx-c->Radius();
  (this->give_form())->x_max=centerx+c->Radius();
  (this->give_form())->y_min=centery-c->Radius();
  (this->give_form())->y_max=centery+c->Radius();

  //replace IR sensors
  IRplace(c->Radius());

  //Replace camera 1D
  if (have_a_1D_cam) {
	cam1D->Center=(c->Center());
	 cam1D->direction=this->direction;
	  }
  
  
  //replace Gripper (especially objects keeped)
  //Gripper not replaced (impossible)
  //gripper_.Translate(_tx,_ty);
  //gripper_.Rotate(_theta,_centerx,centery);
}
	
	
void khepera::Rotate(Real _theta,Real _centerx, Real _centery) 
{
  Forme_robot_pointeur->Rotate(_theta,_centerx,_centery);
		
  vector<PrimitivForm *> fo =(Forme_robot_pointeur->forms);
  vector<PrimitivForm *>::iterator it1=fo.begin();
#ifdef _WIN32
  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif
  centerx=(cir->Center()).x;
  centery=(cir->Center()).y;
  direction+=_theta;

  for (int i=0;i<8;i++){
		  
	IR_[i]->Rotate(_theta,_centerx,centery);
  }

  gripper_.Rotate(_theta,_centerx,centery);
		
}
	
void khepera::Translate(Real _tx,Real _ty) 
{
  Forme_robot_pointeur->Translate(_tx,_ty);
  centerx+=_tx;
  centery+=_ty;

  for (int i=0;i<8;i++)
	{
	  IR_[i]->Translate(_tx,_ty);
	}

  gripper_.Translate(_tx,_ty);
}

void khepera::reset_sensors ()
{
  for (int i=0;i<8;i++)
	{
	  IR_[i]->Reset();
	}
  
  if (have_a_1D_cam) {cam1D->Reset(); }
  
}
	
	
void khepera::take_a_decision()
{
  
  //  if (constructor == 0)
  //{
	  (*controller)(*this);
	  //}
	//  else if (constructor == 1)
	//{
	// (*controller)(*this, blackbox_robot);
	//  }
}


void khepera::choose_a_place(Real _dx, Real _dy,Real _direction,bool given)
{
    
  if (given) {
	//forced to have a position
	 centerx=_dx;
	 centery=_dy;
	 direction=_direction;
	 this->set_robot_according_center_and_direction();
  }
  else
  {
	
  
  if (random_start) {
	
	bool retry=true;
	while (retry){
	  if ((_dx<0)||(_dy<0)) {
		_dx=wld->env->dx;
		_dy=wld->env->dy;
	  }
	  
	  centerx=((Real) rand())/RAND_MAX*_dx;
	  centery=((Real) rand())/RAND_MAX*_dy;
	  direction=((Real) rand())/RAND_MAX*2*M_PI;
	  // direction was already choosed (it was useful to initialize sensor dipslay.) but rechoosed here to allow to reset the world (and having new direction for the random start robots).
	  
	  this->set_robot_according_center_and_direction();
	  retry=(this->test_collision());
	  //cout<<centerx<<" "<<centery<<" "<<retry<<endl;
				  
	}
  } else {
	// fixed start
	centerx=startx;
	centery=starty;
	direction=startdirection;
	this->set_robot_according_center_and_direction();


	//to have a good crash sensor initialisation (especially for food)
	//(this->test_collision());

	vector<robot*>::iterator it2;
	for (it2=((wld->vector_robot)).begin();it2!=((wld->vector_robot)).end();it2++) 
	  {
		  ((*it2)->test_collision());
	  }
  

	
  }
  }
  
		
}



bool khepera::eat()
{
  if (use_real_khepera)
		{
		  cout<<"Warning : In REAL world the robot cannot eat"<<endl;
		  return false;
		}
  
  if (!(on_food)) return false;

  vector<unsigned> vector_of_positions;
  unsigned i,deleted=0;
  
  for (i=0;i<((wld->env)->all_foods).size();i++)
	{
	  if(	GeomFormCollisionDetection(*Forme_robot_pointeur,*((((wld->env)->all_foods)[i])->give_form())))
		{
		  //keep the position of food to delete.
		  vector_of_positions.push_back(i);
		}
	  
	}
  
  //deletion
  for (i=0;i<vector_of_positions.size();i++)
	{
	  
	  delete ((wld->env)->all_foods)[vector_of_positions[i]-deleted];
	  ((wld->env)->all_foods).erase(((wld->env)->all_foods).begin()+(vector_of_positions[i]-deleted));
	  deleted++;
	}
	
  	
  on_food=false;
  return true; //the robot have eaten the food
}


vector<Real> khepera::proximity_food()
{
  vector<Real> answer;
  if (use_real_khepera)
		{
		  cout<<"Warning : In REAL world the robot cannot deal with food"<<endl;
		  return answer;
		}

   unsigned i;

  Form * cF;
  Real cx,cy,dx,dy,angle,d;

  for (i=0;i<((wld->env)->all_foods).size();i++)
	{
	  cF=(((wld->env)->all_foods)[i])->give_form();
	  
	  cx=0.5*(cF->x_max - cF->x_min)+cF->x_min;
	  cy=0.5*(cF->y_max - cF->y_min)+cF->y_min;
	  
	  dx=(cx-centerx);
	  dy=(cy-centery);
	  d=sqrt(dx*dx+dy*dy);
	  
	  angle=Math::ACos(dx/d);
	  if (Math::ASin(dy/d)<0) {angle+=Math::PI;}

	  if (d< KHEPERA_DEFAULT_RADIUS*3){
	  answer.push_back(d);
	  answer.push_back(angle-direction);
	  }

	  //cout<<i<<':'<<cx<<':'<<cy<<':'<<d<<endl;
	}

  return answer;
}



void khepera::verify_decision()
{
  if (decision.left_motor>1) { decision.left_motor=1;}
  if (decision.left_motor<0) { decision.left_motor=0;}
  if (decision.right_motor>1) { decision.right_motor=1;}
  if (decision.right_motor<0) { decision.right_motor=0;}
  if (decision.gripper_angle<0) {decision.gripper_angle=0;}
  if (decision.gripper_angle>250) {decision.gripper_angle=250;}
	  
}


void khepera::decide_to_turn_left(){
  decision.left_motor-=0.1;
  decision.right_motor+=0.1;
  verify_decision();
}

void khepera::decide_to_turn_right(){
  decision.left_motor+=0.1;
  decision.right_motor-=0.1;
  verify_decision();
}

void khepera::decide_to_go_forward(){
  decision.left_motor+=0.1;
  decision.right_motor+=0.1;
    verify_decision();
}

void khepera::decide_to_go_back(){
  decision.left_motor-=0.1;
  decision.right_motor-=0.1;
  verify_decision();
}

void khepera::decide_to_stop(){
  decision.left_motor=0.5;
  decision.right_motor=0.5;
}

void khepera::decide_gripper_up()
{decision.gripper_angle+=5;
 verify_decision();
}

void khepera::decide_gripper_down()
{decision.gripper_angle-=5;
 verify_decision();
}

void khepera::decide_to_grip()
{decision.gripper_take=true;}

void khepera::decide_to_release()
{decision.gripper_release=true;}


void khepera::reset_decision(){
  decide_to_stop();
  decision.gripper_take=false;
  decision.gripper_release=false;
}




vector<Form *> khepera::find_forms(unsigned keep)
{
  vector<Form *> vector_form;
  vector_form.clear();
	  
  vector<obstacle*>::iterator it1;
  if (keep&KEEP_FIXED){
	
	//fixed forms from the environment
	for (it1=((wld->env)->all_obstacles).begin();it1!=((wld->env)->all_obstacles).end();it1++) 
	  {
		vector_form.push_back( (*it1)->give_form());
	  }
  }

  if (keep&KEEP_UNFIXED){
  //unfixed forms from the environment
  for (it1=((wld->env)->all_obstacles_unfixed).begin();it1!=((wld->env)->all_obstacles_unfixed).end();it1++) 
	{
	  vector_form.push_back( (*it1)->give_form());
	}
  }
  
  if (keep&KEEP_OTHER_ROBOTS){
  vector<robot*>::iterator it2;
  //forms from the other robots
  for (it2=((wld->vector_robot)).begin();it2!=((wld->vector_robot)).end();it2++) 
	{
	  if (this!=(*it2))
		{
		  vector_form.push_back( ((*it2)->Forme_robot_pointeur));
		}
	  
	}
  }

  if (keep&KEEP_FOOD){
  //forms from the food
  for (it1=((wld->env)->all_foods).begin();it1!=((wld->env)->all_foods).end();it1++) 
	{
	  vector_form.push_back( (*it1)->give_form());
	}
  }
  

  return vector_form;
  
}






void khepera::manage_gripper_khepera() //Used only in virtual world
{
  if (decision.gripper_take)

	{

  vector<obstacle *> vector_obs;
  vector_obs.clear();
	  
  vector<obstacle*>::iterator it1;
	
	//fixed forms from the environment
	for (it1=((wld->env)->all_obstacles).begin();it1!=((wld->env)->all_obstacles).end();it1++) 
	  {
		if ((*it1)->can_be_gripped_)
		  {
			vector_obs.push_back( (*it1) );
		  }
		
	  }

  //unfixed forms from the environment
  for (it1=((wld->env)->all_obstacles_unfixed).begin();it1!=((wld->env)->all_obstacles_unfixed).end();it1++) 
	{
	  if ((*it1)->can_be_gripped_)
		  {
			vector_obs.push_back( (*it1) );
		  }
	  
	}

  /*
	robots cannot be gripped
  vector<robot*>::iterator it2;
  //forms from the other robots
  for (it2=((wld->vector_robot)).begin();it2!=((wld->vector_robot)).end();it2++) 
	{
	  if (this!=(*it2))
		{
		  vector_obs.push_back( ((*it2)->Forme_robot_pointeur));
		}
	  
	}
  */
  
  //forms from the food
  for (it1=((wld->env)->all_foods).begin();it1!=((wld->env)->all_foods).end();it1++) 
	{
	  if ((*it1)->can_be_gripped_)
		  {
			vector_obs.push_back( (*it1) );
		  }
	
	}
  
  gripper_.try_to_grip(vector_obs,centerx,centery,direction);
  decision.gripper_take=false;
  
	}
  

  if (decision.gripper_release)

	{
	  
	  gripper_.release();
	  decision.gripper_release=false;
	  
	}
  
  
}
	
	
// warning an IR sensor is computed only one time (at the first acces) to have a new computation you have to reset it. This point is useful to avoid to recalc sensor when you acces 2 or more times in the controller.
Real khepera::IR(int i)
{
  Real buf=(IR_[i]->Get_Value());
  if (buf==-1)
	{
	  
	  if (use_real_khepera)
		{// read values from REAL robot
		  const unsigned TEXT_BUF_SIZE=255;
		  char result[TEXT_BUF_SIZE];
		  Real i0,i1,i2,i3,i4,i5,i6,i7;
		  
		  khep_talk(robot_serial,"N\n",result,TEXT_BUF_SIZE-1);
		  sscanf(result,"n,%lg,%lg,%lg,%lg,%lg,%lg,%lg,%lg\n",&i0,&i1,&i2,&i3,&i4,&i5,&i6,&i7);

		  IR_[0]->Value=i0;
		  IR_[1]->Value=i1;
		  IR_[2]->Value=i2;
		  IR_[3]->Value=i3;
		  IR_[4]->Value=i4;
		  IR_[5]->Value=i5;
		  IR_[6]->Value=i6;
		  IR_[7]->Value=i7;

		  
		  // Tag sensor as already filled
		  for (int j=0;j<8;j++)
			{
			  IR_[j]->Value_already_computed=true;
			}
		  
		}

	  else {
		//compute value from simulator
		IR_[i]->IRcompute_Value(find_forms(KEEP_FIXED|KEEP_UNFIXED|KEEP_OTHER_ROBOTS|KEEP_FOOD));
		}
	  
	  buf=(IR_[i]->Get_Value());
			
	}
  return buf;
}


Real khepera::IR_passive(int i)
{
  Real buf=(IR_[i]->Get_Passive_Value());
  if (buf==-1)
	{
	  if (use_real_khepera)
		{// read values from REAL robot
		  const unsigned TEXT_BUF_SIZE=255;
			  
		  char result[TEXT_BUF_SIZE];
		  Real i0,i1,i2,i3,i4,i5,i6,i7;
		  
		  khep_talk(robot_serial,"N\n",result,TEXT_BUF_SIZE-1);
		  sscanf(result,"o,%lg,%lg,%lg,%lg,%lg,%lg,%lg,%lg\n",&i0,&i1,&i2,&i3,&i4,&i5,&i6,&i7);
		  
		  IR_[0]->Passive_Value=i0;
		  IR_[1]->Passive_Value=i1;
		  IR_[2]->Passive_Value=i2;
		  IR_[3]->Passive_Value=i3;
		  IR_[4]->Passive_Value=i4;
		  IR_[5]->Passive_Value=i5;
		  IR_[6]->Passive_Value=i6;
		  IR_[7]->Passive_Value=i7;
		  
		  // Tag sensor as already filled
		  for (int j=0;j<8;j++)
			{
			  IR_[j]->Passive_Value_already_computed=true;
			}
		  
		}

	  else {
		// Compute values from simulator
	  IR_[i]->IRcompute_Passive_Value(find_forms(KEEP_FIXED|KEEP_UNFIXED|KEEP_OTHER_ROBOTS),(wld->env)->all_lights);
	  buf=(IR_[i]->Get_Passive_Value());
	  
	  }
	  
	  
	}
  return buf;
}

	
void khepera::real_move()
{
  const unsigned TEXT_BUF_SIZE=255;
  char message[TEXT_BUF_SIZE];
  char result[TEXT_BUF_SIZE];
  
  //if (this->decision.must_change_motor) {
  int left=(int)(((this->decision.left_motor)-0.5)*60);
  int right=(int)(((this->decision.right_motor)-0.5)*60);

  sprintf(message,"D,%i,%i\n",left,right);
  //cout<<message<<endl;
  khep_talk(robot_serial,message,result,TEXT_BUF_SIZE-1);
  //(this->decision.must_change_motor)=false;
  //}
  

  gripper_.gripper_set_angle(decision.gripper_angle);
  gripper_.move(robot_serial);
  
  
  if (this->decision.gripper_take){
	sprintf(message,"T,1,D,1\n");
	//cout<<message<<endl;
	khep_talk(robot_serial,message,result,TEXT_BUF_SIZE-1);
	(this->decision.gripper_take)=false;
  }
  
  if (this->decision.gripper_release){
	sprintf(message,"T,1,D,0\n");
	//cout<<message<<endl;
	khep_talk(robot_serial,message,result,TEXT_BUF_SIZE-1);
	(this->decision.gripper_release)=false;
  }
}


void khepera::Partial_self_destruct()
{
//int i;

 for (vector<PrimitivForm*>::iterator it1=(Forme_robot_pointeur->forms).begin();it1!=(Forme_robot_pointeur->forms).end();it1++) 
   {
	 delete (*it1);
   }
 //delete Forme_robot_pointeur;

 //delete gripper_
		
 // for (i=0;i<8;i++){delete IR_[i];}

 if (have_a_2D_cam==true){delete camera2D_picture;}
 if (have_a_1D_cam==true){delete cam1D;}

 
}



  
