#ifndef WORLD_H
#define WORLD_H



//#include "robot.h" DO NOT include robot.h here (robot.h need to be able to acces to the environment ; the include is done after the declaration of world)

#include "environment.h"
#include "global.h"
#include "GLheader.h"



extern int winIdSensors;
extern int winIdMain;
extern int take_over;
extern bool at_least_one_crash;
extern Real cycle_simulation;
extern Real simulated_time;

class world

{
 public:
  vector <class robot *> vector_robot;
  class environment * env;
  
  world() 
	{
	  env=NULL;
	  my_restart_func=NULL;
	};

  void set_environment(class environment & _env);
  void add_robot(class robot & _robot);
  void evolue();
  float gl_shift_cam_x();
  float gl_shift_cam_y();
  void initGL3D();
  void display_2D();
  void display_3D();
  void display_winSensors();
  void reset_robots_positions();

  void Register_my_restart_func(void (* func) (class robot * r) );
  

  //Real compute_fitness_per_cycle2();
  //Real compute_fitness();
  //void look_archi();

 private:
  void (* my_restart_func) (class robot * r);
  

  
};

#endif
