//Time-stamp: <2004-05-05 16:08:34 mary>
/*  
 *
 
WoB Server 
 
 *
 */

//Classic headers
#include <stdio.h>
#include <iostream>
#include <strstream>

//Environment, Robot,  Word and Controllers headers
#include "../../src/heart/simulator.h"

#ifdef HAVE_PTHREAD

// To use time to initialise Random number generator
#include <time.h>

//Sockets related headers
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/un.h>




//Threads headers
//#include <stdlib.h>
//#include <string.h>
#include <pthread.h>
//#include <unistd.h>

//pthread_attr_t attr;



#define MY_DEFAULT_SOCKET 1050
#define MAX_STRING_LENGTH 1024
#define DEFAULT_NUMBER_OF_ROBOTS 1
#define DEFAULT_MAIN_WIN_SIZE_X 800
#define DEFAULT_MAIN_WIN_SIZE_Y 600



//bool shifting=false;


class SocketException
{
 public:
  SocketException ( std::string s ) : m_s ( s ) {};
  ~SocketException (){};

  std::string description() { return m_s; }

 private:

  std::string m_s;

};


int first_zero(char* recvchar)
{
  int ret=0;
  while (1) {
	if (recvchar[ret]=='\0') return ret;
	ret++;
  }
}

void shift_buffer(char read_buffer[MAX_STRING_LENGTH+1],int fz)
{
  int i;
  
  //shifting=true;
  for (i=0;i<=MAX_STRING_LENGTH-fz;i++)
	{
	  read_buffer[i]=read_buffer[i+fz];
	}
  for (i=MAX_STRING_LENGTH-fz+1;i<=MAX_STRING_LENGTH;i++)
	{
	  read_buffer[i]='\0';
	}
  //shifting=false;
  
}





// definition of our khepera with external controller
class khepera_Out: public khepera
{
public:
  // here are the 2 standards constructors of khepera - you can modify it but keep in mind that you have to call a constructor of khepera in each of your constructors
  khepera_Out(string _namerobot, Controller * _controller_base, Real _radius=27.5) : khepera(_namerobot,_controller_base,_radius)
  {link_established=0;
  //buffer_have_been_treated=true;
  waiting_for_connection=false;
  position_in_buffer=0;

  }
  khepera_Out(string _namerobot, Controller * _controller_base, Real _centerx, Real _centery, Real _direction, Real _radius=27.5) : khepera(_namerobot,_controller_base,_centerx,_centery,_direction,_radius)
  {link_established=0;
  //buffer_have_been_treated=true;
  waiting_for_connection=false;
  position_in_buffer=0;

  
  }

  ~khepera_Out() // destructor
  { //add here the destructors of the things that you added to your khepera
	pthread_mutex_destroy(&mutex_orders_buffer);
	
	// you NEVER need to modify the destructor beyond this point (it is a call to the destructor of khepera)

	Partial_self_destruct();
	
  }

  int link_established;
  int connfd;
  //vector<char *> read_buffer;
  //bool buffer_have_been_treated;
  bool waiting_for_connection;
  char read_buffer[MAX_STRING_LENGTH+1];
  int position_in_buffer;
  pthread_t reader_thread,waiting_for_connection_thread;
  pthread_mutex_t mutex_orders_buffer;


  
};



// Read in socket. Stops when
// MAXLINE char readed or when char is '\0'
// Readed chars are in received
int my_read(const int sockfd, char recvline[MAX_STRING_LENGTH+1], khepera_Out * myrobot)
{
	  
  bool stop =false;
  
  char recvchar[1];

 
  while ((myrobot->position_in_buffer<MAX_STRING_LENGTH)&&(!stop))
	{
	  
	  if ((recv(sockfd, recvchar, sizeof(recvchar),0))<=0) return -1;
	  if (recvchar[0]=='\0') stop=true;
	  
	  pthread_mutex_lock(&(myrobot->mutex_orders_buffer));
	  	  
	  recvline[myrobot->position_in_buffer]=recvchar[0];
	  myrobot->position_in_buffer++;
	  pthread_mutex_unlock(&(myrobot->mutex_orders_buffer));
	  		  
	}
  recvline[myrobot->position_in_buffer]='\0'; // to be sure to have a \0 somewhere (to avoid buffer overflow)

	  
  return myrobot->position_in_buffer;
  
}


int listenfd;


//This function will be placed in a thread to listen the request of the client
void  reader_thread_function (khepera_Out * myrobot)
{
  
  while (1)
	{
	  // if (myrobot->buffer_have_been_treated==true)
	  //	{
	  //	  myrobot->buffer_have_been_treated=false;
		  //  char recvline[MAX_STRING_LENGTH + 1];


	  int r=(my_read(myrobot->connfd, myrobot->read_buffer,myrobot));

	  
	  if (r<0)
		{
		  cout<<"client disconnected"<<endl;
		  break;
		}

	  //cout<<myrobot->read_buffer<<endl;
		  
		  
		  //(myrobot->read_buffer).push_back(recvline);

		  //	} else {
		  // cout<<myrobot->read_buffer<<endl;
		  
		  // wait for authorisation (without consume cpu)  
		  // sleep(1);
		  
		  //}
	  
	}
  //  myrobot->buffer_have_been_treated=true;
  myrobot->link_established=0;
  myrobot->position_in_buffer=0;
  myrobot->read_buffer[0]='\0';
  
  
}

void wait_thread_function (khepera_Out * myrobot)
{
  // an external controller is asking for a connection
	  
  if (    ((myrobot->connfd) = accept(listenfd, (struct sockaddr *) NULL, NULL)) < 0){
	// accept return a "connection descriptor" used for communication with the new client 

	perror("accept error");
  
  } else {
		
	myrobot->link_established=1;
	pthread_mutex_init(&(myrobot->mutex_orders_buffer), NULL);
	
	//Launch the reader thread
	pthread_create( &(myrobot->reader_thread), NULL, (void *(*)(void *))reader_thread_function,myrobot);

	//Send the name of the robot which have been connected;
	
	send(myrobot->connfd, (myrobot->namerobot).c_str(), (myrobot->namerobot).length()+1,0);
	
  }
  myrobot->waiting_for_connection=false; // Don't wait any more ...
 
 
}


void out_khepera_controller (robot & _myrobot) 
	 
{
  
#ifdef _WIN32
  khepera_Out * myrobot =(static_cast<khepera_Out *>(& _myrobot));
#else
  khepera_Out * myrobot =(dynamic_cast<khepera_Out *>(& _myrobot));
#endif
  
  if (myrobot->link_established==0) // if the robot have no controller at this time 
	{
	  if (!(myrobot->waiting_for_connection)) { // and the robot have no thread wating for a connection
		//pthread_attr_init(&attr);
		//Launch a thread which is waiting for a connection
		pthread_create( &(myrobot->waiting_for_connection_thread), NULL, (void *(*)(void *))wait_thread_function,myrobot);
		myrobot->waiting_for_connection=true;
	  }
	  
	}
	
  /*
  else { // This part is used to destroy the waiting thread but i'm not sure
	     // that is necessary (the thread should destroy itself)
	  if (!(myrobot->waiting_for_connection))
		{
		  pthread_cancel(myrobot->waiting_for_connection_thread);
		  pthread_detach(myrobot->waiting_for_connection_thread);
		}
	  
	}
  */
  

  
  

  //Now begins the normal comportement (ie with a controller connected to the server)


  string reply;
  bool understand;
  strstream strstr;

  
  if  (first_zero(myrobot->read_buffer)>0) {
	
	//fputs(myrobot->read_buffer, stdout); std::cout<<std::endl;

	understand=false;
	strstr.clear();
	
	  
	if (strcmp(myrobot->read_buffer,"N")==0) // Active IR sensors values request
	  {
		understand=true;
		strstr<<"n,"<<(int) myrobot->IR(0)<<","<<(int) myrobot->IR(1)<<","<<(int) myrobot->IR(2)<<","<<(int) myrobot->IR(3)<<","<<(int) myrobot->IR(4)<<","<<(int) myrobot->IR(5)<<","<<(int) myrobot->IR(6)<<","<<(int) myrobot->IR(7)<<ends;
	
	  }
	
	if (strcmp(myrobot->read_buffer,"O")==0) // Passive IR sensors values request
	  {
		understand=true;
		strstr<<"i,"<<(int) myrobot->IR_passive(0)<<","<<(int) myrobot->IR_passive(1)<<","<<(int) myrobot->IR_passive(2)<<","<<(int) myrobot->IR_passive(3)<<","<<(int) myrobot->IR_passive(4)<<","<<(int) myrobot->IR_passive(5)<<","<<(int) myrobot->IR_passive(6)<<","<<(int) myrobot->IR_passive(7)<<ends;
			
	  }

	if (strcmp(myrobot->read_buffer,"S")==0) // Simulated Time request
	  {
		understand=true;
		//cout<<simulated_time<<endl;
		strstr<<"s,"<<simulated_time<<ends;
	  }
	
	if ((myrobot->read_buffer)[0]=='D') // Motor Order
	  {
		int lm,rm;
		understand=true;
		sscanf(myrobot->read_buffer,"D,%i,%i",&lm,&rm);

		myrobot->decision.left_motor=((Real)lm+30.0)/60.0; 
		myrobot->decision.right_motor=((Real)rm+30.0)/60.0;

		strstr<<"d"<<ends;
	  }

	
	if (strcmp(myrobot->read_buffer,"O")==0) // "On food" request
	  {
		understand=true;
		//cout<<simulated_time<<endl;
		strstr<<"o,"<<myrobot->on_food<<ends;
	  }


	if (strcmp(myrobot->read_buffer,"G")==0) // "Grab food" request
	  {
		understand=true;
		//cout<<simulated_time<<endl;
		strstr<<"g,"<<myrobot->eat()<<ends;
	  }


	if (strcmp(myrobot->read_buffer,"P")==0) // "Proximity food" request
	  {
		understand=true;
		//cout<<simulated_time<<endl;
		//strstr<<"s,"<<myrobot->eat()<<ends;
		strstr<<"p,";
		vector<Real> foo=myrobot->proximity_food();
		for (unsigned i=0;i<foo.size();i++){ 
		  strstr<<foo[i]<<',';
		}
		strstr<<ends;
	  }


  
	if ((myrobot->read_buffer)[0]=='T') // Turet Order
	  {
		understand=true;
		
		strstr<<"t"<<ends;
	  }
  
	if (!(understand)) // Request have not been understood
	  {
		strstr<<"error : bad request"<<ends;
	  }

	reply=strstr.str();
	if (reply.length()>0)
	  {
		pthread_mutex_lock(&(myrobot->mutex_orders_buffer));
		//Modify the buffer of the robot to remove the resquest we just treated
		myrobot->position_in_buffer-=first_zero(myrobot->read_buffer)+1;
		shift_buffer(myrobot->read_buffer,first_zero(myrobot->read_buffer)+0);
		pthread_mutex_unlock(&(myrobot->mutex_orders_buffer));
				
		//Send the answer
		if ((send(myrobot->connfd, reply.c_str(), reply.length()+1,0))<=0)
		  {
			//Problem of connection
			cout<<"client disconnected"<<endl;
			myrobot->link_established=0;
			myrobot->position_in_buffer=0;
			myrobot->read_buffer[0]='\0';
		  }
	  }
  
  }
  

  /*  
  if (myrobot->crash_obstacle) {cout<<"crash on obstacle"<<endl; }
  if (myrobot->crash_other_robot) {cout<<"crash on robot"<<endl; }
  if (myrobot->crash_obstacle_unfixed) {cout<<"crash on an unfixed object"<<endl; }
  if (myrobot->on_food)  {
	//Detect if robot is on food (food allow to eat)
	if (myrobot->eat()) {cout<<"miam-miam"<<endl;}
	}
  */

};

extern world world_GL;  // this is the world used by the main function and the main Display function for openGL


int main (int argc, char *argv[]) // int argc, char *argv[ ], char *envp[ ] )
{

  int mysocket=MY_DEFAULT_SOCKET;
  int number_of_robots=DEFAULT_NUMBER_OF_ROBOTS;
  string env_name="";
  unsigned sx=DEFAULT_MAIN_WIN_SIZE_X,sy=DEFAULT_MAIN_WIN_SIZE_Y;


  for (int parse=0;parse<argc;parse++)
	{
	  //help
	  if ((((argv[parse])[0]=='-') && ((argv[parse])[1]=='h'))||(((argv[parse])[0]=='-') && ((argv[parse])[1]=='-') && ((argv[parse])[2]=='h') ))
		{
		  cout<<endl;
		  cout<<"Help for WoB server (for Kheperas)"<<endl<<endl;
		  
		  cout<<"-h or --help : Display this message and exit"<<endl;
		  cout<<"-PXXXX : Set the port to use (default 1050)"<<endl;
		  cout<<"-nXX : Set the number of robots to XX"<<endl;
		  cout<<"-eNAME : Set the environment to NAME"<<endl;
		  cout<<"-d800x600: Set the size and the position of the main window (800 by 600 in this example)"<<endl;
		  
		  
		  cout<<endl;
		  exit(0);
		}


	  //Set number of robots
	  if ( ((argv[parse])[0]=='-') && ((argv[parse])[1]=='n'))
		{
		  sscanf(argv[parse],"-n%i",&number_of_robots);
		}

	  //Set port
	  if ( ((argv[parse])[0]=='-') && ((argv[parse])[1]=='P'))
		{
		  sscanf(argv[parse],"-P%i",&mysocket);
		}

	  //Set environment name
	  if ( ((argv[parse])[0]=='-') && ((argv[parse])[1]=='e'))
		{
		  env_name=argv[parse]+2; // To bypass the -e
		  int p = env_name.find(".env");
		  if (p>=0) env_name[p]='\0'; // To remove the .env in the name (if given)
		  
		}

	  //Set the dimension of the main window
	  if ( ((argv[parse])[0]=='-') && ((argv[parse])[1]=='d'))
		{
		  sscanf(argv[parse],"-d%ix%i",&sx,&sy);
		  cout<<sx<<" "<<sy<<endl;
		}
	  

	}
  
  srand(time(NULL)); //random generator initialisation

  if (GL_world_initialisation(argc,argv,sx,sy)==1) {return 1; }//error with OpenGL
  

  
  //Socket initialisation
  struct sockaddr_in  servaddr;
  
  
  if (    (listenfd = socket(AF_INET, SOCK_STREAM, 0)) < 0 ){
	perror("socket error");                     
	return 0;
  }

  bzero(&servaddr, sizeof(servaddr));
  

  servaddr.sin_family     = AF_INET;
  servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  //INADDR_ANY used to allow client on any interface

  servaddr.sin_port       = htons(mysocket);

  // bind links the server's port to the socket filling the internet socket
  // adresse structure
  if (bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0){   
        perror("bind error");                       
		return 0;
  }

    if (listen(listenfd, 5) < 0){
	  // listen converts the socket in listening socket
	  // which connection request will be allowed by the kernel

	  perror("listen error");
	  return 0;
    }

  
  
  //secondly, we add the parameters for the environment and for the robots
  try	
	{

	  //Default environment 
	  const int WIDTH  = 600;
	  const int LENGTH = 1000;
	  environment env0(WIDTH,LENGTH);// The two numbers are the size of the environment (in mm)
	  env0.add_wall("wall0",0.0,0.0,0.0,LENGTH,unsigned(255));
	  env0.add_wall("wall1",0.0,0.0,WIDTH,0.0,unsigned(255));
	  env0.add_wall("wall2",0.0,LENGTH,WIDTH,LENGTH,unsigned(255));
	  env0.add_wall("wall3",WIDTH,0.0,WIDTH,LENGTH,unsigned(255));
	  for (int f=0;f<30;f++)
		{
		  env0.add_food(Math::UnitRandom()*(WIDTH-20)+10,
						Math::UnitRandom()*(LENGTH-20)+10
						);
		}
	
	 
	  // Loading the environment
	  if (env_name!="")
		{
		  env0.load(env_name.c_str());
		}
	  


	  // Now we create a controller using the function previously defined
	  Controller *  ctrl=new Controller (out_khepera_controller);
	  all_the_controllers.add_a_controller("controller_khepera",ctrl);


	  khepera_Out** khepera_box;
	  khepera_box = new khepera_Out* [number_of_robots];

	  int no_robot;
	  string name_r;
	  for (no_robot=0;no_robot<number_of_robots;no_robot++)
		{
		  
		  strstream strstr;
		  strstr <<"robot"<< no_robot <<ends;
		  name_r=strstr.str();
		  
		  khepera_box[no_robot]=new khepera_Out(name_r,all_the_controllers("controller_khepera"));
		}
	  
	  
	  // Now we set the environment of the world
	  world_GL.set_environment(env0);

	  // And we add the robots
	  for (no_robot=0;no_robot<number_of_robots;no_robot++)
		{
		  world_GL.add_robot(*khepera_box[no_robot]);
		}
	  
	 
	  
	  // main loop (only if you whish to use OPENG_GL display)
	  // See Glut Documentation (you will nevet get back from this function)
	  glutMainLoop();
	  
	  return 0;
		
	}
  
  // optionnal gestion of exceptions may help you...
  catch (error & _error)
	
	{
	  _error.what();
	}
  
  return 0;
  
  }
  
#else

#include <stdio.h>
int main()
{
#ifndef HAVE_PTHREAD
  cout<<"pthread library not found. Cannot launch WoB in server mode"<<endl;
#endif

#ifndef HAVE_SOCKET
  cout<<"socket library not found. Cannot launch WoB in server mode"<<endl;
#endif

  return 0;
}

#endif


