//Time-stamp: <2004-03-26 18:52:03 mary>
/*  
 *

 *
 */

//Classics headers
#include <iostream>

//Environment, Robot,  Word and Controllers headers
#include "../../src/heart/simulator.h"

// To use time to initialise Random number generator
#include <time.h>


#define MAX_STORED_STATES 50




class Action
{

};


class Etat
{
public:

  Etat(Real * _IR)
  {
	for (int i = 0;i<8;i++)
	  {
		IR[i]=_IR[i];
	  }
  }

  void display(){
	for (int i = 0;i<8;i++)
	  {
		cout<<IR[i]<<" ";
	  }
	cout<<endl;
  }
  
private:  
  Real IR[8];
};



class Memory
{
public :
  Memory()
  {}
  void add_etat(Real * _IR)
  {
	vector_of_etats.push_back(new Etat(_IR));
	
	if (vector_of_etats.size()>MAX_STORED_STATES)
	  {
		vector_of_etats.erase(vector_of_etats.begin());
	  }
	
  }
  int number_of_etats()
  {
	return vector_of_etats.size();
  }
  
  
  void print_all_etats()
  {
	for (vector<Etat*>::iterator it1=vector_of_etats.begin();it1!=vector_of_etats.end();it1++) 
		  {
			(*it1)->display();
		  }
  }
  ~Memory()
  {
	for (vector<Etat*>::iterator it1=vector_of_etats.begin();it1!=vector_of_etats.end();it1++) 
		  {
			delete (*it1);
		  }
  }
  
private :
  vector<Etat *> vector_of_etats;
  
  vector<Action *> vector_of_actions;
  
};


// definition of our khepera with memory
class khepera_M: public khepera
{
public:
  // here are the 2 standards constructors of khepera - you can modify it but keep in mind that you have to call a constructor of khepera in each of your constructors
   khepera_M(string _namerobot, Controller * _controller_base, Real _radius=27.5) : khepera(_namerobot,_controller_base,_radius)
  {memory=new Memory();}
  khepera_M(string _namerobot, Controller * _controller_base, Real _centerx, Real _centery, Real _direction, Real _radius=27.5) : khepera(_namerobot,_controller_base,_centerx,_centery,_direction,_radius)
  {memory=new Memory();}
 
  void add_etat(Real * _IR)
  {
	memory->add_etat(_IR);
  }
  void print_all_etats()
  {
	memory->print_all_etats();
  }
  int number_of_etats()
  {
	return memory->number_of_etats();
  }
  
  ~khepera_M() // destructor
  { //add here the destructors of the things that you added to your khepera
	delete memory;
	
	// you NEVER need to modify the destructor beyond this point (it is a call to the destructor of khepera)
	Partial_self_destruct();
  }
  
  
private:
  class Memory *  memory;
};




void simple_khepera_controller (robot & _myrobot) 
	 
{
  
#ifdef _WIN32
  khepera_M * myrobot =(static_cast<khepera_M *>(& _myrobot));
#else
  khepera_M * myrobot =(dynamic_cast<khepera_M *>(& _myrobot));
#endif

  Real IR[8];
  for (int i=0;i<8;i++){
	IR[i]=myrobot->IR(i);
  }

  myrobot->add_etat(IR);
  if (myrobot->number_of_etats()==20)
	{
	  myrobot->print_all_etats();
	}
  
  
  if (myrobot->crash_obstacle) {cout<<"crash on obstacle"<<endl; }
  if (myrobot->crash_other_robot) {cout<<"crash on robot"<<endl; }
  if (myrobot->crash_obstacle_unfixed) {cout<<"crash on an unfixed object"<<endl; }
  if (myrobot->on_food)  {
	//Detect if robot is on food (food allow to eat)
	if (myrobot->eat()) {cout<<"miam-miam"<<endl;}
  }
  
  if ((myrobot->IR(2) < 20) && (myrobot->IR(3) < 20) &&!(myrobot->crash()))  //If the front sensors are not activated and no choc
		{
		  myrobot->decision.left_motor=1.0; 
		  myrobot->decision.right_motor=1.0; // the robot goes forward at maximal speed 
		}
  
	  else  //If the front sensors are activated
		{
		  myrobot->decision.left_motor=1.0; 
		  myrobot->decision.right_motor=0.0; // the robot turn on the right at maximal speed
		}
};

extern world world_GL;  // this is the world used by the main function and the main Display function for openGL


int main (int argc, char *argv[]) // int argc, char *argv[ ], char *envp[ ] )
{
  srand(time(NULL)); //random generator initialisation

  if (GL_world_initialisation(argc,argv)==1) {return 1; }//error with OpenGL
  

  
  //secondly, we add the parameters for the environment and for the robots
  try	
	{
	  const int WIDTH  = 600;
	  const int LENGTH = 1000;
	  
	  
      environment env0(WIDTH,LENGTH);// The two numbers are the size of the environment (in mm)


      env0.add_wall("wall0",0.0,0.0,0.0,LENGTH,unsigned(255));
      //env0.add_wall("wall1",0.0,0.0,WIDTH,0.0,unsigned(255));
      //env0.add_wall("wall2",0.0,LENGTH,WIDTH,LENGTH,unsigned(255));
      //env0.add_wall("wall3",WIDTH,0.0,WIDTH,LENGTH,unsigned(255));
      
	  // save way to add two obstacles (there is a method add_cylinder too)
      //env0.add_cylinder_unfixed("cylinder_unfixed0",200.0,150.0,25.0,unsigned(255)); //this obstacle is unfixed (can move)
	  //env0.add_bloc("bloc1",400.0,400.0,100.0,0.0,0.0,100.0,unsigned(255));

	  
	  //env0.add_food(100,300);
	  //env0.add_food(100,200);
	  
	  
	  // You can make a save of your environment :
	  // env0.save("test_env_save.sav");
	  //
	  // And you can load it using this constructor
	  // environment env1("test_env_sav.sav");


	  // Now we create a controller using the function previously defined
	  Controller *  ctrl=new Controller (simple_khepera_controller);

	  // You can declare the controller you want to use and give them a name
	  // This is optionnal in a normal use (except if you plan to use EO)
	  all_the_controllers.add_a_controller("controller_khepera_simple",ctrl);
	  
	  
	  khepera_M myfirstkhepera ("first",all_the_controllers("controller_khepera_simple"),100.0,300.0,2*M_PI/2);
	  // This robot have a fixed start and direction (direction is given in radian M_PI/2 is North)

	  //khepera mysecondkhepera ("second",all_the_controllers("controller_khepera_simple")); // This robot have a random start


	  // Now we set the environment of the world
	  world_GL.set_environment(env0);
	  // And we add the robots 
	  world_GL.add_robot(myfirstkhepera);
	  //world_GL.add_robot(mysecondkhepera); 

	 
	  
	  // main loop (only if you whish to use OPENG_GL display)
	  // See Glut Documentation (you will nevet get back from this function)
	  glutMainLoop();
	  
	  return 0;
		
	}
  
  // optionnal gestion of exceptions may help you...
  catch (error & _error)
	
	{
	  _error.what();
	}
  
  return 0;
  
  }
  



