#include <vector>
#include "global.h"




  //Neural Network used in backprop function is coded like this way: sample sinus function:
  /**

  Sample for a network 1-5-1 , 1 input, 5 hidden neurons and 1 output

  ****         ****
  *  *         *  *                    Note : the bias is introduced on the last layer to simplify the code of network computations
  ****         ****
  bias         output to approximate sinus
  |      
  |
  _____________|________________________
  |      |      |      |      |      |
  ****   ****   ****   ****   ****   ****
  *  *   *  *   *  *   *  *   *  *   *  *                    
  ****   ****   ****   ****   ****   ****
  bias     |      |      |      |      |
  __|______|______|______|______|______|___
  |
  ________|________
  |            |  
  ****         ****  
  *  *         *  *  
  ****         ****   
  bias         input representsing x in sinus(x)


  */



//_alpha for sigmoid

void backprop (vector<Real> & _desired_output, vector<Real> & _real_output, Real _learning_rate, 
	       Real _inertial_rate, Real _alpha, vector<Real> & _poids,
	       vector <Real> & _recurrenthidden2, vector<int> & _debutCouche, int _nbCouche,
	       vector <int> & _lesCouches, vector <Real> & _delta, vector<int> _debutConnection, int _max_layer)
  
{

  //First, we compute the gradient of the error with respect to the activation a_i, gradient_a[i]

  int nbSortie = _desired_output.size();
  vector<Real> gradient_a(nbSortie);
  vector<Real> gradient_a_provi(_max_layer);
  int i,j;
  
  for (i=1;i<nbSortie;i++)
    {
            gradient_a[i]=-2*((_desired_output[i-1]+1)/2.0-_real_output[i])*_alpha*(_recurrenthidden2[_debutCouche[_nbCouche-1]+i]*(1.0-_recurrenthidden2[_debutCouche[_nbCouche-1]+i]));
    }


  //Weights-relying-output_layer modification 

  for (i=1;i<nbSortie;i++)  //We have the bias neuron at the index 0
    {
      for (j=0;j<_lesCouches[_nbCouche-2];j++) //The bias neuron contributes to the modification of the last output
	{
	  //_Delta modification   //      

	  _delta[_debutConnection[_nbCouche-2]+(i-1)*_lesCouches[_nbCouche-2]+j]=-_learning_rate*gradient_a[i]*(_recurrenthidden2[_debutCouche[_nbCouche-2]+j])+_inertial_rate*_delta[_debutConnection[_nbCouche-2]+(i-1)*_lesCouches[_nbCouche-2]+j];
	
	  _poids[_debutConnection[_nbCouche-2]+(i-1)*_lesCouches[_nbCouche-2]+j]+=_delta[_debutConnection[_nbCouche-2]+(i-1)*_lesCouches[_nbCouche-2]+j];

	  //	  tab_verif[_debutConnection[_nbCouche-2]+(i-1)*_lesCouches[_nbCouche-2]+j]++;

	}

      
    }

  Real gradienti;
      
  //We compute gratient wrt weights to all other layers

  for (int c=1;c<=_nbCouche-2;c++)
    {
      for (i=1;i<_lesCouches[_nbCouche-c-1];i++) //bottom layer   //We begin at i=1 because it is useless to compute gradient wrt a0 because the bias neuron is not relied to bottom layer with weights, so no weights to modifiy
	{

	  gradienti=0.0;
	  for (int k=1;k<_lesCouches[_nbCouche-c];k++)  //top Layer
	    {	       
	      gradienti+=(_recurrenthidden2[_debutCouche[_nbCouche-c-1]+i]*_alpha*(1.0-_recurrenthidden2[_debutCouche[_nbCouche-c-1]+i]))*gradient_a[k]*_poids[_debutConnection[_nbCouche-c-1]+(k-1)*(_lesCouches[_nbCouche-c-1])+i];
	    }
	  gradient_a_provi[i]=gradienti;

	  //Modification of the weights

	  for (j=0;j<_lesCouches[_nbCouche-c-2];j++)
	    {	

_delta[_debutConnection[_nbCouche-c-2]+(i-1)*(_lesCouches[_nbCouche-c-2])+j]=-_learning_rate*gradienti*_recurrenthidden2[_debutCouche[_nbCouche-c-2]+j]+_inertial_rate*_delta[_debutConnection[_nbCouche-c-2]+(i-1)*(_lesCouches[_nbCouche-c-2])+j];
																					 _poids[_debutConnection[_nbCouche-c-2]+(i-1)*(_lesCouches[_nbCouche-c-2])+j]+=_delta[_debutConnection[_nbCouche-c-2]+(i-1)*(_lesCouches[_nbCouche-c-2])+j];
																					 
	    }
	  
	  
	}
      for (int l=1;l<_lesCouches[_nbCouche-c-1];l++)
	{
	  gradient_a[l]=gradient_a_provi[l];
	}
      
    }


 
}


