/** -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

The above line is usefulin Emacs-like editors
 */

/*
Template for simple quadratic crossover operators
=================================================

Quadratic crossover operators modify the both genotypes
*/

#ifndef eoRNQuadCrossover_H
#define eoRNQuadCrossover_H

#include <eoOp.h>

/** 
 *  Always write a comment in this format before class definition
 *  if you want the class to be documented by Doxygen
 *
 * THere is NO ASSUMPTION on the class GenoypeT.
 * In particular, it does not need to derive from EO
 */
template<class GenotypeT> 
class eoRNQuadCrossover: public eoQuadOp<GenotypeT>
{
public:
  /**
   * Ctor - no requirement
   */
  eoRNQuadCrossover(string _num="") : cName("eoRNQuadCrossover"+_num)
  {}

  /// The class name. Used to display statistics
  string className() const { return cName; }

  /**
   * eoQuad crossover - modifies both parents
   * @param _genotype1 The first parent
   * @param _genotype2 The second parent
   */
  bool operator()(GenotypeT & _genotype1, GenotypeT & _genotype2) 
  {
    //code provisoire pour voir si ca apporte quelquechose
   
     for (unsigned i = 0; i <_genotype1.number_of_robots; i++)
       {
    vector<double> provivector1,provivector2;

    unsigned taille = _genotype1.robots[i].archi->NbPoids();
    unsigned crossoverpoint = rng.random(taille);
    bool hasChanged = false;
    
    for (unsigned j=crossoverpoint;j<taille;j++)
      {
	
	//	if (_genotype1.robots[i].poids[j] != _genotype2.robots[i].poids[j])
	// {
	    double tmp = _genotype1.robots[i].poids[j];
	    _genotype1.robots[i].poids[j] = _genotype2.robots[i].poids[j];
	    _genotype2.robots[i].poids[j] = tmp;
	    hasChanged = true;
	    // }

 }
       }
 
    return true;
  }

private:
  string cName;
};

#endif
