// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

//-----------------------------------------------------------------------------
// make_genotype.h
// (c) Maarten Keijzer, Marc Schoenauer and GeNeura Team, 2001
/* 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: todos@geneura.ugr.es, http://geneura.ugr.es
             Marc.Schoenauer@polytechnique.fr
             mkeijzer@dhi.dk
 */
//-----------------------------------------------------------------------------

#ifndef _make_genotype_h
#define _make_genotype_h

#ifndef DONT_USE_EO

  // also need the parser and param includes
#include <utils/eoParser.h>
#include <utils/eoState.h>

#include <eoRN.h>
#include <eoRNInit.h>

#include "world.h"


//template <class EOT>
eoRNInit<eoRN<Real> > & do_make_genotype(eoParser& _parser, eoState& _state, world & _world_eo)
{

  typedef eoRN<Real> EOT;

  // read any useful parameter here from the parser 
  // the param itself will belong to the parser (as far as memory is crm oncerned)

  //    paramType & param = _parser.createParam(deafultValue, "Keyword", "Comment to appear in help and status", 'c',"Section of status file").value();

  // Then built the initializer - a pointer, stored in the eoState
  eoRNInit<EOT>* init =  new eoRNInit<EOT>(_parser, _world_eo);
  // store in state
  _state.storeFunctor(init);
  // and return a reference
  return *init;
}

#endif
#endif
