#include "global.h"
//#include <iostream.h>
#include <vector>
#include <math.h>
#include <sstream>
#include "environment.h"
//#include "Real.h"
#include "world.h"


#ifndef DONT_USE_EO
#include <eo>
#include "map_fitness.h"
#include "param_eo.h"

extern param_eo eo1;
extern world world_GL;

void check_param_environment (eoParser& _parser,environment & _env)

{
 unsigned  nobstacles = _parser.createParam(unsigned(4), "walls", "Number of walls", '\0', "Problem Environment").value();

  //nobstacles = 4


 Real maxx=0.0;
 Real maxy=0.0;

  for (unsigned i=0; i < nobstacles; i++)
    { 
      double obstacles[5];
      ostringstream paramName; // ostrstream os(paramName);
      paramName << "wall" << i ; //os << "connexion" << i << ends;
      eoValueParam<eoParamParamType>& connParam = _parser.createParam( eoParamParamType("(0.0,400.0,600.0,400.0,255.0)"),paramName.str(), "Definition for wall", '\0', "Problem Environment"); //paramName.s_str()
      eoParamParamType & ptArchi2 = connParam.value();
      vector<string> & conns = ptArchi2.second;
      if (conns.size() != 5)
	throw runtime_error("Invalid nb of parameters for walls, haven't you forgotten the color at the end?");
      obstacles[0] = atoi(conns[0].c_str());
      if ( obstacles[0] > maxx) maxx=obstacles[0];
      obstacles[1] = atoi(conns[1].c_str());
      if ( obstacles[1] > maxy) maxy=obstacles[1];
      obstacles[2] = atoi(conns[2].c_str());
      if ( obstacles[2] > maxx) maxx=obstacles[2];
      obstacles[3] = atoi(conns[3].c_str());
      if ( obstacles[3] > maxy) maxy=obstacles[3];
      obstacles[4] = atoi(conns[4].c_str());

      _env.add_wall (paramName.str(),obstacles[0],obstacles[1],obstacles[2],obstacles[3],unsigned (obstacles[4]));
    }


 _env.change_dimension(maxx,maxy); 

 // exit(1);
 unsigned  ncylinders_unfixed = _parser.createParam(unsigned(1), "cylinders_unfixed", 
"Number of cylinders unfixed", '\0', "Problem Environment").value();

  //nobstacles = 4
  for (unsigned i=0; i < ncylinders_unfixed; i++)
    { 
      Real obstacles[4];
      ostringstream paramName; // ostrstream os(paramName);
      paramName << "cylinder_unfixed" << i ; //os << "connexion" << i << ends;
      eoValueParam<eoParamParamType>& connParam = _parser.createParam( eoParamParamType("(200.0,150.0,25.0,255)"),paramName.str(), "Definition for cylinders_unfixed", '\0', "Problem Environment"); //paramName.s_str()
	
      eoParamParamType & ptArchi2 = connParam.value();
      vector<string> & conns = ptArchi2.second;
      if (conns.size() != 4)
	throw runtime_error("Invalid nb of parameters for cylinders_unfixed, haven't you forgotten the color at the end?");

      obstacles[0] = atoi(conns[0].c_str());
      obstacles[1] = atoi(conns[1].c_str());
      obstacles[2] = atoi(conns[2].c_str());
      obstacles[3] = atoi(conns[3].c_str());

      _env.add_cylinder_unfixed (paramName.str(),obstacles[0],obstacles[1],obstacles[2],unsigned(obstacles[3]));

    }

unsigned  nblocks = _parser.createParam(unsigned(4), "blocks", "Number of blocks", '\0', "Problem Environment").value();

  for (unsigned i=0; i < nblocks; i++)
    { 
      double obstacles[7];
      ostringstream paramName; // ostrstream os(paramName);
      paramName << "block" << i ; //os << "connexion" << i << ends;
      eoValueParam<eoParamParamType>& connParam = _parser.createParam( eoParamParamType("(400.0,400.0,100.0,0.0,0.0,100.0,255.0)"),paramName.str(), "Definition for block", '\0', "Problem Environment"); //paramName.s_str()
      eoParamParamType & ptArchi2 = connParam.value();
      vector<string> & conns = ptArchi2.second;
      if (conns.size() != 7)
	throw runtime_error("Invalid nb of parameters for blocks, haven't you forgotten the color at the end?");
      obstacles[0] = atoi(conns[0].c_str());
      obstacles[1] = atoi(conns[1].c_str());
      obstacles[2] = atoi(conns[2].c_str());
      obstacles[3] = atoi(conns[3].c_str());
      obstacles[4] = atoi(conns[4].c_str());
      obstacles[5] = atoi(conns[5].c_str());
      obstacles[6] = atoi(conns[6].c_str());
      
      _env.add_bloc (paramName.str(),obstacles[0],obstacles[1],obstacles[2],obstacles[3],obstacles[4],obstacles[5],unsigned (obstacles[6]));
    }

unsigned  nlights = _parser.createParam(unsigned(4), "lights", "Number of lights", '\0', "Problem Environment").value();

 
 for (unsigned i=0; i < nlights; i++)
    { 
      Real obstacles[3];
      ostringstream paramName; // ostrstream os(paramName);
      paramName << "light" << i ; //os << "connexion" << i << ends;
      eoValueParam<eoParamParamType>& connParam = _parser.createParam( eoParamParamType("(200.0,150.0,25)"),paramName.str(), "Definition for lights x, y, power", '\0', "Problem Environment"); //paramName.s_str()
	
      eoParamParamType & ptArchi2 = connParam.value();
      vector<string> & conns = ptArchi2.second;
      if (conns.size() != 3)
	throw runtime_error("Invalid nb of parameters for cylinders_unfixed, haven't you forgotten the color at the end?");

      obstacles[0] = atoi(conns[0].c_str());
      obstacles[1] = atoi(conns[1].c_str());
      obstacles[2] = atoi(conns[2].c_str());
     

      _env. add_light (paramName.str(),obstacles[0],obstacles[1],obstacles[2]);

    }

}


void check_param_problem (map_fitnesses & _all_fitness_available, world & _world_eo, eoParser & _parser)
{

  //ffitness = _parser.createParam(int(1), "Fitness", "Number of fitness", '\0', "Problem").value();

string & ptStringArchi = _parser.createParam(string("explor"), "Fitness", "class controller", '\0', "Genotype Initialization").value();
	   
unsigned numberepochs =  _parser.createParam(int(10), "Epochs", "Number of epochs", '\0', "Problem").value();

 eo1.number_of_epochs=numberepochs;

unsigned sweeps = _parser.createParam(int(500), "Sweeps", "Number of sweeps", '\0', "Problem").value();

 eo1.number_of_cycles=sweeps; 

 eo1.compute_fitness_per_cycle=_all_fitness_available.map_all_fitnesses[ptStringArchi];

 if (! eo1.compute_fitness_per_cycle )
   {
     string stmp = "Invalid fitness " + ptStringArchi;
     // les exceptions et OpenGL n'ont pas l'air de s'entendre
     cout << stmp << endl ;
     throw runtime_error(stmp.c_str());
   }
 
 // eo1.compute_fitness_per_cycle=_all_fitness_available.map_all_fitnesses[ptStringArchi];

//timelaps = _parser.createParam(int(2), "timelaps", "OpenGL parameters, change it only if you are an expert", '\0', "Problem").value();

//sensornoise = _parser.createParam(float(0.05), "sensornoise", "Random sensor noise added to sensors", '\0', "Problem").value();

//stop_when_crash = _parser.createParam(int(1), "stop_when_crash", "1 == go directly to next epoch after a crash", '\0', "Problem").value();


//robotnumber = _parser.createParam(int(1), "robotnumber", "Number of robots", '\0', "Problem").value();

//realmode = _parser.createParam(int(1), "realmode", "1, experiment launched in real mode", '\0', "Problem").value();

}
#endif
